function y=fun_estimation(adj)

%********************************
% estimating missing population
%********************************

parameter

%***********
% dynamics
%***********

% urban
pop_u_f_t(:,1)=pop2000(:,3)*adj; % female
pop_u_m_t(:,1)=pop2000(:,1)*adj-pop2000(:,3)*adj; % male
% rural
pop_r_f_t(:,1)=pop2000(:,4)*adj; % female
pop_r_m_t(:,1)=pop2000(:,2)*adj-pop2000(:,4)*adj; % male

% dynamics
for t=2:year_end-year_ini+1
    
    % urban
    % existing (using mortality rates)
    for i=2:age_max-age_min+1
        pop_u_m_t(i,t)=pop_u_m_t(i-1,t-1)*(1-mort2000(i-1,1)/1000); % male
        pop_u_f_t(i,t)=pop_u_f_t(i-1,t-1)*(1-mort2000(i-1,2)/1000); % female
    end
    % urban newly born
    nb_u_t(t)=sum(pop_u_f_t(fert_min:fert_max,t).*fert2000(:,1)/1000);
    % total population
    pop_u_f_t(1,t)=nb_u_t(t)*1/(sex_birth_u+1); % female
    pop_u_m_t(1,t)=nb_u_t(t)-pop_u_f_t(1,t); % male
    
    % rural
    % existing (using mortality rates)
    for i=2:age_max-age_min+1
        pop_r_m_t(i,t)=pop_r_m_t(i-1,t-1)*(1-mort2000(i-1,3)/1000); % male
        pop_r_f_t(i,t)=pop_r_f_t(i-1,t-1)*(1-mort2000(i-1,4)/1000); % female
    end
    % rural newly born
    nb_r_t(t)=sum(pop_r_f_t(fert_min:fert_max,t).*fert2000(:,2)/1000);
    % total population
    pop_r_f_t(1,t)=nb_r_t(t)*1/(sex_birth_u+1); % female
    pop_r_m_t(1,t)=nb_r_t(t)-pop_r_f_t(1,t); % male
    
end

% total population
pop_u_t=pop_u_f_t+pop_u_m_t;
pop_r_t=pop_r_f_t+pop_r_m_t;

% aggregation
pop_t=(pop_u_t+pop_r_t);

% residual
y=sum(pop2005(:,1)+pop2005(:,2))-sum(pop_t(:,year_end-year_ini+1));