
% assume low fertility rate as Zeng 2007 scenario 1 forever


clear
close all

parameter

%% ------------------- 0. Data -------------------

% ages 
age_min=0;
age_ini=22;
age_max=100;
age_end=age_max-age_ini+1;
% age_end=age_max-age_min+1;
time_max=800;

% initial year
year_ini=2000;
t_2005=2005-year_ini+1;
t_2020=2020-year_ini+1;
t_2050=2050-year_ini+1;
t_2080=2080-year_ini+1;
t_2100=2100-year_ini+1;

% transition year
year_tra=2100;
t_tra=year_tra-year_ini+1;

% population reform, increase fertility rate
year_popreform=2013;
t_popreform=year_popreform-year_ini+1;

% ending year
year_end=year_ini+time_max-1+age_max-1;
t_end=year_end-year_ini+1;






% mortality rate and life expectation
% from zeng yi 2005
% urban male: 72@2000, 74@2020, 77@2050
% urban female: 76@2000, 78@2020, 81@2050
% rural male: 68@2000, 70.2@2020, 73.5@2050
% rural female: 72@2000, 74.2@2020, 77.5@2050
life_2000=[72,76,68,72];
life_2020=[74,78,70.2,74.2];
life_2050=[77,81,73.5,77.5];
% sex difference still 4
life_2080=[79.9,83.9,79.9,83.9];


mort_2000=mort2000;
mort_2005=mort2005;

% 2020
for i=1:4
    options=optimset('Display','off');
    fun_life_ratio=@(ratio_life) fun_life(ratio_life,squeeze(mort2000(:,i))/1000)-life_2020(i);
    ratio_2020(i)=fsolve(fun_life_ratio, 1,options);
    mort_2020(:,i)=mort2000(:,i)*ratio_2020(i);
end
for i=1:4
    fun_life_ratio=@(ratio_life) fun_life(ratio_life,squeeze(mort2000(:,i))/1000)-life_2050(i);
    ratio_2050(i)=fsolve(fun_life_ratio, 1,options);
    mort_2050(:,i)=mort2000(:,i)*ratio_2050(i);
end
for i=1:4
    fun_life_ratio=@(ratio_life) fun_life(ratio_life,squeeze(mort2000(:,i))/1000)-life_2080(i);
    ratio_2080(i)=fsolve(fun_life_ratio, 1,options);
    mort_2080(:,i)=mort2000(:,i)*ratio_2080(i);
end

index_temp=1; % 1, correct for 2005 error
if index_temp==0
    for t=1:t_2005
        mort_t(:,:,t)=mort2000+(t-1)/(t_2005-1)*(mort2005-mort2000);
    end
    for t=t_2005+1:t_2020
        mort_t(:,:,t)=mort2005+(t-t_2005)/(t_2020-t_2005)*(mort_2020-mort2005);
    end
elseif index_temp==1
    for t=1:t_2020
        mort_t(:,:,t)=mort2000+(t-1)/(t_2020-1)*(mort_2020-mort2000);
    end
end
for t=t_2020+1:t_2050
    mort_t(:,:,t)=mort_2020+(t-t_2020)/(t_2050-t_2020)*(mort_2050-mort_2020);
end
for t=t_2050+1:t_2080
    mort_t(:,:,t)=mort_2050+(t-t_2050)/(t_2080-t_2050)*(mort_2080-mort_2050);
end
for t=t_2080+1:t_end
    mort_t(:,:,t)=mort_2080;
end

% variables
fert_constant=2.078;
case_fert=1.3;
% case_fert=6;
if case_fert==1
    fert_u_reform=1.2;    fert_r_reform=1.98;
    fert_u_end=fert_u_reform; fert_r_end=fert_r_reform; 
elseif case_fert==1.2; % zengyi 1, increase to 2.086 from 2050 to 2100
    fert_u_reform=1.2;    fert_r_reform=1.98;
    fert_u_end=fert_constant; fert_r_end=fert_constant; 
elseif case_fert==1.3; % zengyi 1, no increase to SS population
    fert_u_reform=1.2;    fert_r_reform=1.98;
    fert_u_end=fert_u_reform; fert_r_end=fert_r_reform; 
elseif   case_fert==2 % ZengYi 2
    fert_u_reform=1.8;    fert_r_reform=1.98;
    fert_u_end=fert_u_reform; fert_r_end=fert_r_reform; 
elseif case_fert==2.2; % zengyi 2, increase to 2.086 from 2050 to 2100
    fert_u_reform=1.8;    fert_r_reform=1.98;
    fert_u_end=fert_constant; fert_r_end=fert_constant; 
elseif case_fert==4
    fert_u_reform=1.8;    fert_r_reform=2.27;
    fert_u_end=fert_u_reform; fert_r_end=fert_r_reform; 
elseif case_fert==5
    fert_u_reform=fert_constant;    fert_r_reform=fert_constant;
    fert_u_end=fert_u_reform; fert_end=fert_r_reform; 

elseif case_fert==6; % 1.8 in Chen and Liu
    fert_u_reform=1.8;    fert_r_reform=1.8;
    fert_u_end=fert_u_reform; fert_r_end=fert_r_reform; 
end


% fertility
% from zengyi
fert_total_2000=[1.15,1.90];
fert_2000(:,1)=fert2000(:,1)*fert_total_2000(1)*1000/sum(fert2000(:,1));
fert_2000(:,2)=fert2000(:,2)*fert_total_2000(2)*1000/sum(fert2000(:,2));
fert_2005=fert2005;
fert_total_reform=[fert_u_reform, fert_r_reform]; 
fert_reform(:,1)=fert_2000(:,1)*fert_total_reform(1)*1000/sum(fert_2000(:,1));
fert_reform(:,2)=fert_2000(:,2)*fert_total_reform(2)*1000/sum(fert_2000(:,2));

if case_fert==1.2 % ZengYi 1, fertility constant
    fert_2005=fert_reform;
end

fert_total_end=[fert_u_end, fert_r_end];
fert_end(:,1)=fert_reform(:,1)*fert_total_end(1)*1000/sum(fert_reform(:,1));
fert_end(:,2)=fert_reform(:,2)*fert_total_end(2)*1000/sum(fert_reform(:,2));

for t=1:t_2005
    fert_t(:,:,t)=fert_2000+(t-1)/(t_2005-1)*(fert_2005-fert_2000);
end
for t=t_2005+1:t_popreform-1
%     fert_t(:,:,t)=fert_2005+(t-t_2005)/(t_popreform-t_2005)*(fert_reform-fert_2005);
    fert_t(:,:,t)=fert_2005;
end
for t=t_popreform:t_2050
    fert_t(:,:,t)=fert_reform;
end
for t=t_2050:t_2100
    fert_t(:,:,t)=fert_reform+(t-t_2050)/(t_2100-t_2050)*(fert_end-fert_reform);
end
for t=t_2100:t_end
    fert_t(:,:,t)=fert_end;
end


% sex ratio at birth
% sex_birth_u_raw=1.15;
% sex_birth_r_raw=1.21;
% zeng yi 2006
sex_birth_u_raw=1.142;
sex_birth_r_raw=1.187;
sex_birth_u_zengyi3=1.05;
sex_birth_r_zengyi3=1.06;
 
% sex
t_2030=2030-year_ini+1;
for t=1:t_2030
    sex_birth_u_t(t)=sex_birth_u_raw+(t-1)/(t_2030-1)*(sex_birth_u_zengyi3-sex_birth_u_raw);
    sex_birth_r_t(t)=sex_birth_r_raw+(t-1)/(t_2030-1)*(sex_birth_r_zengyi3-sex_birth_r_raw);
end
for t=t_2030+1:t_end
     sex_birth_u_t(t)=sex_birth_u_zengyi3;
     sex_birth_r_t(t)=sex_birth_r_zengyi3;
end 



%% --------------- 1. Without Migration ------------------
% urban
pop_u_f_t(:,1)=pop2000(:,3); % female
pop_u_m_t(:,1)=pop2000(:,1)-pop2000(:,3); % male
% rural
pop_r_f_t(:,1)=pop2000(:,4); % female
pop_r_m_t(:,1)=pop2000(:,2)-pop2000(:,4); % male



% migration
mig_index=1; % 0 shutting down migration


% dynamics
for t=2:year_end-year_ini+1

    % urban
    % existing (using mortality rates)
    for i=2:age_max-age_min+1
        pop_u_m_t(i,t)=pop_u_m_t(i-1,t-1)*(1-mort_t(i-1,1,t)/1000); % male
        pop_u_f_t(i,t)=pop_u_f_t(i-1,t-1)*(1-mort_t(i-1,2,t)/1000); % female
        % from this equation, it looks like that mort(i) is the mortality
        % rate of age group i to age i+1, whose age is i-1
        
    end
    % urban newly born
    nb_u_t(t)=sum(pop_u_f_t(fert_min:fert_max,t).*fert_t(:,1,t)/1000);
    % total population
    pop_u_f_t(1,t)=nb_u_t(t)*1/(sex_birth_u_t(t)+1); % female
    pop_u_m_t(1,t)=nb_u_t(t)-pop_u_f_t(1,t); % male
    
    % rural
    % existing (using mortality rates)
    for i=2:age_max-age_min+1
        pop_r_m_t(i,t)=pop_r_m_t(i-1,t-1)*(1-mort_t(i-1,3,t)/1000); % male
        pop_r_f_t(i,t)=pop_r_f_t(i-1,t-1)*(1-mort_t(i-1,4,t)/1000); % female
        
    end
    % rural newly born
    nb_r_t(t)=sum(pop_r_f_t(fert_min:fert_max,t).*fert_t(:,2,t)/1000);
    % total population
    pop_r_f_t(1,t)=nb_r_t(t)*1/(sex_birth_r_t(t)+1); % female
    pop_r_m_t(1,t)=nb_r_t(t)-pop_r_f_t(1,t); % male
    
end

% total population
pop_u_t=pop_u_f_t+pop_u_m_t;
pop_r_t=pop_r_f_t+pop_r_m_t;


% aggregation
pop_t=pop_u_t+pop_r_t;

% time series
for t=1:year_end-year_ini+1
    pop_u_t_sum(t)=sum(pop_u_t(:,t));
    pop_r_t_sum(t)=sum(pop_r_t(:,t));
    pop_t_sum(t)=sum(pop_t(:,t));
end

%% ------------------ 2. With Migration ---------------

% load data_migration

% the rate that michael gets
load('../Demography1_MigrationProjection/data_migration','mig_distribution', 'mig_rate_f_sum', 'mig_rate_m_sum', 'mig_rate', 'mig_rate_f', 'mig_rate_m', 'mig_rate_young', 'mig_rate_f_young', 'mig_rate_m_young')
% truncate 10-50
age_mig_min=10;
age_mig_max=50;
mig_rate_m(1:age_mig_min+1)=0; mig_rate_m(age_mig_max+2:age_max+1)=0;
mig_rate_f(1:age_mig_min+1)=0; mig_rate_f(age_mig_max+2:age_max+1)=0;
mig_rate_sum=sum(pop_r_f_t(1:age_max+1,1).*mig_rate_f(1:age_max+1)+pop_r_m_t(1:age_max+1,1).*mig_rate_m(1:age_max+1))/sum(pop_r_f_t(1:age_max+1,1)+pop_r_m_t(1:age_max+1,1));
mig_rate_target=0.023;
mig_rate_m=mig_rate_m*mig_rate_target/mig_rate_sum;
mig_rate_f=mig_rate_f*mig_rate_target/mig_rate_sum;
mig_rate_sum=sum(pop_r_f_t(1:age_max+1,1).*mig_rate_f(1:age_max+1)+pop_r_m_t(1:age_max+1,1).*mig_rate_m(1:age_max+1))/sum(pop_r_f_t(1:age_max+1,1)+pop_r_m_t(1:age_max+1,1));

case_mig=1; % 1: age-specific migration 2: total migration rate 3: adjusted total migration rate
% adjust mig_age_min/max
% mig_age_min=15;
% mig_age_max=50;

% initial 
pop_u_t_mig(:,1)=pop_u_t(:,1);
pop_r_t_mig(:,1)=pop_r_t(:,1);
pop_u_t_mig_sum(1)=sum(pop_u_t_mig(:,1));
pop_r_t_mig_sum(1)=sum(pop_r_t_mig(:,1));

% initial by gender
pop_u_f_t_mig(:,1)=pop_u_f_t(:,1);
pop_u_m_t_mig(:,1)=pop_u_m_t(:,1);
pop_r_f_t_mig(:,1)=pop_r_f_t(:,1);
pop_r_m_t_mig(:,1)=pop_r_m_t(:,1);
pop_u_f_t_mig_sum(1)=sum(pop_u_f_t_mig(:,1));
pop_u_m_t_mig_sum(1)=sum(pop_u_m_t_mig(:,1));
pop_r_f_t_mig_sum(1)=sum(pop_r_f_t_mig(:,1));
pop_r_m_t_mig_sum(1)=sum(pop_r_m_t_mig(:,1));



% time series
for t=2:t_tra
    mig_rate_m_t(:,t)=mig_rate_m;
    mig_rate_f_t(:,t)=mig_rate_f;
end
for t=t_tra+1:t_end
    mig_rate_m_t(:,t)=0;
    mig_rate_f_t(:,t)=0;
end
    
% migrants to urban
        
    
for t=2:t_end
    age_nomig=age_max;
    
    mig_f_t_total(t)=sum(pop_r_f_t_mig(1:age_max+1,t-1).*mig_rate_f_t(1:age_max+1,t-1));
    mig_m_t_total(t)=sum(pop_r_m_t_mig(1:age_max+1,t-1).*mig_rate_m_t(1:age_max+1,t-1));
    % urban
    % existing (using mortality rates)
    for i=2:age_max-age_min+1
        pop_u_m_t_mig(i,t)=pop_u_m_t_mig(i-1,t-1)*(1-mort_t(i-1,1,t)/1000); % male
        pop_u_f_t_mig(i,t)=pop_u_f_t_mig(i-1,t-1)*(1-mort_t(i-1,2,t)/1000); % female
    end
    % urban newly born
    nb_u_t_mig(t)=sum(pop_u_f_t_mig(fert_min:fert_max,t).*fert_t(:,1,t)/1000);
    % total population
    % all new born in the urban area are original
    pop_u_f_t_mig(1,t)=nb_u_t_mig(t)*1/(sex_birth_u_t(t)+1); % female
    pop_u_m_t_mig(1,t)=nb_u_t_mig(t)-pop_u_f_t_mig(1,t); % male
        
    % rural
    % existing (using mortality rates)
    for i=2:age_max-age_min+1
        pop_r_m_t_mig(i,t)=pop_r_m_t_mig(i-1,t-1)*(1-mort_t(i-1,3,t)/1000); % male
        pop_r_f_t_mig(i,t)=pop_r_f_t_mig(i-1,t-1)*(1-mort_t(i-1,4,t)/1000); % female        
    end
    % rural newly born
    nb_r_t_mig(t)=sum(pop_r_f_t_mig(fert_min:fert_max,t).*fert_t(:,2,t)/1000);
    % total population
    pop_r_f_t_mig(1,t)=nb_r_t_mig(t)*1/(sex_birth_r_t(t)+1); % female
    pop_r_m_t_mig(1,t)=nb_r_t_mig(t)-pop_r_f_t_mig(1,t); % male
    
    % ----------  age_ini+1 means age_ini because the pop(1,t) is for age 0
    if case_mig==1
        mig_f_t(:,t)=pop_r_f_t_mig(:,t).*mig_rate_f_t(:,t);
        mig_m_t(:,t)=pop_r_m_t_mig(:,t).*mig_rate_m_t(:,t);
    elseif case_mig==2 % case_mig==2
        mig_f_t(:,t)=pop_r_f_t_mig(:,t)*mig_rate_sum_t(t);
        mig_m_t(:,t)=pop_r_m_t_mig(:,t)*mig_rate_sum_t(t);
    elseif case_mig==3;
        adjust_mig=0.85; % for 2050
        adjust_mig=0.775; % for 2020
        mig_f_t(:,t)=pop_r_f_t_mig(:,t)*mig_rate_sum_t(t)*adjust_mig;
        mig_m_t(:,t)=pop_r_m_t_mig(:,t)*mig_rate_sum_t(t)*adjust_mig;
    end
    % including migrants
    pop_u_f_t_mig(:,t)=pop_u_f_t_mig(:,t)+mig_f_t(:,t);
    pop_u_m_t_mig(:,t)=pop_u_m_t_mig(:,t)+mig_m_t(:,t);
    % excluding migrants
    pop_r_f_t_mig(:,t)=pop_r_f_t_mig(:,t)-mig_f_t(:,t);
    pop_r_m_t_mig(:,t)=pop_r_m_t_mig(:,t)-mig_m_t(:,t);

end

% computing aggregates

pop_u_t_mig=pop_u_f_t_mig+pop_u_m_t_mig;
pop_r_t_mig=pop_r_f_t_mig+pop_r_m_t_mig;
pop_t_mig=pop_u_t_mig+pop_r_t_mig;
for  t=1:year_end-year_ini+1

    pop_u_t_mig_sum(t)=sum(pop_u_t_mig(:,t));
    pop_r_t_mig_sum(t)=sum(pop_r_t_mig(:,t));
    pop_t_mig_sum(t)=sum(pop_t_mig(:,t));

    pop_u_f_t_mig_sum(t)=sum(pop_u_f_t_mig(:,t));
    pop_u_m_t_mig_sum(t)=sum(pop_u_m_t_mig(:,t));
    pop_r_f_t_mig_sum(t)=sum(pop_r_f_t_mig(:,t));
    pop_r_m_t_mig_sum(t)=sum(pop_r_m_t_mig(:,t));
    
    % urban labor force
    labor_u_t_mig_sum(t)=sum(pop_u_f_t_mig(1+age_labor_f_min:1+age_labor_f_max,t))+sum(pop_u_m_t_mig(1+age_labor_m_min:1+age_labor_m_max,t));
    labor_u_t_sum(t)=sum(pop_u_f_t(1+age_labor_f_min:1+age_labor_f_max,t))+sum(pop_u_m_t(1+age_labor_m_min:1+age_labor_m_max,t));
    
    % urban old
    old_u_t_mig_sum(t)=sum(pop_u_f_t_mig(1+age_labor_f_max+1:1+age_max,t))+sum(pop_u_m_t_mig(1+age_labor_m_max+1:1+age_max,t));
    old_u_t_sum(t)=sum(pop_u_f_t(1+age_labor_f_max+1:1+age_max,t))+sum(pop_u_m_t(1+age_labor_m_max+1:1+age_max,t));
    
    % rural labor force
    labor_r_t_mig_sum(t)=sum(pop_r_f_t_mig(1+age_labor_f_min:1+age_labor_f_max,t))+sum(pop_r_m_t_mig(1+age_labor_m_min:1+age_labor_m_max,t));
    labor_r_t_sum(t)=sum(pop_r_f_t(1+age_labor_f_min:1+age_labor_f_max,t))+sum(pop_r_m_t(1+age_labor_m_min:1+age_labor_m_max,t));
    
    % rural old
    old_r_t_mig_sum(t)=sum(pop_r_f_t_mig(1+age_labor_f_max+1:1+age_max,t))+sum(pop_r_m_t_mig(1+age_labor_m_max+1:1+age_max,t));
    old_r_t_sum(t)=sum(pop_r_f_t(1+age_labor_f_max+1:1+age_max,t))+sum(pop_r_m_t(1+age_labor_m_max+1:1+age_max,t));

end

clear pop_r_f_t pop_r_m_t pop_u_f_t pop_u_m_t




% urban population growth rate from 1993 to 2000
N_growth=[0.031017871
0.030024417
0.029412625
0.060556093
0.057500536
0.05472889
0.051432417
0.049327969
0.047009106
];



% urban and rural fertility
fert_u_t=squeeze(fert_t(:,1,:));
fert_r_t=squeeze(fert_t(:,2,:));

% life expectation
for t=1:t_end
    life_u_m_t(t)=fun_life(1,squeeze(mort_t(:,1,t))/1000);
    life_u_f_t(t)=fun_life(1,squeeze(mort_t(:,2,t))/1000);
    life_r_m_t(t)=fun_life(1,squeeze(mort_t(:,3,t))/1000);
    life_r_f_t(t)=fun_life(1,squeeze(mort_t(:,4,t))/1000);
end

ratio_sex_t=sum(pop_u_m_t_mig+pop_r_m_t_mig,1)./sum(pop_u_f_t_mig+pop_r_f_t_mig,1);


% new born in peroid 1
    t=1;
    nb_u_t_mig(t)=sum(pop_u_f_t_mig(fert_min:fert_max,t).*fert_t(:,1,t)/1000);
    nb_r_t_mig(t)=sum(pop_r_f_t_mig(fert_min:fert_max,t).*fert_t(:,2,t)/1000);
% ex-post fertility rate
for t=1:t_end
    fert_u_t_expost(t)=nb_u_t_mig(t)/(fert_u_t(:,t)'/sum(fert_u_t(:,t))*(pop_u_f_t_mig(fert_min:fert_max,t)-mig_f_t(fert_min:fert_max,t)));
    fert_r_t_expost(t)=nb_r_t_mig(t)/(fert_r_t(:,t)'/sum(fert_r_t(:,t))*(pop_r_f_t_mig(fert_min:fert_max,t)+mig_f_t(fert_min:fert_max,t)));
    fert_ur_t_expost(t)=(nb_u_t_mig(t)+nb_r_t_mig(t))/(fert_u_t(:,t)'/sum(fert_u_t(:,t))*(pop_u_f_t_mig(fert_min:fert_max,t)-mig_f_t(fert_min:fert_max,t))+fert_r_t(:,t)'/sum(fert_r_t(:,t))*(pop_r_f_t_mig(fert_min:fert_max,t)+mig_f_t(fert_min:fert_max,t)));
end


%% ------------------ working population ----------------
age_work=22;
age_retire_m=60;
age_retire_f=55;
for t=1:100
    pop_work_u_t_22(t)=sum(pop_u_f_t_mig(age_work+1:age_retire_f,t))+sum(pop_u_m_t_mig(age_work+1:age_retire_m,t));
    pop_work_r_t_22(t)=sum(pop_r_f_t_mig(age_work+1:age_retire_f,t))+sum(pop_r_m_t_mig(age_work+1:age_retire_m,t));
end


%% ------------------ Mortality Rate --------------------

% before 1
t=1;
% from pop age 0-age_max-1 to age 1-age_max
mort_u_jt(1:age_max,t)=(mort_t(1:age_max,1,t).*pop_u_m_t_mig(1:age_max,t)+mort_t(1:age_max,2,t).*pop_u_f_t_mig(1:age_max,t))./(pop_u_m_t_mig(1:age_max,t)+pop_u_f_t_mig(1:age_max,t));
mort_r_jt(1:age_max,t)=(mort_t(1:age_max,3,t).*pop_r_m_t_mig(1:age_max,t)+mort_t(1:age_max,4,t).*pop_r_f_t_mig(1:age_max,t))./(pop_r_m_t_mig(1:age_max,t)+pop_r_f_t_mig(1:age_max,t));
for t=2:t_end
    mort_u_jt(1:age_max,t)=(mort_t(1:age_max,1,t).*pop_u_m_t_mig(1:age_max,t-1)+mort_t(1:age_max,2,t-1).*pop_u_f_t_mig(1:age_max,t-1))./(pop_u_m_t_mig(1:age_max,t-1)+pop_u_f_t_mig(1:age_max,t-1));
    mort_r_jt(1:age_max,t)=(mort_t(1:age_max,3,t).*pop_r_m_t_mig(1:age_max,t-1)+mort_t(1:age_max,4,t-1).*pop_r_f_t_mig(1:age_max,t-1))./(pop_r_m_t_mig(1:age_max,t-1)+pop_r_f_t_mig(1:age_max,t-1));
end
% life expectation
for t=1:t_end
    life_u_t(t)=fun_life(1,squeeze(mort_u_jt(:,t))/1000);
    life_r_t(t)=fun_life(1,squeeze(mort_r_jt(:,t))/1000);
end



%% ----------------- 2. Save to Data, normalize N and pop by N_1 -----------------
save data_NoNormalization
% N is for urban, Nr is for rural
% mean(N_growth)=0.0457
N_growth(1:9,1)=0.03;


N_1_sum=sum(pop_u_t_mig(1+age_ini:1+age_max,1)); % normalize the first period urban population to 1
% urban population since 2001
for  t=1:year_end-year_ini+1
%     N_t_mig(8+t,1:age_end)=pop_u_t_mig(1+age_ini:1+age_max,t)/sum(pop_k(1,:))*100;
%     N_t_no_mig(8+t,1:age_end)=pop_u_t(1+age_ini:1+age_max,t)/sum(pop_k(1,:))*100;
    N_t_mig(t,1:age_end)=pop_u_t_mig(1+age_ini:1+age_max,t)/N_1_sum*100;
    N_t_no_mig(t,1:age_end)=pop_u_t(1+age_ini:1+age_max,t)/N_1_sum*100;
    Nr_t_mig(t,1:age_end)=pop_r_t_mig(1+age_ini:1+age_max,t)/N_1_sum*100;
end



% test
tt=80;
N_t=sum(N_t_mig');
Nr_t=sum(Nr_t_mig');
for t=1:tt
    if t > 1
       NG_t(t)=N_t(t)/N_t(t-1)-1;
    end
    Nw_t(t)=sum(N_t_mig(t,1:60-age_ini));
    Nwr_t(t)=sum(N_t_mig(t,60-age_ini+1:age_end));
    Nw_t_no(t)=sum(N_t_no_mig(t,1:60-age_ini));
    Nwr_t_no(t)=sum(N_t_no_mig(t,60-age_ini+1:age_end));
end


% pop_t scale down as the same rate as N_t
pop_u_t_mig=pop_u_t_mig/N_1_sum*100;
pop_r_t_mig=pop_r_t_mig/N_1_sum*100;
pop_t_mig_sum=pop_t_mig_sum/N_1_sum*100;
pop_u_t_mig_sum=pop_u_t_mig_sum/N_1_sum*100;
pop_r_t_mig_sum=pop_r_t_mig_sum/N_1_sum*100;


save data_demography_zengyi1_forever N_t_mig Nr_t_mig pop_u_t_mig pop_r_t_mig pop_t_mig_sum pop_u_t_mig_sum pop_r_t_mig_sum N_t_no_mig age_ini age_end age_max






