
% close all


% load data_benchmark
% fig GDP GDPPC US IT CN
data_pop_CN=[1263638
1270744
1277595
1284303
1291002
1297765
1304262
1310584
1317066
1323592
];

data_pop_US=[282172
285082
287804
290326
293046
295753
298593
301580
304375
307007
307907
310532
313166
315806
318446
321085
323716
326339
328949
331545
334123
336681
339215
341724
344205
346655
349072
351457
353808
356124
358407
360657
362874
365060
367214
369339
371435
373503
375544
377560
379551
381519
383466
385394
387304
389200
391083
392954
394816
396674
398528
];

data_gdppc_CN1=[2885.387864
3117.865097
3408.410098
3776.895875
4188.736908
4735.81457
5249.988462
5889.959325
6415.391577
7011.573153
];

data_gdppc_CN2=[3261.004255
3449.557132
3839.269737
4207.480872
4676.721941
5218.064576
5868.894619
6605.898878
6996.124621
7430.751909
];

data_gdppc_US=[39174.89195
38959.34451
39149.1802
39788.6679
40907.97317
42534.81791
43258.39307
43691.52574
43326.0262
41101.86498
];


%% -------------------------- GDPpc ----------------------------
year_start_data=2000;
year_end_data=2009;
t_start_data=1;
t_end_data=year_end_data-year_start_data+1;
t_fig=101; % 2000-2100

% load data_benchmark growth_y_t
load data_benchmark growth_yur_t g

% keep the real CN growth
growth_CN1_data(2:t_end_data)=data_gdppc_CN1(2:t_end_data)./data_gdppc_CN1(1:t_end_data-1)-1;
growth_CN2_data(2:t_end_data)=data_gdppc_CN2(2:t_end_data)./data_gdppc_CN2(1:t_end_data-1)-1;
growth_US_data(2:t_end_data)=data_gdppc_US(2:t_end_data)./data_gdppc_US(1:t_end_data-1)-1;
growth_CN(1:t_fig)=g+growth_yur_t(1:t_fig);
growth_US=g*ones(1,t_fig);
% use the real US growth
growth_US(2:t_end_data)=growth_US_data(2:t_end_data); 

gdppc_CN1(t_end_data)=data_gdppc_CN1(t_end_data);
gdppc_CN2(t_end_data)=data_gdppc_CN2(t_end_data);
gdppc_US(t_end_data)=data_gdppc_US(t_end_data);

% use our model to predict the gdp 2000-2009
for t=t_end_data-1:-1:t_start_data
    gdppc_CN1(t)=gdppc_CN1(t+1)/(1+growth_CN(t+1));
    gdppc_CN2(t)=gdppc_CN2(t+1)/(1+growth_CN(t+1));
    gdppc_US(t)=gdppc_US(t+1)/(1+growth_US(t+1));
end
for t=t_end_data+1:t_fig
    gdppc_CN1(t)=gdppc_CN1(t-1)*(1+growth_CN(t));
    gdppc_CN2(t)=gdppc_CN2(t-1)*(1+growth_CN(t));
    gdppc_US(t)=gdppc_US(t-1)*(1+growth_US(t));
end


%% -------------------- pop ----------------------------

load data_benchmark pop_ur_total_t pop_t_mig_sum
g_pop_CN(2:t_fig)=pop_ur_total_t(2:t_fig)./pop_ur_total_t(1:t_fig-1)-1;
pop_CN(1:t_end_data)=data_pop_CN(1:t_end_data);
pop_US(1:length(data_pop_US))=data_pop_US; % we have data until 2050
g_pop_US(2:length(data_pop_US))=pop_US(2:length(data_pop_US))./pop_US(1:length(data_pop_US)-1)-1;
g_pop_US(length(data_pop_US)+1:t_fig)=0;

for t=t_end_data+1:t_fig
    pop_CN(t)=pop_CN(t-1)*(1+g_pop_CN(t));
    pop_US(t)=pop_US(t-1)*(1+g_pop_US(t));
end

for t=1:t_fig
    gdp_CN1(t)=pop_CN(t)*gdppc_CN1(t);
    gdp_CN2(t)=pop_CN(t)*gdppc_CN2(t);
    gdp_US(t)=pop_US(t)*gdppc_US(t);
end

for t=1:t_end_data
    data_gdp_CN1(t)=pop_CN(t)*data_gdppc_CN1(t);
    data_gdp_CN2(t)=pop_CN(t)*data_gdppc_CN2(t);
    data_gdp_US(t)=pop_US(t)*data_gdppc_US(t);
end

%% -------------------------- graph for fabrizio ----------------------------

% 
%% ------------
for t_fig=[41 51 101]; % 2000-2040
i_fig=i_fig+1;
figure(i_fig);
x_fig=year_start_data:year_start_data+t_fig-1;

subplot(2,1,1)
plot(x_fig,gdp_CN1(t_start_data:t_start_data+t_fig-1)./gdp_US(t_start_data:t_start_data+t_fig-1),'LineWidth',1.5);
hold on 
plot(x_fig(1:t_end_data),data_gdp_CN1(1:t_end_data)./data_gdp_US(1:t_end_data), 'color','r','LineWidth',1.5);
hold off
axis tight
title('GDP Relative to US')

subplot(2,1,2)
plot(x_fig,gdppc_CN1(t_start_data:t_start_data+t_fig-1)./gdppc_US(t_start_data:t_start_data+t_fig-1),'LineWidth',1.5);
hold on
plot(x_fig(1:t_end_data),data_gdppc_CN1(1:t_end_data)./data_gdppc_US(1:t_end_data), 'color','r','LineWidth',1.5);
hold off

axis tight
title('GDPpc Relative to US')
print( '-dpng', '-r300', ['gdp_gdppc_CN1_2000_' num2str(year_start_data+t_fig-1)  '.png']);
% print( '-depsc2', ['gdp_gdppc_CN1_US_2000_' num2str(year_start_data+t_fig-1)  '.eps']);


subplot(2,1,1)
plot(x_fig,gdp_CN2(t_start_data:t_start_data+t_fig-1)./gdp_US(t_start_data:t_start_data+t_fig-1),'LineWidth',1.5);
hold on 
plot(x_fig(1:t_end_data),data_gdp_CN2(1:t_end_data)./data_gdp_US(1:t_end_data), 'color','r','LineWidth',1.5);
hold off
axis tight
title('GDP Relative to US')

subplot(2,1,2)
plot(x_fig,gdppc_CN2(t_start_data:t_start_data+t_fig-1)./gdppc_US(t_start_data:t_start_data+t_fig-1),'LineWidth',1.5);
hold on
plot(x_fig(1:t_end_data),data_gdppc_CN2(1:t_end_data)./data_gdppc_US(1:t_end_data), 'color','r','LineWidth',1.5);
hold off

axis tight
title('GDPpc Relative to US')
print( '-dpng', '-r300', ['gdp_gdppc_CN2_2000_' num2str(year_start_data+t_fig-1)  '.png']);
print( '-depsc2', ['gdp_gdppc_CN2_US_2000_' num2str(year_start_data+t_fig-1)  '.eps']);

end

% % --------------- 2009-2040
% for t_fig=[32 42 92]; % 2009-2040
% i_fig=i_fig+1;
% figure(i_fig);
% x_fig=year_end_data:year_end_data+t_fig-1;
% 
% subplot(2,1,1)
% plot(x_fig,gdp_CN1(t_end_data:t_end_data+t_fig-1)./gdp_US(t_end_data:t_end_data+t_fig-1),'LineWidth',1.5);
% axis tight
% title('GDP Relative to US')
% 
% subplot(2,1,2)
% plot(x_fig,gdppc_CN1(t_end_data:t_end_data+t_fig-1)./gdppc_US(t_end_data:t_end_data+t_fig-1),'LineWidth',1.5);
% 
% axis tight
% title('GDPpc Relative to US')
% print( '-dpng', '-r300', ['gdp_gdppc_CN1_2009_' num2str(year_end_data+t_fig-1)  '.png']);
% print( '-depsc2', ['gdp_gdppc_CN1_US_2009_' num2str(year_end_data+t_fig-1)  '.eps']);
% end
% 
% for t_fig=[32 42 92]; % 2009-2040
% i_fig=i_fig+1;
% figure(i_fig);
% x_fig=year_end_data:year_end_data+t_fig-1;
% 
% subplot(2,1,1)
% plot(x_fig,gdp_CN2(t_end_data:t_end_data+t_fig-1)./gdp_US(t_end_data:t_end_data+t_fig-1),'LineWidth',1.5);
% hold on 
% plot(x_fig(1:t_end_data),data_gdp_CN2(1:t_end_data)./data_gdp_US(1:t_end_data), 'LineWidth',1.5);
% hold off
% axis tight
% title('GDP Relative to US')
% 
% subplot(2,1,2)
% plot(x_fig,gdppc_CN2(t_end_data:t_end_data+t_fig-1)./gdppc_US(t_end_data:t_end_data+t_fig-1),'LineWidth',1.5);
% hold on
% plot(x_fig(1:t_end_data),data_gdppc_CN2(1:t_end_data)./data_gdppc_US(1:t_end_data), 'LineWidth',1.5);
% hold off
% axis tight
% title('GDPpc Relative to US')
% print( '-dpng', '-r300', ['gdp_gdppc_CN2_2009_' num2str(year_end_data+t_fig-1)  '.png']);
% print( '-depsc2', ['gdp_gdppc_CN2_US_2009_' num2str(year_end_data+t_fig-1)  '.eps']);
% end


% 
% %% ----------------------- graphs ------------
% % i_fig=0;
% for t_fig=[41]
% i_fig=i_fig+1;
% figure(i_fig);
% x_fig=year_start_data:year_start_data+t_fig-1;
% % subplot(1,2,1)
% plot(x_fig(2:t_fig),g_pop_CN(2:t_fig),'LineWidth',1.5);
% hold on
% % plot(x_fig,g_pop_IT,'color','g');
% % hold on
% plot(x_fig(2:t_fig),g_pop_US(2:t_fig),'color','g','LineWidth',1.5);
% hold off
% % axis tight
% axis([x_fig(2) x_fig(t_fig) min(0.95*min(g_pop_CN(1:t_fig)),1.05*min(g_pop_CN(1:t_fig))) 1.05*max(g_pop_US(1:t_fig))])
% title('growth of population: CN US')
% print( '-dpng', '-r300', ['growth_pop_CN_US_2010_' num2str(year_start_data+t_fig-1)  '.png']);
% print( '-depsc2', ['growth_pop_CN_US_2010_' num2str(year_start_data+t_fig-1)  '.eps']);
% 
% i_fig=i_fig+1;
% figure(i_fig);
% % subplot(1,2,2)
% plot(x_fig,pop_CN(1:t_fig),'LineWidth',1.5);
% hold on
% % plot(x_fig,pop_IT,'color','g');
% % hold on
% plot(x_fig,pop_US(1:t_fig),'color','g','LineWidth',1.5);
% hold off
% axis tight
% % title('population: CN IT US')
% title('population: CN US')
% print( '-dpng', '-r300', ['pop_CN_US_2010_' num2str(year_start_data+t_fig-1)  '.png']);
% print( '-depsc2',  ['pop_CN_US_2010_' num2str(year_start_data+t_fig-1)  '.eps']);
% 
% i_fig=i_fig+1;
% figure(i_fig);
% x_fig=year_start_data:year_start_data+t_fig-1;
% % subplot(1,2,1)
% plot(x_fig(2:t_fig),growth_CN(2:t_fig),'LineWidth',1.5);
% hold on
% % plot(x_fig,growth_IT,'color','g');
% % hold on
% plot(x_fig(2:t_fig),growth_US(2:t_fig),'color','g','LineWidth',1.5);
% hold off
% axis tight
% title('growth of GDPpc: CN US')
% print( '-dpng', '-r300', ['growth_gdppc_CN_US_2010_' num2str(year_start_data+t_fig-1)  '.png']);
% print( '-depsc2', ['growth_gdppc_CN_US_2010_' num2str(year_start_data+t_fig-1)  '.eps']);
% 
% i_fig=i_fig+1;
% figure(i_fig);
% % subplot(1,2,2)
% plot(x_fig,gdppc_CN(1:t_fig)./gdppc_US(1:t_fig),'LineWidth',1.5);
% hold off
% % axis([year_start_data+1 year_start_data+t_fig 0 1])
% axis tight
% title('GDPpc: CN over US')
% print( '-dpng', '-r300', ['gdppc_CN_US_2010_' num2str(year_start_data+t_fig-1)  '.png']);
% print( '-depsc2', ['gdppc_CN_US_2010_' num2str(year_start_data+t_fig-1)  '.eps']);
% 
% i_fig=i_fig+1;
% figure(i_fig);
% x_fig=year_start_data:year_start_data+t_fig-1;
% plot(x_fig,gdp_CN(1:t_fig)./gdp_US(1:t_fig),'LineWidth',1.5);
% hold off
% axis tight
% title('GDP: CN over US')
% print( '-dpng', '-r300', ['gdp_CN_US_2010_' num2str(year_start_data+t_fig-1)  '.png']);
% print( '-depsc2', ['gdp_CN_US_2010_' num2str(year_start_data+t_fig-1)  '.eps']);
% 
% end

% gdppc_CN1./gdppc_US
