% compare this with the benchmark2 utility

if strcmp(name_fig_title,'delayed reform')==1
    y_max=1.2;
    y_min=0.95;
elseif strcmp(name_fig_title,'fully funded')==1
    y_max=1.1;
    y_min=0.9;
end

%% ---------------------- 1. Load Utility Data from the Benchmark ---------------------------
% name_data_compare='data_benchmark_2013.mat';
load(name_data_compare,'uw_p_sum_coh_bm2', 'uw_np_sum_coh_bm2')

i_fig=i_fig+1;
figure(i_fig)
coh_fig1=J-Jw;
coh_fig2=J;
coh_fig3=200;
x_fig1=year_start-(J-Jw):year_start-(J-Jw)+coh_fig1-1;
x_fig2=year_start-(J-Jw)+coh_fig1:year_start-(J-Jw)+coh_fig2-1;
x_fig3=year_start-(J-Jw)+coh_fig2:year_start-(J-Jw)+coh_fig3-1;
subplot(3,1,1)
plot(x_fig1,uw_np_sum_coh(1:coh_fig1)./uw_np_sum_coh_bm2(1:coh_fig1),':','color','g','LineWidth',1.5)
hold on
plot(x_fig1,uw_p_sum_coh(1:coh_fig1)./uw_p_sum_coh_bm2(1:coh_fig1),'color','b','LineWidth',1.5);
hold off
% axis('tight')
axis([x_fig1(1) x_fig1(length(x_fig1)) y_min y_max])

% legend('pension','without pension')
% xlabel('Birth year of cohort')
xlabel('Retirement year of cohort')
title(['Welfare gain, ' name_fig_title ': retired in 2011'])

subplot(3,1,2)
plot(x_fig2,uw_p_sum_coh(coh_fig1+1:coh_fig2)./uw_p_sum_coh_bm2(coh_fig1+1:coh_fig2),'color','b','LineWidth',1.5)
hold on
plot(x_fig2,uw_np_sum_coh(coh_fig1+1:coh_fig2)./uw_np_sum_coh_bm2(coh_fig1+1:coh_fig2),':','color','g','LineWidth',1.5)
hold off
% axis('tight')
axis([x_fig2(1) x_fig2(length(x_fig2)) y_min y_max])

% legend('pension','without pension')
% xlabel('Birth year of cohort')
xlabel('Retirement year of cohort')
title(['Welfare gain, ' name_fig_title ': working in 2011'])

subplot(3,1,3)
plot(x_fig3,uw_p_sum_coh(coh_fig2+1:coh_fig3)./uw_p_sum_coh_bm2(coh_fig2+1:coh_fig3),'color','b','LineWidth',1.5)
hold on
plot(x_fig3,uw_np_sum_coh(coh_fig2+1:coh_fig3)./uw_np_sum_coh_bm2(coh_fig2+1:coh_fig3),':','color','g','LineWidth',1.5)
hold off
% axis('tight')
axis([x_fig3(1) x_fig3(length(x_fig3)) y_min y_max])

% legend('pension','without pension')
% xlabel('Birth year of cohort')
xlabel('Retirement year of cohort')
title(['Welfare gain, ' name_fig_title ': working after 2011'])


print( '-dpng', '-r300', ['utility_' fig_name '.png']);
print( '-depsc2', ['utility_' fig_name '.eps']);

