% benchmark reform
% retirement age 57

clear;
clear global;
close all;
tic

%% ----------------- 0. Setup ---------------------------------

global_claim;  % global variables

index_guess=0;
index_fixedlabor=1;


% set the parameters (e.g. population, death rate) if the economy starts from 2000
% name_data_2000='../Pension1_BaselineScenario/data_benchmark.mat';
name_data_2013='../Pension1_BaselineScenario/data_benchmark_2013.mat';
% name_data_2000='data_benchmark.mat';

load(name_data_2013);
parameters_t_adjust_retirement57;

parameters_rural_adjust_retirement57;




%% ----------------- 2. Solve the Dynamics -------------


index_guess=0;
name_data_eq='data_eq_2013_benchmark.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'replace_w_coh3'); % initial

solve_replace_w_coh3_update_pe;


disp('Dynamic computation finished')
toc


% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;



fig_name='2013';



%% --------------- 3. Experiment and Graph ------------------

i_fig=i_fig+1;
experiment_benchmark_2013;     % current system
disp('Experiment_benchmark_2013 finished')
toc