clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

name_data_2013='data_benchmark_2013.mat';

% load the equilibrium from the benchmark reform
load(name_data_2013); 
name_data_2000='../Pension1_BaselineScenario/data_benchmark.mat';

name_exp='delayedreform';
name_data_exp='data_delayedreform.mat';




index_fixedlabor=0; 
index_gtext=0;



%% ---------------- 1. Solve for Long-run Replacement Rate ----------------

% year_reform=2013; % test
% year_reform=year_start+Jw-1+1;
load ('../Pension1_BaselineScenario/data_loop_t_reform','year_reform_optimal') % the optimal reform year
year_reform=2050;
if year_reform~=year_reform_optimal
    display('year_reform is not optimal')
    pause;
end
t_reform=year_reform-year_start+1; % year_start is defined in parameters_t_xxxx.m


index_guess=0;
name_data_eq='data_eq_2013_delayedreform.mat';
name_data_guess=name_data_eq;
% name_data_guess=name_data_2013;
name_data_load=name_data_exp;
load(name_data_guess,'H_p_t','H_np_t','p_base_t','replace_w_coh3');
H_p_t=H_p_t(1:t_dyn); H_np_t=H_np_t(1:t_dyn); p_base_t=p_base_t(1:t_dyn);


solve_replace_w_coh3_update_pe;


disp('Dynamic computation finished')
toc

% save(name_data_eq,'H_p_t','H_np_t','p_base_t','replace_w_coh3');

% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;







%% ----------------- 2. Pension Reform Experiment Outcomes ------------------------

i_fig=i_fig+1;
% adjust_wage_exogeneous;
experiment_delayedreform;     % current system
disp('Experiment_delayedreform finished')
toc



