% retirement age to 57



%% ----- demography ------
Jw_bm=Jw;
Jw_adjust=-3;
Jw=Jw_bm+Jw_adjust; % 5 years delay


%% ----- productivity ------
if Jw_adjust>0
    % add some more productivity
    prod_jt(Jw-Jw_adjust:Jw-1,1:t_dyn)=ones(Jw_adjust,1)*prod_jt(Jw-Jw_adjust-1,1:t_dyn);
    prod_jss(Jw-Jw_adjust:Jw-1)=prod_jt(Jw-Jw_adjust:Jw-1,t_dyn);
elseif Jw_adjust<0
    % clean the prodoctivity
    prod_jt(Jw:Jw-Jw_adjust-1,1:t_dyn)=zeros(-Jw_adjust,t_dyn);
    prod_jss(Jw:Jw-Jw_adjust-1)=prod_jt(Jw:Jw-Jw_adjust-1,t_dyn);
end

%% ----- N_t, N_ss -----
for t=1:t_dyn
    % population gaining labor income
    Ne_labor_t(t)=sum(Ne_t(1:Je-1,t));
    Nw_labor_t(t)=sum(Nw_t(1:Jw-1,t));
    Nr_labor_t(t)=sum(Nr_t(1:Jw-1,t));
    % population gaining capital
    Ne_retire_t(t)=sum(Ne_t(Je:J,t));
    Nw_retire_t(t)=sum(Nw_t(Jw:J,t));
end

for t=1:t_dyn
    Nw_labor_p_t(t)=sum(Nw_p_t(1:Jw-1,t));
    Nw_labor_np_t(t)=sum(Nw_np_t(1:Jw-1,t));
    Nw_retire_p_t(t)=sum(Nw_p_t(Jw:J,t));
    Nw_retire_np_t(t)=sum(Nw_np_t(Jw:J,t));
end

% percentage gaining labor income
Ne_labor_ss=sum(Ne_ss(1:Je-1));
Nw_labor_ss=sum(Nw_ss(1:Jw-1));
% percentage only gaining capital income
Ne_retire_ss=sum(Ne_ss(Je:J));
Nw_retire_ss=sum(Nw_ss(Jw:J));

Nw_labor_p_ss=Nw_labor_ss*Perc_w_p_ss;
Nw_labor_np_ss=Nw_labor_ss*Perc_w_np_ss;
Nw_retire_p_ss=Nw_retire_ss*Perc_w_p_ss;
Nw_retire_np_ss=Nw_retire_ss*Perc_w_np_ss;




