% pre-transition with growth
% entrepreneurs have rational expectation, and their income before 2000 is
% computed using growth

% clear

pw_jt(1:Jw-1,1:t_dyn)=0;

% global sig g

w_t=real(w_t);
p_base_t=real(p_base_t);
me_t=real(me_t);
RE_t=real(RE_t);

%% ---------------- wage growth and management income growth --------------
for t=1:50
    growth_w_t(t+1)=w_t(t+1)/w_t(t)-1;
    growth_p_base_t(t+1)=p_base_t(t+1)/p_base_t(t)-1;
    growth_me_t(t+1)=me_t(t+1)/me_t(t)-1;
%     growth_me_t(t+1)=0;
    growth_RE_t(t+1)=RE_t(t+1)/RE_t(t)-1;
%     growth_RE_t(t+1)=0;
end

%% --------------- compute w_pre_t and me_pre_t from 1978 to 1999 ---------------
% growth_w_pre=0.02;
% growth_p_base_pre=0.01;
% growth_me_pre=0.3;
% % growth_RE_pre=-0.0059;
% growth_RE_pre=0;
% growth_w_pre=growth_w_t(2);
% growth_p_base_pre=growth_p_base_t(2);
% growth_me_pre=growth_me_t(2);
% growth_RE_pre=growth_RE_t(2);
growth_w_pre=mean(growth_w_t(2:3));
growth_p_base_pre=mean(growth_p_base_t(2:3));
growth_me_pre=mean(growth_me_t(2:3));
growth_RE_pre=mean(growth_RE_t(2:3));


% T_pre=year_start-1-year_pre_start+1; % 8 years, 92-99

load data_input data_index_realwageincome
% this wage income is in fact w*h, so proportion to p, but not to w
% income=w*h=w^(1+1/nu)*prod^(1/nu)
% (1+growth_w_pre)^(1+1/nu)-1, very close to growth_p_base_pre
growth_p_base_pre_t(1:t_pre_1980-1)=-g;
growth_p_base_pre_t(t_pre_1980:T_pre+1)=growth_p_base_pre;
growth_w_pre_t(1:t_pre_1980-1)=-g;
growth_w_pre_t(t_pre_1980:T_pre+1)=growth_w_pre;


% year T_pre is 1999
w_pre_t(T_pre+1)=w_t(1);
p_base_pre_t(T_pre+1)=p_base_t(1);
for t=T_pre:-1:1
    w_pre_t(t)=w_pre_t(t+1)/(1+growth_w_pre_t(t+1));
    p_base_pre_t(t)=p_base_pre_t(t+1)/(1+growth_p_base_pre_t(t+1));
    me_pre_t(t)=me_t(1)/((1+growth_me_pre)^(T_pre-t+1));
    RE_pre_t(t)=RE_t(1)/((1+growth_RE_pre)^(T_pre-t+1));
end



%% ----------------- initial aw_t, me_t ---------------------


w_pre_t(T_pre+1:T_pre+J)=w_t(1:J);
p_base_pre_t(T_pre+1:T_pre+J)=p_base_t(1:J);
me_pre_t(T_pre+1:T_pre+J)=me_t(1:J);
RE_pre_t(T_pre+1:T_pre+J)=RE_t(1:J);

pe_pre_t(1:T_pre+J)=0;

tau_w_pre_t(1:T_pre+J)=tau_w_t(1);
tau_e_pre_t(1:T_pre+J)=tau_e_t(1);



%% ------------------ 1. Workers, variables -----------------


% age-year specific indexed pension
t=1;
for j=Jw:J
        t_retire=t-j+Jw;
        if t_retire<=1 % last period goes to pre_t
            % t_retire+J-1 gives the t_retire in pre_t
%             p_base_pre_jt(j,t)=(1-indexation)*p_base_pre_t(1)/(1+growth_p_base_pre_t(1))^(1-t_retire+1)/(1+g)^(j-Jw+1)+indexation*p_base_pre_t(1)/(1+growth_p_base_pre_t(1))/(1+g); % can not track back to earlier, just use the growth rate
            p_base_pre_jt(j,t)=p_base_pre_t(1); % can't go further
        else
            p_base_pre_jt(j,t)=(1-indexation)*p_base_pre_t(t_retire-1)/(1+g)^(j-Jw+1)+indexation*p_base_pre_t(t-1)/(1+g); % from last year
        end
end
for t=2:T_pre+J
    for j=Jw:J
        t_retire=t-j+Jw;
        if t_retire<=1
            % t_retire+J-1 gives the t_retire in pre_t
            p_base_pre_jt(j,t)=(1-indexation)*p_base_pre_t(1)/(1+g)^(t-1)+indexation*p_base_pre_t(t-1)/(1+g); % can not track back to earlier, just use the growth rate
        else
            p_base_pre_jt(j,t)=(1-indexation)*p_base_pre_t(t_retire-1)/(1+g)^(j-Jw+1)+indexation*p_base_pre_t(t-1)/(1+g); % from last year
        end
    end
end


for t=1:T_pre % born after 1922
    coh=J+t-1+year_pre_start-year_start;
    Length=J;
    for l=1:Length
        replace_w_pre_jt(l,t+l-1)=(j+l-1>=Jw)*replace_w_coh(coh);
    end
end
replace_w_pre_jt(Jw:J,T_pre+1:T_pre+J)=replace_w_jt(Jw:J,1:J);
replace_w_pre_jt(1:Jw-1,1:T_pre+J)=0;

pw_pre_jt(Jw:J,1:T_pre+J)=p_base_pre_jt(Jw:J,1:T_pre+J).*replace_w_pre_jt(Jw:J,1:T_pre+J);



% given w_t, tau_w_t, solve aw_t, cw_t

%% ----------------------- 2. workers with pension --------------------
% income
for t=1:T_pre+J
    for j=1:Jw-1
        wagepension_p_pre_t(j,t)=(1-tau_w_pre_t(t))*w_pre_t(t)*prod_pre_jt(j,t);
    end
    for j=Jw:J
        wagepension_p_pre_t(j,t)=pw_pre_jt(j,t);
    end
end




% given w_t, tau_w_t, solve aw_t, cw_t
% those cohorts already exist in period 1
t=t_pre_w_start;
aw_p_pre_t(1:t_pre_w_start,t)=aw_t_pre_w_start(1:t_pre_w_start);
for j=1:J+(t-T_pre-1) % j is the age in the starting period, the first cohort's age is J+(t-T_pre-1)
    Length=J-j+1;
    coh=1+(t-T_pre-1)+(J-j); % age J in t=T_pre+1 is cohort 1
    Interest(1:Length)=1+r;
    for l=1:Length
        WagePension(l)=wagepension_p_pre_t(j+l-1,t+l-1); % year l, age depends positively on j
    end
    Surv(1:Length)=lam_jcoh(j:j+Length-1,coh);
    Asset_ini=aw_p_pre_t(j,t);
    Beta=bet_w_coh(coh);
    [cw_p_j,h_p_j,yw_p_j,aw_p_j]=fun_c_a_j_kpr(Beta,Length, Interest, WagePension, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t, cw_coh
    
    % l means the lth period he appears in the sample
    for l=1:Length
        cw_p_pre_t(j+l-1,t+l-1)=cw_p_j(l);
        h_p_pre_t(j+l-1,t+l-1)=h_p_j(l);
        yw_p_pre_t(j+l-1,t+l-1)=yw_p_j(l);
        aw_p_pre_t(j+l-1,t+l-1)=aw_p_j(l);
        
        cw_p_coh(j+l-1,coh)=cw_p_j(l);  
        h_p_coh(j+l-1,coh)=h_p_j(l);  
        yw_p_coh(j+l-1,coh)=yw_p_j(l);  
        aw_p_coh(j+l-1,coh)=aw_p_j(l);  


        uw_p_coh(j+l-1,coh)=fun_u_kpr(cw_p_coh(j+l-1,coh),h_p_coh(j+l-1,coh));
        
        
        for len=1:j-1
            if len<Jw
                h_p_coh(len,coh)=h_adjust;
                yw_p_coh(len,coh)=wagepension_p_pre_t(len,t+len-j)*h_adjust;
                cw_p_coh(len,coh)=yw_p_coh(len,coh);
                cw_p_pre_t(len,t+len-j)=cw_p_coh(len,coh);
            else
                h_p_coh(len,coh)=0;
                yw_p_coh(len,coh)=wagepension_p_pre_t(len,t+len-j);
                cw_p_coh(len,coh)=yw_p_coh(len,coh);
                cw_p_pre_t(len,t+len-j)=cw_p_coh(len,coh);
            end
            
            uw_p_coh(len,coh)=fun_u_kpr(cw_p_coh(len,coh),h_p_coh(len,coh));
            
        end
    
    end
end

% those born in period t>t_pre_w_start
j=1;  % start with age 1
for t=t_pre_w_start+1:T_pre
    Length=J;
    coh=J+(t-T_pre-1); % born in T_pre+1 is cohort J
    Interest(1:Length)=1+r;
    for l=1:Length
        WagePension(l)=wagepension_p_pre_t(l,t+l-1); % year l, age depends positively on j
    end
    Surv(1:Length)=lam_jcoh(1:Length,coh);
    Asset_ini=0;
    Beta=bet_w_coh(coh);
    [cw_p_j,h_p_j,yw_p_j,aw_p_j]=fun_c_a_j_kpr(Beta,Length, Interest, WagePension, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t
    uw_p_sum_coh(coh)=0;
    for l=1:Length
        cw_p_pre_t(l,t+l-1)=cw_p_j(l);
        h_p_pre_t(l,t+l-1)=h_p_j(l);
        yw_p_pre_t(l,t+l-1)=yw_p_j(l);
        aw_p_pre_t(l,t+l-1)=aw_p_j(l);
        
        cw_p_coh(l,coh)=cw_p_j(l); 
        h_p_coh(l,coh)=h_p_j(l); 
        yw_p_coh(l,coh)=yw_p_j(l);
        aw_p_coh(l,coh)=aw_p_j(l); 

        uw_p_coh(l,coh)=fun_u_kpr(cw_p_coh(l,coh),h_p_coh(l,coh));
        
    end
end
aw_p_pre_t(1,T_pre+1)=0;
aw_p_t(1:J,1)=aw_p_pre_t(1:J,T_pre+1);

% save data_pre aw_p_pre_t aw_np_pre_t ae_pre_t







%% ---------------  2. Worker without Pension -----------------

% income
for t=1:T_pre+J
    for j=1:Jw-1
        wagepension_np_pre_t(j,t)=w_pre_t(t)*prod_pre_jt(j,t);
    end
    for j=Jw:J
        wagepension_np_pre_t(j,t)=0;
    end
end


% given w_t, tau_w_t, solve aw_t, cw_t
% those cohorts already exist in period 1
t=t_pre_w_start;
aw_np_pre_t(1:t_pre_w_start,t)=aw_t_pre_w_start(1:t_pre_w_start);
for j=1:J+(t-T_pre-1) % j is the age in the starting period, the first cohort's age is J+(t-T_pre-1)
    Length=J-j+1;
    coh=1+(t-T_pre-1)+(J-j); % age J in t=T_pre+1 is cohort 1
    Interest(1:Length)=1+r;
    for l=1:Length
        WagePension(l)=wagepension_np_pre_t(j+l-1,t+l-1); % year l, age depends positively on j
    end
    Surv(1:Length)=lam_jcoh(j:j+Length-1,coh);
    Asset_ini=aw_np_pre_t(j,t);
    Beta=bet_w_coh(coh);
    [cw_np_j,h_np_j,yw_np_j,aw_np_j]=fun_c_a_j_kpr(Beta,Length, Interest, WagePension, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t, cw_coh
    
    % l means the lth period he appears in the sample
    for l=1:Length
        cw_np_pre_t(j+l-1,t+l-1)=cw_np_j(l);
        h_np_pre_t(j+l-1,t+l-1)=h_np_j(l);
        yw_np_pre_t(j+l-1,t+l-1)=yw_np_j(l);
        aw_np_pre_t(j+l-1,t+l-1)=aw_np_j(l);
        
        cw_np_coh(j+l-1,coh)=cw_np_j(l);  
        h_np_coh(j+l-1,coh)=h_np_j(l);  
        yw_np_coh(j+l-1,coh)=yw_np_j(l);  
        aw_np_coh(j+l-1,coh)=aw_np_j(l);  

        uw_np_coh(j+l-1,coh)=fun_u_kpr(cw_np_coh(j+l-1,coh),h_np_coh(j+l-1,coh));
        
    end
    
        % life before t_w_start
        for len=1:j-1
            if len<Jw
                h_np_coh(len,coh)=h_adjust;
                yw_np_coh(len,coh)=wagepension_np_pre_t(len,t+len-j)*h_adjust;
                cw_np_coh(len,coh)=yw_np_coh(len,coh);
                cw_np_pre_t(len,t+len-j)=cw_np_coh(len,coh);
            else
                h_np_coh(len,coh)=0;
                yw_np_coh(len,coh)=wagepension_np_pre_t(len,t+len-j);
                cw_np_coh(len,coh)=yw_np_coh(len,coh);
                cw_np_pre_t(len,t+len-j)=cw_np_coh(len,coh);
            end
            uw_np_coh(len,coh)=fun_u_kpr(cw_np_coh(len,coh),h_np_coh(len,coh));
            

        end
end


% those born in period t>t_pre_w_start
j=1;  % start with age 1
for t=t_pre_w_start+1:T_pre
    Length=J;
    coh=J+(t-T_pre-1); % born in T_pre+1 is cohort J
    Interest(1:Length)=1+r;
    for l=1:Length
        WagePension(l)=wagepension_np_pre_t(l,t+l-1); % year l, age depends positively on j
    end
    Surv(1:Length)=lam_jcoh(1:Length,coh);
    Asset_ini=0;
    Beta=bet_w_coh(coh);
    [cw_np_j,h_np_j,yw_np_j,aw_np_j]=fun_c_a_j_kpr(Beta,Length, Interest, WagePension, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t
    uw_np_sum_coh(coh)=0;
    for l=1:Length
        cw_np_pre_t(l,t+l-1)=cw_np_j(l);
        h_np_pre_t(l,t+l-1)=h_np_j(l);
        yw_np_pre_t(l,t+l-1)=yw_np_j(l);
        aw_np_pre_t(l,t+l-1)=aw_np_j(l);
        
        cw_np_coh(l,coh)=cw_np_j(l); 
        h_np_coh(l,coh)=h_np_j(l); 
        yw_np_coh(l,coh)=yw_np_j(l);
        aw_np_coh(l,coh)=aw_np_j(l); 

        uw_np_coh(l,coh)=fun_u_kpr(cw_np_coh(l,coh),h_np_coh(l,coh));
        
    end
end
aw_np_pre_t(1,T_pre+1)=0;
aw_np_t(1:J,1)=aw_np_pre_t(1:J,T_pre+1);





%% ----------------------- 3. Entrepreneurs -------------------------
% entrepreneurs start later, in 1995
t=t_pre_e_start;
ae_pre_t(Je:J,t)=ones(J-Je+1,1)*ae_t_pre_e_start;
for j=1:t % cohort 1 to t_pre_e_start, older cohorts doesn't matter
    coh=t_pre_e_start-j+1;
    Length=J-j+1;
     if j<Je
        Interest(1:Je-j)=1+r;
        Interest(Je-j+1:J-j+1)=RE_pre_t(t+Je-j:t+J-j);
        Inc(1:Je-j)=(1-tau_e_pre_t(t:t+Je-j-1)).*me_pre_t(t:t+Je-j-1);
        Inc(Je-j+1:J-j+1)=pe_pre_t(t+Je-j:t+J-j);
     else
        Interest(1:J-j+1)=RE_pre_t(t:t+J-j);
        Inc(1:J-j+1)=pe_pre_t(t:t+J-j);
     end
    Labor=zeros(1,Length);
%     Surv(1)=1;
%     for l=2:Length
%         Surv(l)=lam_pre_jt(j+l-1,t+l-1);
%     end
    Surv(1:Length)=lam_jcoh(j:j+Length-1,coh);
    Asset_ini=ae_pre_t(j,t);
    [ce_j,ae_j]=fun_c_a_j_fixlabor(bet_e_ini,Length, Interest, Inc, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t
    for l=1:Length
        ce_pre_t(j+l-1,t+l-1)=ce_j(l);
        ae_pre_t(j+l-1,t+l-1)=ae_j(l);
        ye_pre_t(j+l-1,t+l-1)=Inc(l);
    end
end


% those born in period t>1
for t=t_pre_e_start+1:T_pre
    coh=t;
    j=1;
    Length=J;
    Interest(1:Je-1)=1+r;
    Interest(Je:J)=RE_pre_t(t+Je-1:t+J-1);
    Inc(1:Je-1)=(1-tau_e_pre_t(t:t+Je-2)).*me_pre_t(t:t+Je-2);
    Inc(Je:J)=pe_pre_t(t+Je-1:t+J-1);
%     
%     Surv(1)=1;
%     for l=2:Length
%         Surv(l)=lam_pre_jt(l,t+l-1);
%     end
    Surv(1:Length)=lam_jcoh(1:Length,coh);
    Asset_ini=0;
    Labor=zeros(1,J);
    [ce_j,ae_j]=fun_c_a_j_fixlabor(bet_e_ini,Length, Interest, Inc, Surv, Asset_ini);
    % put ce_j, ae_j into ce_t, ae_t
    for l=1:Length
        ce_pre_t(j+l-1,t+l-1)=ce_j(l);
        ae_pre_t(j+l-1,t+l-1)=ae_j(l);
        ye_pre_t(j+l-1,t+l-1)=Inc(l);
    end
end
ae_pre_t(1,T_pre+1)=0;
% save data_pre aw_p_pre_t aw_np_pre_t ae_pre_t
