% compare fully funded reform and benchmark 2013

% load data_benchmark_2013 bm2.cw_p_coh bm2.yw_p_coh bm2.cw_p_t bm2.yw_p_t bm2.aw_p_t bm2.aw_p_coh
bm2=load('data_benchmark_2013','cw_p_coh', 'yw_p_coh', 'cw_p_t', 'yw_p_t', 'aw_p_t', 'aw_p_coh','tau_w_t','p_base_t');


t=1;
for j=1:J % j is the age in period 1
    Length=J-j+1;
    coh=J-j+1;
    Surv(1:Length)=lam_jcoh(j:j+Length-1,coh);
    Surv(1)=1;
    % lifetime income and consumption
    cw_p_sum_coh(coh)=0;
    bm2.cw_p_sum_coh(coh)=0;
    yw_p_sum_coh(coh)=0;
    bm2.yw_p_sum_coh(coh)=0;
    for l=1:Length
        cw_p_sum_coh(coh)=cw_p_sum_coh(coh)+prod(Surv(1:l))*cw_p_coh(j+l-1,coh)*((1+g)/(1+r))^(l-1);
        bm2.cw_p_sum_coh(coh)=bm2.cw_p_sum_coh(coh)+prod(Surv(1:l))*bm2.cw_p_coh(j+l-1,coh)*((1+g)/(1+r))^(l-1);
        yw_p_sum_coh(coh)=yw_p_sum_coh(coh)+prod(Surv(1:l))*yw_p_coh(j+l-1,coh)*((1+g)/(1+r))^(l-1);
        bm2.yw_p_sum_coh(coh)=bm2.yw_p_sum_coh(coh)+prod(Surv(1:l))*bm2.yw_p_coh(j+l-1,coh)*((1+g)/(1+r))^(l-1);
    end
    aw_p_ini_coh(coh)=aw_p_coh(j,coh);
    bm2.aw_p_ini_coh(coh)=bm2.aw_p_coh(j,coh);
    ayw_p_sum_coh(coh)=(1+r)*aw_p_coh(j,coh)+yw_p_sum_coh(coh);
    bm2.ayw_p_sum_coh(coh)=(1+r)*bm2.aw_p_coh(j,coh)+bm2.yw_p_sum_coh(coh);
    
    % tax payment and pension income
    tax_sum_coh(coh)=0;
    bm2.tax_sum_coh(coh)=0;
    pension_sum_coh(coh)=0;
    bm2.pension_sum_coh(coh)=0;
        
    if j<Jw
        % tax payment
        for l=1:Jw-1-j+1
            tax_sum_coh(coh)=tax_sum_coh(coh)+yw_p_coh(j+l-1,coh)/(1-tau_w_t(l))*tau_w_t(l)*prod(Surv(1:l))*((1+g)/(1+r))^(l-1);
            bm2.tax_sum_coh(coh)=bm2.tax_sum_coh(coh)+bm2.yw_p_coh(j+l-1,coh)/(1-bm2.tau_w_t(l))*bm2.tau_w_t(l)*prod(Surv(1:l))*((1+g)/(1+r))^(l-1);
        end
        for l=Jw-j+1:J-j+1
            pension_sum_coh(coh)=pension_sum_coh(coh)+yw_p_coh(j+l-1,coh)*prod(Surv(1:l))*((1+g)/(1+r))^(l-1);
            bm2.pension_sum_coh(coh)=bm2.pension_sum_coh(coh)+bm2.yw_p_coh(j+l-1,coh)*prod(Surv(1:l))*((1+g)/(1+r))^(l-1);
        end
    else % already retired
        for l=1:J-j+1
            pension_sum_coh(coh)=pension_sum_coh(coh)+yw_p_coh(j+l-1,coh)*prod(Surv(1:l))*((1+g)/(1+r))^(l-1);
            bm2.pension_sum_coh(coh)=bm2.pension_sum_coh(coh)+bm2.yw_p_coh(j+l-1,coh)*prod(Surv(1:l))*((1+g)/(1+r))^(l-1);
        end
    end
        
end


% those born in period t>1
for t=2:t_dyn
    Length=J;
    coh=J+t-1;
    Surv(1:Length)=lam_jcoh(1:Length,coh);
    Surv(1)=1;
    % lifetime income and consumption
    cw_p_sum_coh(coh)=0;
    bm2.cw_p_sum_coh(coh)=0;
    yw_p_sum_coh(coh)=0;
    bm2.yw_p_sum_coh(coh)=0;
    for l=1:Length
        cw_p_sum_coh(coh)=cw_p_sum_coh(coh)+prod(Surv(1:l))*cw_p_coh(l,coh)*((1+g)/(1+r))^(l-1);
        bm2.cw_p_sum_coh(coh)=bm2.cw_p_sum_coh(coh)+prod(Surv(1:l))*bm2.cw_p_coh(l,coh)*((1+g)/(1+r))^(l-1);
        yw_p_sum_coh(coh)=yw_p_sum_coh(coh)+prod(Surv(1:l))*yw_p_coh(l,coh)*((1+g)/(1+r))^(l-1);
        bm2.yw_p_sum_coh(coh)=bm2.yw_p_sum_coh(coh)+prod(Surv(1:l))*bm2.yw_p_coh(l,coh)*((1+g)/(1+r))^(l-1);
    end
    aw_p_ini_coh(coh)=aw_p_coh(1,coh);
    bm2.aw_p_ini_coh(coh)=bm2.aw_p_coh(1,coh);
    ayw_p_sum_coh(coh)=(1+r)*aw_p_coh(1,coh)+yw_p_sum_coh(coh);
    bm2.ayw_p_sum_coh(coh)=(1+r)*bm2.aw_p_coh(1,coh)+bm2.yw_p_sum_coh(coh);
    
    % tax payment and pension income
    tax_sum_coh(coh)=0;
    bm2.tax_sum_coh(coh)=0;
    pension_sum_coh(coh)=0;
    bm2.pension_sum_coh(coh)=0;
    j=1; % all born in period 1
        % tax payment
        for l=1:Jw-1-j+1
            tax_sum_coh(coh)=tax_sum_coh(coh)+yw_p_coh(j+l-1,coh)/(1-tau_w_t(t+l-1))*tau_w_t(t+l-1)*prod(Surv(1:l))*((1+g)/(1+r))^(l-1);
            bm2.tax_sum_coh(coh)=bm2.tax_sum_coh(coh)+bm2.yw_p_coh(j+l-1,coh)/(1-bm2.tau_w_t(t+l-1))*bm2.tau_w_t(t+l-1)*prod(Surv(1:l))*((1+g)/(1+r))^(l-1);
        end
        for l=Jw-j+1:J-j+1
            pension_sum_coh(coh)=pension_sum_coh(coh)+yw_p_coh(j+l-1,coh)*prod(Surv(1:l))*((1+g)/(1+r))^(l-1);
            bm2.pension_sum_coh(coh)=bm2.pension_sum_coh(coh)+bm2.yw_p_coh(j+l-1,coh)*prod(Surv(1:l))*((1+g)/(1+r))^(l-1);
        end
    
    
end


% cohort specific difference comes from ?
cw_p_sum_coh-bm2.cw_p_sum_coh - (yw_p_sum_coh-bm2.yw_p_sum_coh);
error_acy=(1+r)*aw_p_ini_coh+yw_p_sum_coh-cw_p_sum_coh;
error_acy_bm2=(1+r)*bm2.aw_p_ini_coh+bm2.yw_p_sum_coh-bm2.cw_p_sum_coh;
% cw_p_sum_coh(1:J)-bm2.cw_p_sum_coh(1:J) - (yw_p_sum_coh(1:J)-bm2.yw_p_sum_coh(1:J)) - transfer_aw_p_coh(1:J)*(1+r)


%% ----------------------- con/inc, year specific -------------------
for t=1:t_dyn
    Cw_p_t(t)=sum(cw_p_t(1:J,t).*Nw_p_t(1:J,t));
    Yw_p_t(t)=sum(yw_p_t(1:J,t).*Nw_p_t(1:J,t));
    Aw_p_t(t)=sum(aw_p_t(1:J,t).*Nw_p_t(1:J,t));
    bm2.Cw_p_t(t)=sum(bm2.cw_p_t(1:J,t).*Nw_p_t(1:J,t));
    bm2.Yw_p_t(t)=sum(bm2.yw_p_t(1:J,t).*Nw_p_t(1:J,t));
    bm2.Aw_p_t(t)=sum(bm2.aw_p_t(1:J,t).*Nw_p_t(1:J,t));
end

% aggregate over years
Cw_p_lifetime=0;
bm2.Cw_p_lifetime=0;
Yw_p_lifetime=0;
bm2.Yw_p_lifetime=0;
for t=1:t_dyn
    Cw_p_lifetime=Cw_p_lifetime+Cw_p_t(t)*((1+g)/(1+r))^(t-1);
    bm2.Cw_p_lifetime=bm2.Cw_p_lifetime+bm2.Cw_p_t(t)*((1+g)/(1+r))^(t-1);
    Yw_p_lifetime=Yw_p_lifetime+Yw_p_t(t)*((1+g)/(1+r))^(t-1);
    bm2.Yw_p_lifetime=bm2.Yw_p_lifetime+bm2.Yw_p_t(t)*((1+g)/(1+r))^(t-1);
end

Cw_p_ss=Cw_p_t(t_dyn)*(1+N_growth_ss);
Cw_p_ss_bm2=bm2.Cw_p_t(t_dyn)*(1+N_growth_ss);
Yw_p_ss=Yw_p_t(t_dyn)*(1+N_growth_ss);
Yw_p_ss_bm2=bm2.Yw_p_t(t_dyn)*(1+N_growth_ss);
% continuation value from steady state
Cw_p_lifetime=Cw_p_lifetime+Cw_p_ss*((1+g)/(1+r))^t_dyn/(1-(1+N_growth_ss)*(1+g)/(1+r));
bm2.Cw_p_lifetime=bm2.Cw_p_lifetime+Cw_p_ss_bm2*((1+g)/(1+r))^t_dyn/(1-(1+N_growth_ss)*(1+g)/(1+r));
Yw_p_lifetime=Yw_p_lifetime+Yw_p_ss*((1+g)/(1+r))^t_dyn/(1-(1+N_growth_ss)*(1+g)/(1+r));
bm2.Yw_p_lifetime=bm2.Yw_p_lifetime+Yw_p_ss_bm2*((1+g)/(1+r))^t_dyn/(1-(1+N_growth_ss)*(1+g)/(1+r));

% extra asset from migration
Aw_p_t_extra_mig;


display('error Cw_p_lifetime/bm2.Cw_p_lifetime-1')
Cw_p_lifetime/bm2.Cw_p_lifetime-1
display('error Cw_p_lifetime-bm2.Cw_p_lifetime')
Cw_p_lifetime-bm2.Cw_p_lifetime
display('error (1+r)*(Aw_p_t(1)-bm2.Aw_p_t(1))+Yw_p_lifetime-bm2.Yw_p_lifetime')
(1+r)*(Aw_p_t(1)-bm2.Aw_p_t(1))+Yw_p_lifetime-bm2.Yw_p_lifetime
display('error (1+r)*Aw_p_t(1)+Yw_p_lifetime+Aw_p_lifetime_extra-Cw_p_lifetime')
(1+r)*Aw_p_t(1)+Yw_p_lifetime+Aw_p_lifetime_extra-Cw_p_lifetime
display('error (1+r)*bm2.Aw_p_t(1)+bm2.Yw_p_lifetime+bm2.Aw_p_lifetime_extra-bm2.Cw_p_lifetime')
(1+r)*bm2.Aw_p_t(1)+bm2.Yw_p_lifetime+bm2.Aw_p_lifetime_extra-bm2.Cw_p_lifetime



% transfer_aw_p_sum
display('gov_debt_t(1)*(1+r)')
% gov_debt_t(1)*(1+r)
% tax_lifetime
% display('error gov_debt_t(1)*(1+r)-tax_lifetime')
% gov_debt_t(1)*(1+r)-tax_lifetime
% pension_lifetime
% gov_debt_lifetime



%% ---------------- figure, cohort specific ---------------
% i_fig=i_fig+1;
% figure(i_fig)
% t_fig=111;
% 
% year_fig_start=2000;
% coh_fig_start=1+(J-Jw)+(year_fig_start-year_start);
% x_fig=year_fig_start:year_fig_start+t_fig-1;
% 
% 
% plot(x_fig,cw_p_sum_coh(coh_fig_start:coh_fig_start+t_fig-1)./bm2.cw_p_sum_coh(coh_fig_start:coh_fig_start+t_fig-1),'color','b','LineWidth',2);
% hold on
% plot(x_fig,ayw_p_sum_coh(coh_fig_start:coh_fig_start+t_fig-1)./bm2.ayw_p_sum_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','r','LineWidth',2);
% hold off
% % axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
% axis tight
% % legend('pension','without pension')
% xlabel('year')
% title(['income, consumption difference by year of retirement: ' name_fig_title])
% print('-dpng','-r300',['compare_inc_con_' fig_name  '.png'])
% print('-depsc2',['compare_inc_con_' fig_name '.eps'])
% 
% 
% ratio_dif_tax_ay_sum_coh=(tax_sum_coh-bm2.tax_sum_coh)./ayw_p_sum_coh;
% ratio_dif_pension_ay_sum_coh=(pension_sum_coh-bm2.pension_sum_coh)./ayw_p_sum_coh;
% i_fig=i_fig+1;
% figure(i_fig)
% t_fig=111;
% % tax difference and pension difference
% % plot(x_fig,(tax_sum_coh(coh_fig_start:coh_fig_start+t_fig-1)-bm2.tax_sum_coh(coh_fig_start:coh_fig_start+t_fig-1))./bm2.ayw_p_sum_coh(coh_fig_start:coh_fig_start+t_fig-1),'color','b','LineWidth',2);
% plot(x_fig,ratio_dif_tax_ay_sum_coh(coh_fig_start:coh_fig_start+t_fig-1),'color','b','LineWidth',2);
% hold on
% % plot(x_fig,(pension_sum_coh(coh_fig_start:coh_fig_start+t_fig-1)-bm2.pension_sum_coh(coh_fig_start:coh_fig_start+t_fig-1))./bm2.ayw_p_sum_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','r','LineWidth',2);
% plot(x_fig,ratio_dif_pension_ay_sum_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','r','LineWidth',2);
% hold off
% axis([x_fig(1) x_fig(length(x_fig)) -0.3 -0.1])
% % axis tight
% % legend('pension','without pension')
% xlabel('year')
% title(['tax and pension difference by year of retirement: ' name_fig_title])
% 
% print('-dpng','-r300',['compare_tax_pension_' fig_name  '.png'])
% print('-depsc2',['compare_tax_pension_' fig_name '.eps'])
% 
% i_fig=i_fig+1;
% figure(i_fig)
% t_fig=111;
% x_fig=2000+[1:t_fig];
% % tax difference and pension difference
% % plot(x_fig,(tax_sum_coh(coh_fig_start:coh_fig_start+t_fig-1)-bm2.tax_sum_coh(coh_fig_start:coh_fig_start+t_fig-1))./bm2.ayw_p_sum_coh(coh_fig_start:coh_fig_start+t_fig-1),'color','b','LineWidth',2);
% plot(x_fig,p_base_t(2:t_fig+1),'color','b','LineWidth',2);
% % hold on
% % % plot(x_fig,(pension_sum_coh(coh_fig_start:coh_fig_start+t_fig-1)-bm2.pension_sum_coh(coh_fig_start:coh_fig_start+t_fig-1))./bm2.ayw_p_sum_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','r','LineWidth',2);
% % plot(x_fig,bm2.p_base_t(1:t_fig),'-.','color','r','LineWidth',2);
% % hold off
% % axis tight
% axis([x_fig(1) x_fig(length(x_fig)) 2.3 2.4])
% % legend('pension','without pension')
% xlabel('year')
% title(['pension base by year ' name_fig_title])
% 
% print('-dpng','-r300',['compare_p_base_t_' fig_name  '.png'])
% print('-depsc2',['compare_p_base_t_' fig_name '.eps'])
