% load data_temp


%%  -------------------- replacement rate ------------------------

figure
% n_fig=n_reform;

x_fig= grid_reform(1:n_fig);
plot(x_fig,replace_w_coh3_t_reform(1:n_fig),'color','b','LineWidth',2);
axis tight
xlabel('year')
title(['long run replacement rate'])


print( '-dpng', '-r300', ['pension_t_reform.png']);
print( '-depsc2', ['pension_t_reform.eps']);


%% -------------------- equivalence variation, pensioners -------------------------
figure

plot(x_fig,(ev_p_sum_t_reform(1:n_fig)-1)*100,'color','b','LineWidth',2);
hold on
plot(x_fig,(ev_p_sum_rg_t_reform(1:n_fig)-1)*100,'-.','color','b','LineWidth',2);
hold off
axis tight
xlabel('Period T of Reform Implementation')
ylabel('Welfare Gain \omega (in Percent)')
gtext({'High Discount Rate';'Low Discount Rate'})
title(['Welfare Gains of Delaying the Reform (Utilitarian Planner)'])

print( '-dpng', '-r300', ['equivalence_variation_t_reform.png']);
print( '-depsc2', ['equivalence_variation_t_reform.eps']);

% 
% figure
% x_fig= 2013:2400;
% plot(x_fig,ev_p_sum_t_reform(x_fig-year_start+1),'color','b','LineWidth',2);
% hold on
% plot(x_fig,ev_p_sum_rg_t_reform(x_fig-year_start+1),'-.','color','b','LineWidth',2);
% hold off
% axis tight
% xlabel('year')
% title(['Equivalence Variation'])
% 
% 
% print( '-dpng', '-r300', ['equivalence_variation_t_reform_2400.png']);
% print( '-depsc2', 'equivalence_variation_t_reform_2400.eps');
