 

% PAYGO reform expected in 2000


clear;
clear global;
close all;
tic

%% ----------------- 1. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

% name_data_2000='..\Pension34.1_1992_ConstantBeta_111103\data_benchmark.mat';
name_data_2000='../Pension1_BaselineScenario/data_benchmark.mat';


load(name_data_2000);

name_exp='paygo';
name_data_exp='data_paygo.mat';


index_fixedlabor=0; 
index_gtext=0;


%% ---------------- 2. Solve for Long-run Replacement Rate ----------------
name_data_bm=name_data_2000;
year_reform=2013;
t_reform=1+year_reform-year_start;

index_guess=0;
name_data_eq='data_eq_paygo.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'tau_subsidy'); % initial
% tau_subsidy=0.0043;

tol_setting_accurate;
solve_tau_subsidy_update_pe; % calculate the tax rate subsidy into the pension system (due to initial asset, given 20% tax rate)


disp('Dynamic computation finished')
toc
% save(name_data_eq,'H_p_t','H_np_t','p_base_t','tau_w_ss');

% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;




%% ----------------- 3. Pension Reform Experiment Outcomes ------------------------

experiment_paygo;     % current system
disp('Experiment_fullyfunded finished')
toc
