 

% fully funded reform is expected by households in 2000


clear;
clear global;
close all;
tic

%% ----------------- 1. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

index_mac=1;
if index_mac==1
    name_data_2000='../Pension1_BaselineScenario/data_benchmark.mat';
else
    name_data_2000='..\Pension1_BaselineScenario\data_benchmark.mat';
end
% load everything from benchmark 2000
load(name_data_2000); 

name_exp='fullyfunded';
name_data_exp='data_fullyfunded.mat';



index_fixedlabor=0; 
index_gtext=0;

% -------fully funded adjust initial state --------------
name_data_bm=name_data_2000;
year_reform=2013;
t_reform=1+year_reform-year_start;
initialstate_adjust2_fullyfunded; % using data_bm2 adjust the wealth and government debt according to the pension promise
pensionsystem_adjust_fullyfunded;


%% ---------------- 2. Solve for Long-run Replacement Rate ----------------

index_guess=0;
name_data_eq='data_eq_fullyfunded.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'tau_w_ss'); % initial


tol_setting_accurate;
solve_tau_w_update_pe;


disp('Dynamic computation finished')
toc
% save(name_data_eq,'H_p_t','H_np_t','p_base_t','tau_w_ss');

% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;




%% ----------------- 3. Pension Reform Experiment Outcomes ------------------------



experiment_fullyfunded;     % current system
disp('Experiment_fullyfunded finished')
toc

