% calculate the growing like china model
% make psi decrease over time and relax financial borrowing gradually

% ! remember to check diff_Ag_transfer and let it converge
% date back to 1922....

clear;
clear global;
close all;
tic

%% ----------------- 0. Setup ---------------------------------

global_claim;  % global variables

% some useful indexes
index_fixedlabor_rural=1;
index_pre=1;
index_Ag_transfer_guess=0; % guess or read Ag_transfer from data
index_guess=0;
index_gtext=0;

i_fig=0;

names_data_fig; % decide the names of data and figures

% parameters that do not depend on year
parameters_basic;

% set the parameters (e.g. population, death rate) if the economy starts from 2000
parameters_t_2000; 

adjust_prod_kpr; % before parameters_rural, so remember to change hr in parameters_rural

% pension and tax that matter for the equilibrium price
pensionsystem_2000; % current system, tau_w_ss=0.2; tau_

% rural model
parameters_rural;
pensionsystem_rural_2000;

% foreign surplus and things that we want to match or get from the data
parameters_data_2000;


%% -------------- 1. the rural model --------------

solve_Hr_update; % update Hr to solve the rural model

pension_debt_coh_rural;

%% ---------------- 2. loop g_extra_ini and T_g_extra to match g_yw and GDPpc, CN/US --------------
t_reform=2013-year_start+1; % year_start is defined in parameters_t_xxxx.m

name_exp='benchmark';

tol_g_extra=1e-3;
tol_ae1=1e-3;
tol_replace_w_coh3=1e-3;
tol=1e-3;

loop_g_extra; % TFP growth and also beta



% why do we need it for two times? not quite understood yet
% solve_ae1_update;

%% -------------- 3. experiment and all variables ------------
% most variables and experiments already done in solving the equilibrium
experiment_benchmark;
save(name_data_exp);

%% ------------- 4. Figures and Statistics ----------------
fig_name='benchmark';
name_fig_title='Benchmark';
name_fig_title2='';
index_fig=1;
if index_fig==1
figures_eq;
figures_pension_coh;
figures_sz;
figures_GDP;
% figures_temp;
end


disp('HE/H')
ratio_HE_H=HE_t(1:30)./H_t(1:30)

for t_fig=[11 101]
i_fig=i_fig+1;
figure(i_fig)

x_fig=year_start:year_start+t_fig-1;
subplot(3,2,1)
plot(x_fig,Ag_t(1:t_fig)./Yur_t(1:t_fig),'color','k','LineWidth',2)
% hold on
% plot(x_fig,gap_BYur_t(1:t_fig).*Yur_t(1:t_fig)./KF_t(1:t_fig),'color','k','LineWidth',2)
% hold off
axis tight
title('Total Government Wealth/ GDP')
subplot(3,2,2)
plot(1999+[1:t_fig],Sg_t(1:t_fig)./Yur_t(1:t_fig),'LineWidth',2)
axis tight
title('Total Government Savings / GDP')
subplot(3,2,3)
plot(x_fig,Aw_t(1:t_fig)./Yur_t(1:t_fig),'color','b','LineWidth',2)
hold on
plot(x_fig,(Ae_t(1:t_fig)-AE_t(1:t_fig))./Yur_t(1:t_fig),'color','k','LineWidth',2)
hold on
plot(x_fig,AE_t(1:t_fig)./Yur_t(1:t_fig),'color','r','LineWidth',2)
hold off
axis tight
title('Worker, Manager, Entrepreneur Asset / GDP')
subplot(3,2,4)
plot(x_fig,w_t(2:t_fig+1)./w_t(1:t_fig)-1+g,'LineWidth',2)
hold on
plot(x_fig,(ave_yw_t(2:t_fig+1)./ave_prod_t(2:t_fig+1))./(ave_yw_t(1:t_fig)./ave_prod_t(1:t_fig))-1+g,'color','r','LineWidth',2)
axis tight
title('Growth of Wage and Average Labor Earning')

subplot(3,2,5)
plot(x_fig,(I_t(1:t_fig)+Ir_t(1:t_fig)+Ig_t(1:t_fig))./Yur_t(1:t_fig),'LineWidth',2)
hold on
plot(year_start-1+[1:(t_fig)],(S_t(1:t_fig)+Sr_t(1:t_fig)+Sg_t(1:t_fig))./Yur_t(1:t_fig),'color','k','LineWidth',2)
hold off
axis tight
title('Investment Rate and Saving Rate')
% subplot(3,2,6)
% plot(1999+[1:21],HE_t(1:21)./H_t(1:21),'LineWidth',2)
% axis tight
% title('E firm Labor')
subplot(3,2,6)
plot(1999+[1:(t_fig)],(Sp_t(1:t_fig)+Sp_r_t(1:t_fig))./Yur_t(1:t_fig),'LineWidth',2)
hold on
plot(1999+[1:(t_fig)],(Sp_t(1:t_fig)+Sp_r_t(1:t_fig)+Sg_t(1:t_fig))./Yur_t(1:t_fig),'color','k','LineWidth',2)
% hold on
% plot(1999+[1:(t_fig)],(Sh_t(1:t_fig)+Sh_r_t(1:t_fig)+Sf_t(1:t_fig)+Sf_r_t(1:t_fig)+Sg_t(1:t_fig)+Sg_r_t(1:t_fig))./Yur_t(1:t_fig),'color','r','LineWidth',2)
hold off
% axis([2000,1999+t_fig,0,0.6])
axis tight
title('Saving Decomposition: Priv, Gov')
print( '-dpng', '-r300', ['Targets_' num2str(1999+t_fig) '.png']);
print( '-depsc2', '-r300', ['Targets_' num2str(1999+t_fig) '.eps']);

i_fig=i_fig+1;
figure(i_fig)
plot(1999+[1:t_fig],B_t(1:t_fig)./Yur_t(1:t_fig),'LineWidth',2)
title('Foreign Reserve')
print( '-dpng', '-r300', ['ForeignReserve_' num2str(1999+t_fig) '.png']);
print( '-depsc2', '-r300', ['ForeignReserve_' num2str(1999+t_fig) '.eps']);
end

% % Ag_transfer_old is set to the previous Ag_transfer in pensionsystem_2000
% diff_Ag_transfer=(Ag_transfer-Ag_transfer_old)/Ag_transfer
% display('Wage Growth')
% w_t(2:11)./w_t(1:10)

