
% special for benchmark 2013, include p_base_t_pre_t updating

% a script to update w_t AE_t

% notice that YE means after-tax output
% later when we calculate Y, we have Y=(YE+YF)/(1-tau_g)

%% --------------------- 1. Initialization ---------------------

H_AE_t_new=zeros(1,2*t_dyn);
H_p_t=H_AE_t(1:t_dyn);
H_np_t = H_AE_t(t_dyn+1:2*t_dyn);
AE_t=H_AE_t(2*t_dyn+1:3*t_dyn);

H_t=H_p_t+H_np_t;


% useful later

RE_t(t_dyn+1:t_end)=RE_ss;
me_t(t_dyn+1:t_end)=me_ss;
tau_e_t(t_dyn+1:t_end)=tau_e_ss;
replace_e_t(t_dyn+1:t_end)=replace_e_ss;


%% --------------------- 2. Equilibrium, Given H_t, AE_t -----------------
% for t=1:t_dyn
for t=1:t_dyn
    

if chi_t(t)<(1/(1-psai_t(t)))^(1/(1-alp))
    display(['Warning: chi<chi_bar at t=' num2str(t)])
    pause;
end



% -- 5 cases for AE, seperated by 4 AEi --

% --- 1. AE1_t(t) makes the Entrepreneur's labor employment just equal to H_t(t)
w1_t(t)=alp^(alp/(1-alp))*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_t(t))*(rl_t(t)+dep)^(-alp/(1-alp));
rho1_t(t)=(1-psai_t(t))^(1/alp)*chi_t(t)^((1-alp)/alp)*(rl_t(t)+dep)-dep;
KE1_t(t)=(1-psai_t(t))^(-1/alp)*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_t(t))*chi_t(t)^(-(1-alp)/alp)*(rl_t(t)+dep)^(-1/(1-alp))*H_t(t); % back out KE using H_t(t) and MPL
AE1_t(t)=KE1_t(t)/(1+eta_t(t)*(1+rho1_t(t))/(1+rl_t(t)-eta_t(t)*(1+rho1_t(t)))); % full borrowing

if AE_t(t)<=AE1_t(t)
%% ---- case 1, AE_t(t)<=AE1_t(t), HE_t(t)<=H_t(t), wage determined by F firm ----
    w_t(t)=alp^(alp/(1-alp))*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_t(t))*(rl_t(t)+dep)^(-alp/(1-alp));
    rho_t(t)=(1-psai_t(t))^(1/alp)*chi_t(t)^((1-alp)/alp)*(rl_t(t)+dep)-dep;
    KE_t(t)=(1+eta_t(t)*(1+rho_t(t))/(1+rl_t(t)-eta_t(t)*(1+rho_t(t))))*AE_t(t);
    KE_prod_t(t)=KE_t(t);
    HE_t(t)=(1-psai_t(t))^(1/alp)*alp^(-1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_t(t))^(-1)*chi_t(t)^((1-alp)/alp)*(rl_t(t)+dep)^(1/(1-alp))*KE_t(t);
    YE_t(t)=KE_t(t)^alp*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*HE_t(t)^(1-alp);
    m_t(t)=psai_t(t)*YE_t(t);
    case_t(t)=1;
    


    
else % AE_t(t)>AE1_t(t)
% --- 2. AE2_t(t): rho just equals rl_t(t) when full borrowing
rho2_t(t)=rl_t(t);
KE2_t(t)=(1-psai_t(t))^(1/(1-alp))*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_t(t))*chi_t(t)*H_t(t)*(rl_t(t)+dep)^(-1/(1-alp));
AE2_t(t)=KE2_t(t)/(1+eta_t(t)*(1+rho2_t(t))/(1+rl_t(t)-eta_t(t)*(1+rho2_t(t))));
% check(2)=(1-psai_t(t))*alp*(AE2_t(t)*(1+eta_t(t)*(1+rho2_t(t))/(1+rl_t(t)-eta_t(t)*(1+rho2_t(t)))))^(alp-1)*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*H_t(t)^(1-alp)-dep - rl_t(t);
if AE_t(t)<=AE2_t(t)
%% ---- case 2, AE1_t(t)<AE<=AE2_t(t), HE_t(t)=H, wage determined by E firm, rho_t(t)>=rl_t(t)
    HE_t(t)=H_t(t);
    % rho_t(t) solve the following equation
    if t==1
        rho_ini=rl_t(t)*1.01;
    else
        rho_ini=rho_t(t-1);
    end
    fun_rho_givenp=@(rho)fun_rho(rho,AE_t(t),HE_t(t),rl_t(t),((1-tau_g)^(1/(1-alp))*Z_t(t)),chi_t(t),psai_t(t),eta_t(t));
%     options = optimset('Display','off');
    options = optimset('Display','off','TolFun',1e-30);
    rho_t(t)=fsolve(fun_rho_givenp,rho_ini,options);
    KE_t(t)=(1+eta_t(t)*(1+rho_t(t))/(1+rl_t(t)-eta_t(t)*(1+rho_t(t))))*AE_t(t);
    KE_prod_t(t)=KE_t(t);
    w_t(t)=(1-psai_t(t))*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*KE_t(t)^alp*HE_t(t)^(-alp);
    YE_t(t)=KE_t(t)^alp*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*HE_t(t)^(1-alp);
    m_t(t)=psai_t(t)*YE_t(t);
    case_t(t)=2;

    
else % AE>AE2
% --- 3. AE3_t(t): rho just equals rl_t(t) when no borrowing
rho3_t(t)=rl_t(t);
KE3_t(t)=(1-psai_t(t))^(1/(1-alp))*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_t(t))*chi_t(t)*H_t(t)*(rl_t(t)+dep)^(-1/(1-alp));
AE3_t(t)=KE3_t(t);
% check(3)=(1-psai_t(t))*alp*AE3_t(t)^(alp-1)*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*H_t(t)^(1-alp)-dep - rl_t(t);
if AE_t(t)<=AE3_t(t)
%% ---- case 3, AE2_t(t)<AE<=AE3_t(t), HE_t(t)=H, rho_t(t)=rl_t(t)
    HE_t(t)=H_t(t);
    rho_t(t)=rl_t(t);
    KE_t(t)=(1-psai_t(t))^(1/(1-alp))*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_t(t))*chi_t(t)*H_t(t)*(rl_t(t)+dep)^(-1/(1-alp));
    KE_prod_t(t)=KE_t(t);
    w_t(t)=(1-psai_t(t))*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*KE_t(t)^alp*HE_t(t)^(-alp);
    YE_t(t)=KE_t(t)^alp*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*HE_t(t)^(1-alp);
%     m_t(t)=psai_t(t)*KE_t(t)^alp*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*HE_t(t)^(1-alp);
    m_t(t)=psai_t(t)*YE_t(t);
    case_t(t)=3;
%     check(7)=(1-psai_t(t))*alp*KE_t(t)^(alp-1)*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*HE_t(t)^(1-alp)-dep - rl_t(t);
    
    
    
else % AE>AE3
% --- 4. AE4_t(t): rho just equals r when no borrowing
rho4_t(t)=r;
KE4_t(t)=(1-psai_t(t))^(1/(1-alp))*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_t(t))*chi_t(t)*H_t(t)*(r+dep)^(-1/(1-alp));
AE4_t(t)=KE4_t(t);

% if AE_t(t)<=AE4_t(t)
% if AE_t(t)<=AE4_t(t) || case_t(t+1)==4  % assume monotonicity
if AE_t(t)<=AE4_t(t)  % assume monotonicity
%% ---- case 4, AE3_t(t)<AE_t(t)<=AE4_t(t), HE_t(t)=H, r<=rho_t(t)<rl_t(t)
    HE_t(t)=H_t(t);
    KE_t(t)=AE_t(t);
    w_t(t)=(1-psai_t(t))*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*KE_t(t)^alp*HE_t(t)^(-alp);
    rho_t(t)=(1-psai_t(t))*alp*KE_t(t)^(alp-1)*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*HE_t(t)^(1-alp) - dep;
    YE_t(t)=KE_t(t)^alp*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*HE_t(t)^(1-alp);

    m_t(t)=psai_t(t)*YE_t(t);
    case_t(t)=4;

    KE_prod_t(t)=KE_t(t);
    KE_stor_t(t)=0;
    
    
else % AE>AE4
%% ---- case 5, AE_t(t)>AE4_t(t), HE_t(t)=H, rho_t(t)=r
    HE_t(t)=H_t(t);
    rho_t(t)=r;
    KE_t(t)=AE_t(t);
    KE_prod_t(t)=(1-psai_t(t))^(1/(1-alp))*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_t(t))*chi_t(t)*HE_t(t)*(r+dep)^(-1/(1-alp));
    
    w_t(t)=(1-psai_t(t))^(1/(1-alp))*alp^(alp/(1-alp))*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_t(t))*chi_t(t)*(r+dep)^(-alp/(1-alp));
%     YE_t(t)=KE_prod_t(t)^alp*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*HE_t(t)^(1-alp)+KE_stor_t(t)*r;
    YE_t(t)=KE_prod_t(t)^alp*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*HE_t(t)^(1-alp); % KE_stor_t*r is not in GDP but in GNP
    m_t(t)=psai_t(t)*KE_prod_t(t)^alp*((1-tau_g)^(1/(1-alp))*Z_t(t))^(1-alp)*chi_t(t)^(1-alp)*HE_t(t)^(1-alp);
    case_t(t)=5;


end % end of AE<AE4    
end % end of AE<AE3   
end % end of AE<AE2
end % end of AE<AE1
    

% RE, return of savings
RE_t(t)=((1+rho_t(t))*KE_t(t) - (1+rl_t(t))*(KE_t(t)-AE_t(t)))/AE_t(t);

% if AE1_t(t)>AE2_t(t) || AE2_t(t)>AE3_t(t) || AE3_t(t)>AE4_t(t) 
%     disp('error for AE1_t(t) AE2_t(t) AE3_t(t) AE4_t(t)');
%     AE1_t(t)
%     AE2_t(t)
%     AE3_t(t)
%     AE4_t(t)
%     pause
% end



p_base_t(t)=w_t(t)*H_p_t(t)/Nw_labor_p_t(t);


end % end of t loop
% error=w_t(1:t_dyn).*H_p_t(1:t_dyn)./Nw_labor_p_t(1:t_dyn)-p_base_t(1:t_dyn);

%%  ----- 3. Update H_t,  and h,H,w,HE,rho,m -----

% if strcmp(name_exp,'benchmark_2013')==1 || strcmp(name_exp,'benchmark')==1
% % given the new p_base_t, we can update the p_base_pre_t using g_p_base_pre_t
% % in order to make the p_base_jt smooth
% p_base_pre_t_old=p_base_pre_t;
% p_base_pre_t(T_pre)=p_base_t(1)/(1+g_p_base_pre_t(T_pre+1));
% for t=T_pre-1:-1:1
%     p_base_pre_t(t)=p_base_pre_t(t+1)/(1+g_p_base_pre_t(t+1));
% end
% disp('Difference of p_base_pre_t:')
% max(abs(p_base_pre_t-p_base_pre_t_old))
% end

workers_dyn;
if strcmp(name_exp,'drasticreform')==1 || strcmp(name_exp,'drasticreform_2100')==1 || strcmp(name_exp,'drasticreform_2040')==1
    % all the np workers become p workers
    workers_adjust_drasticreform;
%     aggregate_variable_adjust_drasticreform;
end

for t=1:t_dyn

% total labor supply
H_p_t_new(t)=sum(prod_jt(1:Jw-1,t).*h_p_t(1:Jw-1,t).*Nw_p_t(1:Jw-1,t));
H_np_t_new(t)=sum(prod_jt(1:Jw-1,t).*h_np_t(1:Jw-1,t).*Nw_np_t(1:Jw-1,t));
H_t_new(t)=H_p_t(t)+H_np_t(t);

ave_h_p_t(t)=sum(h_p_t(1:Jw-1,t).*Nw_p_t(1:Jw-1,t))/sum(Nw_p_t(1:Jw-1,t));
ave_h_np_t(t)=sum(h_np_t(1:Jw-1,t).*Nw_np_t(1:Jw-1,t))/sum(Nw_np_t(1:Jw-1,t));
ave_h_t(t)=sum(h_p_t(1:Jw-1,t).*Nw_p_t(1:Jw-1,t)+h_np_t(1:Jw-1,t).*Nw_np_t(1:Jw-1,t))/sum(Nw_p_t(1:Jw-1,t)+Nw_np_t(1:Jw-1,t));

% (pre-tax) average income of workers in pension system
   
end

if strcmp(name_exp,'drasticreform')==1 || strcmp(name_exp,'drasticreform_2100')==1 || strcmp(name_exp,'drasticreform_2040')==1
    % all the np workers become p workers
%     workers_adjust_drasticreform;
    H_t_adjust_drasticreform;
end


KE_stor_t(1:t_dyn)=KE_t(1:t_dyn)-KE_prod_t(1:t_dyn);

%% ------------------- 4. Update ae,AE --------------------------

pe_t(1:t_dyn)=replace_e_t(1:t_dyn).*p_base_t(1:t_dyn);
pe_t(t_dyn+1:t_end)=replace_e_ss*p_base_ss;

% m_t is the total payment to the management
% me_t is the income of per manager
me_t(1:t_dyn)=m_t(1:t_dyn)./Ne_labor_t(1:t_dyn);
% me_t(1+t_dyn:t_end) is defined as me_ss

% solve the entrepreneur households' saving problem
% those already exist in period 1
t=1;
for j=1:J % j is the age in period 1
    coh=J-j+1;
    Length=J-j+1;
    if j<Je
        Interest(1:Je-j)=1+r;
        Interest(Je-j+1:J-j+1)=RE_t(Je-j+1:J-j+1);
        Inc(1:Je-j)=(1-tau_e_t(1:Je-j)).*me_t(1:Je-j);
        Inc(Je-j+1:J-j+1)=pe_t(Je-j+1:J-j+1);
    else
        Interest(1:J-j+1)=RE_t(1:J-j+1);
        Inc(1:J-j+1)=pe_t(1:J-j+1);
    end
    Labor=zeros(1,Length);
%     Surv(1)=1;
%     for l=2:Length
%         Surv(l)=lam_jt(j+l-1,l);
%     end
    Surv(1:Length)=lam_jcoh(j:j+Length-1,coh);
    Asset_ini=ae_t(j,1);
    [ce_j,ae_j]=fun_c_a_j_fixlabor(bet_e_coh(coh),Length, Interest, Inc,  Surv, Asset_ini);
    % put ce_j, ae_j into ce_t, ae_t
    for l=1:Length
        ce_t(j+l-1,l)=ce_j(l);
        ae_t(j+l-1,l)=ae_j(l);
        ye_t(j+l-1,l)=Inc(l);
    end
end

% those born in period t>1
for t=2:t_dyn
    Length=J;
    coh=J+t-1;
    Interest(1:Je-1)=1+r;
    Interest(Je:J)=RE_t(t+Je-1:t+J-1);
    Inc(1:Je-1)=(1-tau_e_t(t:t+Je-2)).*me_t(t:t+Je-2);
    Inc(Je:J)=pe_t(t+Je-1:t+J-1);
    Labor=zeros(1,Length);
%     Surv(1)=1;
%     for l=2:Length
%         Surv(l)=lam_jt(l,t+l-1);
%     end
    Surv(1:Length)=lam_jcoh(1:Length,coh);
    Asset_ini=0;
    [ce_j,ae_j]=fun_c_a_j_fixlabor(bet_e_coh(coh),Length, Interest, Inc,  Surv, Asset_ini);
    % put ce_j, ae_j into ce_t, ae_t
    for l=1:Length
        ce_t(l,t+l-1)=ce_j(l);
        ae_t(l,t+l-1)=ae_j(l);
        ye_t(l,t+l-1)=Inc(l);
    end
    
    
    
end


% check AE
for t=1:t_dyn
    AE_t_new(t)=ae_t(Je:J,t)'*Ne_t(Je:J,t);
%     AE_t_new(t)=(abs(ae_t(Je:J,t))+ae_t(Je:J,t))'/2*Ne_t(Je:J,t);
end

% yy(1+2*t_dyn:3*t_dyn)=AE_t_new(1:t_dyn)-AE_t(1:t_dyn);
% yy(1+1*t_dyn:2*t_dyn)=AE_t_new(1:t_dyn);
H_AE_t_new(1:t_dyn)=H_p_t_new(1:t_dyn);
H_AE_t_new(t_dyn+1:2*t_dyn)=H_np_t_new(1:t_dyn);
H_AE_t_new(1+2*t_dyn:3*t_dyn)=AE_t_new(1:t_dyn);


H_AE_t_new-H_AE_t;
% aaa=1+1;



