
%% ------------ Labor ------------
% aggregat labor unit (different from aggregate labor supply)
for t=1:t_dyn
    agg_prod_t(t)=prod_jt(1:Jw-1,t)'*Nw_t(1:Jw-1,t);
    agg_prod_r_t(t)=prod_jt(1:Jw-1,t)'*Nr_t(1:Jw-1,t); % rural
end




%% ----------- 1. GDP and Growth -----------------
for t=1:t_dyn
    if case_t(t)==0 || case_t(t)==1
        HF_t(t)=H_t(t)-HE_t(t);
        KF_t(t)=(alp/(rl_t(t)+dep))^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_t(t))*HF_t(t);
        YF_t(t)=KF_t(t)^alp*(((1-tau_g)^(1/(1-alp))*Z_t(t))*HF_t(t))^(1-alp);
    else
        HF_t(t)=0;
        KF_t(t)=0;
        YF_t(t)=0;
    end
end


Y_t=(YE_t+YF_t)/(1-tau_g); % YE YF are after-tax output, Y is GDP

% y_t(1:t_dyn)=Y_t(1:t_dyn)./N_total_t(1:t_dyn); % N starts from age_ini
y_t(1:t_dyn)=Y_t(1:t_dyn)./pop_total_t(1:t_dyn);
% y_pw_t(1:t_dyn)=Y_t(1:t_dyn)./Nw_labor_t(1:t_dyn);
y_pw_t(1:t_dyn)=Y_t(1:t_dyn)./pop_labor_t(1:t_dyn);
% output per productivity - efficient unit labor
y_pprod_t(1:t_dyn)=Y_t(1:t_dyn)./agg_prod_t(1:t_dyn);




for t=2:t_dyn
    growth_Y_t(t)=Y_t(t)/Y_t(t-1)-1;
    growth_y_t(t)=y_t(t)/y_t(t-1)-1;
    growth_y_pw_t(t)=y_pw_t(t)/y_pw_t(t-1)-1;
end

span_ma=11;
growth_Y_t_ma(2:t_dyn)=smooth(growth_Y_t(2:t_dyn),span_ma,'moving');
growth_y_t_ma(2:t_dyn)=smooth(growth_y_t(2:t_dyn),span_ma,'moving');
growth_y_pw_t_ma(2:t_dyn)=smooth(growth_y_pw_t(2:t_dyn),span_ma,'moving');


%% ------------ Loans ------------
LE_t=KE_t-AE_t; % to E firm
L_t=LE_t+KF_t; % total urban loan




%% ----------- 2. Aggregate Variables -------------------
% aggregate labor income
Yw_t=w_t(1:t_dyn).*H_t(1:t_dyn);
% aggregate (productive) capital
K_t=KF_t+KE_prod_t;

for t=1:t_dyn
    Ae_t(t)=ae_t(1:J,t)'*Ne_t(1:J,t);
    % Asset about to be brought into E firm
    Ae_49_t(t)=ae_t(Je-1,t)*Ne_t(Je-1,t);
end


