

%% -------------------------- graph for fabrizio ----------------------------

% 
%% ------------
for t_fig=[41 51 101]; % 2000-2040

figure;
x_fig=year_start_data:year_start_data+t_fig-1;

subplot(2,1,1)
plot(x_fig,gdp_CN1(t_start_data:t_start_data+t_fig-1)./gdp_US(t_start_data:t_start_data+t_fig-1),'LineWidth',1.5);
hold on 
plot(x_fig(1:t_end_data),data_gdp_CN1(1:t_end_data)./data_gdp_US(1:t_end_data), 'color','r','LineWidth',1.5);
hold off
axis tight
title('GDP Relative to US')

subplot(2,1,2)
plot(x_fig,gdppc_CN1(t_start_data:t_start_data+t_fig-1)./gdppc_US(t_start_data:t_start_data+t_fig-1),'LineWidth',1.5);
hold on
plot(x_fig(1:t_end_data),data_gdppc_CN1(1:t_end_data)./data_gdppc_US(1:t_end_data), 'color','r','LineWidth',1.5);
hold off

axis tight
title('GDPpc Relative to US')
print( '-dpng', '-r300', ['gdp_gdppc_CN1_2000_' num2str(year_start_data+t_fig-1)  '.png']);
% print( '-depsc2', ['gdp_gdppc_CN1_US_2000_' num2str(year_start_data+t_fig-1)  '.eps']);


subplot(2,1,1)
plot(x_fig,gdp_CN2(t_start_data:t_start_data+t_fig-1)./gdp_US(t_start_data:t_start_data+t_fig-1),'LineWidth',1.5);
hold on 
plot(x_fig(1:t_end_data),data_gdp_CN2(1:t_end_data)./data_gdp_US(1:t_end_data), 'color','r','LineWidth',1.5);
hold off
axis tight
title('GDP Relative to US')

subplot(2,1,2)
plot(x_fig,gdppc_CN2(t_start_data:t_start_data+t_fig-1)./gdppc_US(t_start_data:t_start_data+t_fig-1),'LineWidth',1.5);
hold on
plot(x_fig(1:t_end_data),data_gdppc_CN2(1:t_end_data)./data_gdppc_US(1:t_end_data), 'color','r','LineWidth',1.5);
hold off

axis tight
title('GDPpc Relative to US')
print( '-dpng', '-r300', ['gdp_gdppc_CN2_2000_' num2str(year_start_data+t_fig-1)  '.png']);
print( '-depsc2', ['gdp_gdppc_CN2_US_2000_' num2str(year_start_data+t_fig-1)  '.eps']);

end

%% -------------------------------  GDP growth and GDP US --------------------------
load data_benchmark growth_yur_t_ma growth_yur_pw_t_ma g 

index_gtext=0;


figure
subplot(2,1,1)
    plot(x_fig(2:t_fig),g+growth_yur_t_ma(2:t_fig),'color','b','LineWidth',2);
    hold on
    plot(x_fig(2:t_fig),g+growth_yur_pw_t_ma(2:t_fig),'-.','color','b','LineWidth',2);
    hold off
xlabel('Time')
ylabel('Annual Growth Rate')
title('GDPpc and GDPpw growth')
axis tight
if index_gtext==1
gtext({'GDPpc';'GDPpw'})
end
subplot(2,1,2)
% plot(x_fig,gdppc_CN2(t_start_data:t_start_data+t_fig-1),'LineWidth',2);
semilogy(x_fig,gdppc_CN2(t_start_data:t_start_data+t_fig-1),'LineWidth',2);
hold on
% plot(x_fig,gdppc_US(t_start_data:t_start_data+t_fig-1),'-.','LineWidth',2);
semilogy(x_fig,gdppc_US(t_start_data:t_start_data+t_fig-1),'-.','LineWidth',2);
hold off
set(gca,'YTick',[7500, 15000, 30000, 60000, 120000],'YTickLabel',{'7500', '15000', '30000', '60000', '120000'})
xlabel('Time')
ylabel('GDP per Capita (Log Scale)')
title('GDPpc: China and US')
axis tight
if index_gtext==1
gtext({'China';'US'})
end
% mtit('GDP per capita and GDP per worker dynamics','xoff',0,'yoff',0.04)
if index_gtext==1
print( '-dpng', '-r300', ['growth_pc_pw_cn_us.png']);
print( '-depsc2', ['growth_pc_pw_cn_us.eps']);
end


figure
subplot(2,1,1)
    plot(x_fig(2:t_fig),g+growth_yur_t_ma(2:t_fig),'color','b','LineWidth',2);
    hold on
    plot(x_fig(2:t_fig),g+growth_yur_pw_t_ma(2:t_fig),'-.','color','b','LineWidth',2);
    hold off
xlabel('Time')
ylabel('Annual Growth Rate')
title('GDPpc and GDPpw growth')
axis tight
if index_gtext==1
gtext({'GDPpc';'GDPpw'})
end
subplot(2,1,2)
% plot(x_fig,gdppc_CN2(t_start_data:t_start_data+t_fig-1),'LineWidth',2);
semilogy(x_fig,gdppc_CN1(t_start_data:t_start_data+t_fig-1),'LineWidth',2);
hold on
% plot(x_fig,gdppc_US(t_start_data:t_start_data+t_fig-1),'-.','LineWidth',2);
semilogy(x_fig,gdppc_US(t_start_data:t_start_data+t_fig-1),'-.','LineWidth',2);
hold off
set(gca,'YTick',[7500, 15000, 30000, 60000, 120000],'YTickLabel',{'7500', '15000', '30000', '60000', '120000'})
xlabel('Time')
ylabel('GDP per Capita (Log Scale)')
title('GDPpc: China and US')
axis tight
if index_gtext==1
gtext({'China';'US'})
end
% mtit('GDP per capita and GDP per worker dynamics','xoff',0,'yoff',0.04)
if index_gtext==1
print( '-dpng', '-r300', ['growth_pc_pw_cn_us.png']);
print( '-depsc2', ['growth_pc_pw_cn1_us.eps']);
end



