% since government merge their asset into pension system from the beginning
% we draw graph of -Ag instead of -Ag_pen or gov_debt

%% -------------------- New Figures for PAYGO, SZ requires -------------------

t_fig=111;


figure

subplot(3,1,1)
if year_start==2013
    bm=load(name_data_2000,'replace_w_coh','pension_total_t','tax_total_t','Nw_labor_p_t','Nw_retire_p_t','tau_w_t');
    bm2=load(name_data_compare,'replace_w_coh','pension_total_t','tax_total_t','Nw_labor_p_t','Nw_retire_p_t','tau_w_t');
    % year specific replacement rate
    bm.replace_w_t(1:t_dyn)=(bm.pension_total_t(1:t_dyn)./bm.Nw_retire_p_t(1:t_dyn))./(bm.tax_total_t(1:t_dyn)./bm.tau_w_t(1:t_dyn)./bm.Nw_labor_p_t(1:t_dyn));
    bm2.replace_w_t(1:t_dyn)=(bm2.pension_total_t(1:t_dyn)./bm2.Nw_retire_p_t(1:t_dyn))./(bm2.tax_total_t(1:t_dyn)./bm2.tau_w_t(1:t_dyn)./bm2.Nw_labor_p_t(1:t_dyn));
    year_start_bm=2000;
    dif_year=year_start-year_start_bm;
    x_fig=year_start_bm:year_start_bm+t_fig-1;
    plot(x_fig,[bm.replace_w_t(1:dif_year) replace_w_t(1:t_fig-dif_year)],'LineWidth',2)
    hold on
    plot(x_fig,[bm.replace_w_t(1:dif_year) bm2.replace_w_t(1:t_fig-dif_year)],'-.','LineWidth',2)
    hold off
    axis([x_fig(1) x_fig(t_fig) 0 1.5]);
%     axis tight;
end
if index_gtext==1
    gtext({'Benchmark';'PAYGO'})
end
xlabel('year')
title(['Panel a: Replacement rate by year'])
temp=[x_fig;replace_w_t(1:t_fig)]; % 1997 and 2013

subplot(3,1,2)
% present value of pension as a ratio of the year retire

if year_start==2013
    bm2=load(name_data_compare,'pw_sum_coh','p_base_pre_t','p_base_t');
    bm2.p_base_retire_coh=[bm2.p_base_pre_t(T_pre-J+Jw:T_pre) bm2.p_base_t(1:t_dyn)];
    p_base_retire_coh=[p_base_pre_t(T_pre-J+Jw:T_pre) p_base_t(1:t_dyn)];
        
    coh_fig=151;
    x_fig=year_start-J+Jw:year_start-J+Jw+coh_fig-1;
    plot(x_fig,[pw_sum_coh(1:coh_fig)./p_base_retire_coh(1:coh_fig)],'LineWidth',2)
    hold on
    plot(x_fig,[bm2.pw_sum_coh(1:coh_fig)./bm2.p_base_retire_coh(1:coh_fig)],'-.','LineWidth',2)
    hold off
    axis([x_fig(1) x_fig(coh_fig) 0 ceil(max(pw_sum_coh(1:coh_fig)./p_base_retire_coh(1:coh_fig))/10)*10]);
%     axis('tight');
    if index_gtext==1
        gtext({'Benchmark';'PAYGO'})
    end
end
xlabel('year')
title(['Panel b: lifetime pension / average wage in the year of retirement, by cohort'])


subplot(3,1,3)
year_fig_start=2000;
coh_fig_start=1+(J-Jw)+(year_fig_start-year_start);
x_fig=year_fig_start:year_fig_start+t_fig-1;
plot(x_fig,ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1),'color','b','LineWidth',2);
hold on
plot(x_fig,ev_np_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','b','LineWidth',2)
hold off
y_min=floor(min(ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*10)/10;
y_max=ceil(max(ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*10)/10;
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
% axis tight
% legend('pension','without pension')
xlabel('year')
title(['Panel c: Welfare gain (equiv. variation) by year of retirement: ' name_fig_title])

if index_gtext==1 % no gtext, no need to save graphs
    print('-dpng','-r300',['pension_' fig_name  '.png'])
    print('-depsc2',['pension_' fig_name '.eps'])
end





%% --------------------- Old Figures, for reference ------------------------


for t_fig=[111]


figure

subplot(3,1,1)
if year_start==2000
    x_fig=year_start-(J-Jw):year_start-(J-Jw)+coh_fig-1;
    plot(x_fig,replace_w_coh(1:coh_fig),'LineWidth',2)
    axis([x_fig(1) x_fig(coh_fig) 0.2 0.8]);
elseif year_start==2013
    bm=load(name_data_2000,'replace_w_coh','pension_total_t','tax_total_t','Nw_labor_p_t','Nw_retire_p_t','tau_w_t');
    bm2=load(name_data_compare,'replace_w_coh','pension_total_t','tax_total_t','Nw_labor_p_t','Nw_retire_p_t','tau_w_t');
    % year specific replacement rate
    bm.replace_w_t(1:t_dyn)=(bm.pension_total_t(1:t_dyn)./bm.Nw_retire_p_t(1:t_dyn))./(bm.tax_total_t(1:t_dyn)./bm.tau_w_t(1:t_dyn)./bm.Nw_labor_p_t(1:t_dyn));
    bm2.replace_w_t(1:t_dyn)=(bm2.pension_total_t(1:t_dyn)./bm2.Nw_retire_p_t(1:t_dyn))./(bm2.tax_total_t(1:t_dyn)./bm2.tau_w_t(1:t_dyn)./bm2.Nw_labor_p_t(1:t_dyn));
    year_start_bm=2000;
    dif_year=year_start-year_start_bm;
    x_fig=year_start_bm:year_start_bm+t_fig-1;
    plot(x_fig,[bm.replace_w_t(1:dif_year) replace_w_t(1:t_fig-dif_year)],'LineWidth',2)
    hold on
    plot(x_fig,[bm.replace_w_t(1:dif_year) bm2.replace_w_t(1:t_fig-dif_year)],'-.','LineWidth',2)
    hold off
    axis([x_fig(1) x_fig(t_fig) 0.2 1.5]);
end
xlabel('year')
title(['Panel a: Replacement rate by year'])
temp=[x_fig;replace_w_t(1:t_fig)]; % 1997 and 2013

subplot(3,1,2)
if year_start==2000
    x_fig=year_start:year_start+t_fig-1;
%     plot(x_fig,tax_total_t(1:t_fig)./Y_t(1:t_fig),'LineWidth',2)
%     plot(x_fig,tax_total_t(1:t_fig)./Yur_t(1:t_fig),'LineWidth',2)
    plot(x_fig,(tax_total_t(1:t_fig)+tax_total_r_t(1:t_fig))./Yw_t(1:t_fig),'LineWidth',2)
    hold on 
%     plot(x_fig,pension_total_t(1:t_fig)./Y_t(1:t_fig),'color','k','LineWidth',2)
%     plot(x_fig,pension_total_t(1:t_fig)./Yur_t(1:t_fig),'color','k','LineWidth',2)
    plot(x_fig,(pension_total_t(1:t_fig)+pension_total_r_t(1:t_fig))./Yw_t(1:t_fig),'color','k','LineWidth',2)
    hold off
elseif year_start==2013
    bm=load(name_data_2000,'tax_total_t','Yw_t','pension_total_t','pension_total_r_t');
    bm2=load(name_data_compare,'tax_total_t','Yw_t','pension_total_t','pension_total_r_t');
       
    x_fig=year_start_bm:year_start_bm+t_fig-1;
    plot(x_fig,[bm.tax_total_t(1:dif_year)./bm.Yw_t(1:dif_year) (tax_total_t(1:t_fig-dif_year)+tax_total_r_t(1:t_fig-dif_year))./Yw_t(1:t_fig-dif_year)],'LineWidth',2)
    hold on
%     plot(x_fig,tax_total_t_bm(1:t_fig)./Yw_t_bm(1:t_fig),'-.','LineWidth',2)
%     hold on
    plot(x_fig,[(bm.pension_total_t(1:dif_year)+bm.pension_total_r_t(1:dif_year))./bm.Yw_t(1:dif_year) (pension_total_t(1:t_fig-dif_year)+pension_total_r_t(1:t_fig-dif_year))./Yw_t(1:t_fig-dif_year)],'color','k','LineWidth',2)
    hold on
    plot(x_fig,[(bm.pension_total_t(1:dif_year)+bm.pension_total_r_t(1:dif_year))./bm.Yw_t(1:dif_year) (bm2.pension_total_t(1:t_fig-dif_year)+bm2.pension_total_r_t(1:t_fig-dif_year))./bm2.Yw_t(1:t_fig-dif_year)],'-.','color','k','LineWidth',2)
    hold off
end
hold off
% axis( 'auto y')
% axis([year_start year_start+t_fig-1 0.1 1]);
axis('tight');
xlabel('year')
% title('Tax Revenue / Urban GDP and Pension Payments / Urban GDP')
% if index_gtext==1
% gtext('Tax revenue')
% gtext('Expenditures, benchmark')
% gtext(['Expenditures, ' name_fig_title2])
% end
title('Panel b: Tax revenue and pension expenditures as shares of urban earnings')


subplot(3,1,3)
if year_start==2000
    x_fig=year_start:year_start+t_fig-1;
%     plot(x_fig,gov_debt_t(1:t_fig)./Y_t(1:t_fig),'LineWidth',2)
%     plot(x_fig,-Ag_t(1:t_fig)./Yur_t(1:t_fig),'LineWidth',2)
    plot(x_fig,-Ag_t(1:t_fig)./Yw_t(1:t_fig),'LineWidth',2)
elseif year_start==2013
    bm=load(name_data_2000,'Ag_t','Yw_t');
    bm2=load(name_data_compare,'Ag_t','Yw_t');
    x_fig=year_start_bm:year_start_bm+t_fig-1;
%     plot(x_fig,[gov_debt_t_bm(1:dif_year)./Y_t_bm(1:dif_year) gov_debt_t(1:t_fig-dif_year)./Y_t(1:t_fig-dif_year)],'LineWidth',2)
%     plot(x_fig,[-Ag_t_bm(1:dif_year)./Yur_t_bm(1:dif_year) -Ag_t(1:t_fig-dif_year)./Yur_t(1:t_fig-dif_year)],'LineWidth',2)
    plot(x_fig,[-bm.Ag_t(1:dif_year)./bm.Yw_t(1:dif_year) -Ag_t(1:t_fig-dif_year)./Yw_t(1:t_fig-dif_year)],'LineWidth',2)
    hold on
    plot(x_fig,[-bm.Ag_t(1:dif_year)./bm.Yw_t(1:dif_year) -bm2.Ag_t(1:t_fig-dif_year)./bm2.Yw_t(1:t_fig-dif_year)],'-.','LineWidth',2)
    hold off
end
% axis( 'auto y')
% axis([year_start year_start+t_fig-1])
axis('tight');
xlabel('year')
title('Panel c: Government debt as a share of urban earnings')
% if index_gtext==1
% gtext('Benchmark')
% gtext(initialcaps(name_fig_title2))
% end

% if index_gtext==1 % no gtext, no need to save graphs
%     print('-dpng','-r300',['pension_' fig_name  '_ykw.png'])
%     print('-depsc2',['pension_' fig_name '_ykw.eps'])
% end

end 
