% initial states in 2000


%% ---------------- 1. Get the Initial Wealth in 2000 -------------
t_pre_w_start=year_pre_w_start-year_pre_start+1; % workers' initial wealth in 1995 is taken from data

% initial wealth-income ratio  aw_yw_t_pre_w_start(1:J) given in parameters_data_2000
% calculate the weighted median income of working population in 1995 
weight_yw_labor_t_pre_w_start(1:Jw-1)=Nw_p_t(1:Jw-1,1)/sum(Nw_t(1:Jw-1,1));
weight_yw_labor_t_pre_w_start(Jw:Jw+Jw-1-1)=Nw_np_t(1:Jw-1,1)/sum(Nw_t(1:Jw-1,1));
yw_labor_t_pre_w_start(1:Jw-1)=yw_p_pre_t(1:Jw-1,t_pre_w_start);
yw_labor_t_pre_w_start(Jw:Jw+Jw-1-1)=yw_np_pre_t(1:Jw-1,t_pre_w_start);
med_yw_labor_t_pre_w_start=weightedMedian(yw_labor_t_pre_w_start,weight_yw_labor_t_pre_w_start);

% now we know the worker wealth in 1995
aw_t_pre_w_start(1:t_pre_w_start)=aw_med_yw_t_pre_w_start(1:t_pre_w_start)*med_yw_labor_t_pre_w_start;

t_pre_e_start=year_pre_e_start-year_pre_start+1; % entrepreneur wealth in 1995

% Two ways to get the initial wealth in 2000. 
% In the paper, we use the first one, that is, we calculate the worker and
% entrepreneur's problem from 1995 to get their endogenous wealth in 2000
if index_pre~=0;
    pre_transition_growth; % compute the agents' problem from 1995
    aw_p_t(1:J,1)=aw_p_pre_t(1:J,T_pre+1);
    aw_np_t(1:J,1)=aw_np_pre_t(1:J,T_pre+1);
    ae_t(1:J,1)=ae_pre_t(1:J,T_pre+1);
else
    % the alternative is to assume that their asset in 2000 is 1
    aw_p_t(1:J,1)=ones(J,1);
    aw_np_t(1:J,1)=ones(J,1);
    ae_t(1:J,1)=ones(J,1);
end


% aggregate asset of entrepreneurs owning E firms
AE_t(1)=ae_t(Je:J,1)'*Ne_t(Je:J,1); 
Aw_t(1)=aw_p_t(1:J,1)'*Nw_p_t(1:J,1)+aw_np_t(1:J,1)'*Nw_np_t(1:J,1);



%% ------------- 2. Initial Government Debt -----------------
gov_debt_t(1)=0;
