% use data from 2013 benchmark to calculate

%% ------------------- 1. The Promised Payment for existing cohorts ---------------------
bm2=load(name_data_bm2,'pw_jt', 'yw_p_t','tau_w_t');


% update the cohort existing in t=1, which is 2013
t=1;
for j=1:J % j is the age in period 1
    Length=J-j+1;
    coh=J-j+1;
    j_t_reform=j+t_reform-t; % age at t_reform
    l_t_reform=t_reform; % l at t_reform
    % survival rate to period xx
    Surv(1)=1;
    for l=2:Length
        Surv(l)=lam_jt(j+l-1,l);
    end
    % acc. survival rate to period l
    for l=1:Length
        Surv_prod(l)=prod(Surv(1:l));
    end
    % total pw_coh discounted to t=1
    pw_sum_coh_bm2(coh)=0;
    if j_t_reform<Jw
        for l=1+Jw-j:Length
            pw_sum_coh_bm2(coh)=pw_sum_coh_bm2(coh)+Surv_prod(l)*bm2.pw_jt(j+l-1,l)*((1+g)/(1+r))^(l-1); % t_start is updated in parameters_t_2013.m
        end
    else
        for l=l_t_reform:Length
            pw_sum_coh_bm2(coh)=pw_sum_coh_bm2(coh)+Surv_prod(l)*bm2.pw_jt(j+l-1,l)*((1+g)/(1+r))^(l-1); % t_start is updated in parameters_t_2013.m
        end
    end
    % unpaid tax
    tax_w_sum_coh_bm2(coh)=0;
    lw=Jw-j+1; % l=1, age=j, l=Jw-j+1, age=Jw
    for l=l_t_reform:lw-1 % pay tax before retirement
        tax_w_sum_coh_bm2(coh)=tax_w_sum_coh_bm2(coh)+Surv_prod(l)*bm2.yw_p_t(j+l-1,l)*bm2.tau_w_t(l)/(1-bm2.tau_w_t(l))*((1+g)/(1+r))^(l-1); % t_start is updated in parameters_t_2013.m
    end
end


% give this promise to them as assets
% workers retire before t_reform get a fraction according to their working years, net for
% unpaid tax
% workers retire after t_reform get a fraction according to their working
% years at t_reform

t=1;
for j=1:J
    coh=J-j+1;
    j_t_reform=j+t_reform-1;
    if j_t_reform>=Jw
        transfer_share_coh(coh)=1;
    else
        transfer_share_coh(coh)=(j_t_reform-1)/(Jw-1);
    end
    transfer_aw_p_coh(coh)=(pw_sum_coh_bm2(coh)-tax_w_sum_coh_bm2(coh))/(1+r)*transfer_share_coh(coh);
    aw_p_t(j,1)=aw_p_t(j,1)+transfer_aw_p_coh(coh);
end


%% ------------------ 2. The Promised Payment to Cohorts between born between t and t_reform ---------------------

j=1;
for t=2:t_reform
    
    Length=J;
    coh=J-j+t;
    j_t_reform=j+t_reform-t; % age at t_reform
    l_t_reform=j+t_reform-t; % l at t_reform
    % survival rate to period xx
    Surv(1)=1;
    for l=2:Length
        Surv(l)=lam_jt(j+l-1,t+l-1);
    end
    % acc. survival rate to period l
    for l=1:Length
        Surv_prod(l)=prod(Surv(1:l));
    end
    % total pw_coh discounted to t=1
    pw_sum_coh_bm2(coh)=0;
    if j_t_reform<Jw
        for l=1+Jw-j:Length
            pw_sum_coh_bm2(coh)=pw_sum_coh_bm2(coh)+Surv_prod(l)*bm2.pw_jt(j+l-1,t+l-1)*((1+g)/(1+r))^(l-1); % t_start is updated in parameters_t_2013.m
        end
    else
        for l=l_t_reform:Length
            pw_sum_coh_bm2(coh)=pw_sum_coh_bm2(coh)+Surv_prod(l)*bm2.pw_jt(j+l-1,t+l-1)*((1+g)/(1+r))^(l-1); % t_start is updated in parameters_t_2013.m
        end
    end
    
    % unpaid tax
    tax_w_sum_coh_bm2(coh)=0;
    lw=Jw-j+1; % l=1, age=j, l=Jw-j+1, age=Jw
    for l=l_t_reform:lw-1 % pay tax before retirement
        tax_w_sum_coh_bm2(coh)=tax_w_sum_coh_bm2(coh)+Surv_prod(l)*bm2.yw_p_t(j+l-1,t+l-1)*bm2.tau_w_t(t+l-1)/(1-bm2.tau_w_t(t+l-1))*((1+g)/(1+r))^(l-1); % t_start is updated in parameters_t_2013.m
    end    
end

j=1;
for t=2:t_reform
    coh=J-j+t;
    j_t_reform=j+t_reform-t;
    if j_t_reform>=Jw
        transfer_share_coh(coh)=1;
    else
        transfer_share_coh(coh)=(j_t_reform-1)/(Jw-1);
    end
    transfer_aw_p_coh(coh)=(pw_sum_coh_bm2(coh)-tax_w_sum_coh_bm2(coh))/(1+r)*transfer_share_coh(coh);
    aw_p_t(1,t)=aw_p_t(1,t)+transfer_aw_p_coh(coh);
end


%% ------------------ 3. The Increase of Government Debt ----------------------

transfer_aw_p_sum=0;
t=1;
for j=1:J
    coh=J-j+1;
    transfer_aw_p_sum=transfer_aw_p_sum+transfer_aw_p_coh(coh)*Nw_p_t(j,1);
end

j=1;
for t=2:t_reform
    coh=J-j+t;
    transfer_aw_p_sum=transfer_aw_p_sum+transfer_aw_p_coh(coh)*Nw_p_t(j,1)*((1+g)/(1+r))^(t-1); % discounted to the first period
end

gov_debt_t(1)=gov_debt_t(1)+transfer_aw_p_sum;

