% initial state ff, adjustment
% in 2013, government announces fully funded reform
% issue bond and give the existing agent the promised discounted value of
% pension


%% ------------------- 1. The Promised Payment for existing cohorts ---------------------
load(name_data_2013,'pw_jt_bm2', 'yw_p_t_bm2','tau_w_t_bm2')

% update the cohort existing in t=1, which is 2013
t=1;
for j=1:J % j is the age in period 1
    Length=J-j+1;
    coh=J-j+1;
    % survival rate to period xx
    Surv(1)=1;
    for l=2:Length
        Surv(l)=lam_jt(j+l-1,l);
    end
    % acc. survival rate to period l
    for l=1:Length
        Surv_prod(l)=prod(Surv(1:l));
    end
    % total pw_coh discounted to t=1
    pw_sum_coh_bm2(coh)=0;
    for l=1:Length
        pw_sum_coh_bm2(coh)=pw_sum_coh_bm2(coh)+Surv_prod(l)*pw_jt_bm2(j+l-1,l+t_start-1)*((1+g)/(1+r))^(l-1); % t_start is updated in parameters_t_2013.m
    end
    % unpaid tax
    tax_w_sum_coh_bm2(coh)=0;
    lw=Jw-j+1; % l=1, age=j, l=Jw-j+1, age=Jw
    for l=1:lw-1 % pay tax before retirement
        tax_w_sum_coh_bm2(coh)=tax_w_sum_coh_bm2(coh)+Surv_prod(l)*yw_p_t_bm2(j+l-1,l+t_start-1)*tau_w_t_bm2(l+t_start-1)/(1-tau_w_t_bm2(l+t_start-1))*((1+g)/(1+r))^(l-1); % t_start is updated in parameters_t_2013.m
    end
end

% give this promise to them as assets
% current workers get a fraction according to their working years, net for
% unpaid tax
t=1;
for j=1:Jw-1
    coh=J-j+1;
    aw_p_t(j,1)=aw_p_t(j,1)+(pw_sum_coh_bm2(coh)-tax_w_sum_coh_bm2(coh))/(1+r)*(j-1)/(Jw-1);
end

% retired people get all what they should get
for j=Jw:J
    coh=J-j+1;
    aw_p_t(j,1)=aw_p_t(j,1)+pw_sum_coh_bm2(coh)/(1+r);
end


%% ------------------ 2. The Increase of Government Debt ----------------------
% gov_debt_t(1) is updatedin initialstate_2013
% paid to current workers

pension_promise=0;


t=1;
for j=1:Jw-1
    coh=J-j+1;
    pension_promise=pension_promise+pw_sum_coh_bm2(coh)/(1+r)*(j-1)/(Jw-1)*Nw_p_t(j,1);
end

% paid to retired workers
for j=Jw:J
    coh=J-j+1;
    pension_promise=pension_promise+pw_sum_coh_bm2(coh)/(1+r)*Nw_p_t(j,1);
end

gov_debt_t(1)=gov_debt_t(1)+pension_promise;
