
% update TFP growth and discount 
% to match
% wage growth
% and urban household saving rate


name_data_g_extra='data_g_extra';
index_g_extra_guess=0;

% target until certain years
t_target=t_2013;  
t_target_bet=t_2010;
target_g_ave_wageincome=0.075-g; % initial average earning growth before t_target
index_gdppc_CNUS_ini_load=1;
if index_gdppc_CNUS_ini_load==1
    % load from our model's prediction
    load data_GDPpc_CN_US ratio_gdppc_CN2_US 
    ratio_yur_CNUS_ini=ratio_gdppc_CN2_US(1);
else
    ratio_yur_CNUS_ini=0.0832; % from data
end
% final urban GDPpc ration CN/US, 73%, implying that E firms are as
% productive as US firms
target_ratio_y_CNUS_ss=(1-psai_ss)^(alp/(1-alp)); 
target_Sav_rate=0.25; % 2000-2010 household saving rate



% load the initial guess from our previous calculation
load(name_data_load,'g_extra_ini','T_g_extra','bet_ini') % initial beta

% T_g_extra=23;

iter_g_extra=0;
dev_g_extra=1; % deviation from the target
adjust_g_extra=1; % adjust of the parameters

while iter_g_extra<100 && abs(dev_g_extra)>tol_g_extra && adjust_g_extra>1e-7
    
    % ----------- extra TFP growth
    Z_t(1)=Z_ini;
    iter_g_extra=iter_g_extra+1;
    for t=2:t_2010
        g_extra_t(t)=g_extra_ini;
    end
    g_extra_t(T_g_extra)=0; % no extra growth from T_g_extra on
    % slow down until T_g_extra
    for t=t_2010+1:T_g_extra
        g_extra_t(t)=g_extra_t(t_2010)+(g_extra_t(T_g_extra)-g_extra_t(t_2010))/(T_g_extra-t_2010)*(t-t_2010);
    end
    for t=T_g_extra+1:t_end
        g_extra_t(t)=0;
    end
    for t=2:t_end
        Z_t(t)=Z_t(t-1)*(1+g_extra_t(t));
    end
    Z_ss=Z_t(t_end);
    
    % ------------ discount 
    bet_ini
    bet_e_ini=bet_ini; % benchmark in low g r
    bet_w_ini=bet_e_ini;
    bet_e_ss=bet_e_ini;
    bet_w_ss=bet_e_ss; 
    coh_betachange=J+t_2013-1;
    for coh=1:coh_betachange-1
        bet_e_coh(coh)=bet_e_ini;
        bet_w_coh(coh)=bet_w_ini;
    end
    for coh=coh_betachange:J+t_dyn-1
        bet_e_coh(coh)=bet_e_ss;
        bet_w_coh(coh)=bet_w_ss;
    end
    
       
    % solve the equilibrium with the new calibration
    % rural
    parameters_rural;
    solve_Hr_update; 
    pension_debt_coh_rural;
    % urban
    solve_ae1_update;
    variables_exp;
    
    % ---------- compute the target: average wage income growth
    for t=1:t_target
        % average labor income
        ave_wageincome_t(t)=(yw_p_t(1:Jw-1,t)'/(1-tau_w_t(t))*Nw_p_t(1:Jw-1,t)+yw_np_t(1:Jw-1,t)'*Nw_np_t(1:Jw-1,t))/sum(Nw_p_t(1:Jw-1,t)+Nw_np_t(1:Jw-1,t));
        ave_prod_t(t)=(prod_jt(1:Jw-1,t)'*(Nw_p_t(1:Jw-1,t)+Nw_np_t(1:Jw-1,t)))/sum(Nw_p_t(1:Jw-1,t)+Nw_np_t(1:Jw-1,t));
    end
    g_ave_wageincome=(ave_wageincome_t(t_target)/ave_wageincome_t(1))^(1/(t_target-1))-1;
    % adjust initial TFP growth
    g_extra_ini_old=g_extra_ini;
    g_extra_ini=g_extra_ini+target_g_ave_wageincome-g_ave_wageincome;
    
    % ----------- compute the second target: GDPpc ratio CN v.s. US    
    ratio_y_CNUS_ss=ratio_yur_CNUS_ini*y_t(1)/yur_t(1)*y_t(t_dyn)/y_t(1); 
    % adjust the length of TFP growth
    T_g_extra_old=T_g_extra;
    T_g_extra=floor(1.03*T_g_extra_old*(target_ratio_y_CNUS_ss/ratio_y_CNUS_ss));
    
    % ----------- compute the third target: urban household saving rate
    Sav_rate_w_0010=mean(Sav_rate_w_t(2000-year_start+1:2010-year_start+1));
    % adjust the discount
    bet_ini_old=bet_ini;
    bet_ini=bet_ini*(1+(target_Sav_rate-Sav_rate_w_0010)/target_Sav_rate/200);
    
    
    iter_g_extra=iter_g_extra+1;
    dev_g_extra=max(abs([(g_ave_wageincome-target_g_ave_wageincome)/target_g_ave_wageincome, (ratio_y_CNUS_ss-target_ratio_y_CNUS_ss)/target_ratio_y_CNUS_ss, (Sav_rate_w_0010-target_Sav_rate)/target_Sav_rate]));
    adjust_g_extra=max(abs([(g_extra_ini-g_extra_ini_old)/g_extra_ini_old T_g_extra-T_g_extra_old (bet_ini-bet_ini_old)/bet_ini_old]));
    
    iter_g_extra
    dev_g_extra
    adjust_g_extra
    
    
end
