% similar to main_GE2000
% the difference is that in this file we calibrate discount and TFP growth
% to urban household saving rate and the wage growth


clear;
clear global;
close all;
tic

%% ----------------- 0. Model Setup ---------------------------------

% global variables
global_claim;  

% set some useful indexes to control how to solve the model
index_setting;

% the names of data and figures
names_data_fig; 

% model parameters that are constant over time
parameters_basic;

% set the parameters (e.g. population, death rate) if the economy starts from 2000
parameters_t_2000; 

% parameters for the pension system
pensionsystem_2000; 

% rural model
parameters_rural;
pensionsystem_rural_2000;

% moments that we want to match or get from the data, e.g., foreign surplus
parameters_data_2000;




%% -------------- 1. Rural model --------------

solve_Hr_update; % update Hr until it converges to solve the rural model

pension_debt_coh_rural;



%% ---------------- 2. Calibrate Initial TFP growth and Discount --------------
t_reform=2013-year_start+1; % year_start is defined in parameters_t_xxxx.m

name_exp='benchmark';

tol_g_extra=1e-4; % tolerance for the calibration
tol_setting_accurate;


% update to find the right TFP growth and discount 
loop_g_extra_bet;



%% -------------- 3. Reform Experiment: Benchmark ------------
% most variables and experiments already done in solving the equilibrium
experiment_benchmark;
save(name_data_exp);



%% ------------- 4. Figures and Statistics ----------------

index_fig=0;
if index_fig==1
    figures_sz;
    figures_GDP;
end


