 
% given the general equilibrium model 2000 - main_GE2000
% re-calculate the partial equilibrium from 2013 given the original wage
% growth (without approximate the wage growth with the simple step function)

clear;
clear global;
close all;
tic

profile on
profile off

%% ----------------- 0. Setup ---------------------------------

global_claim;  % global variables


index_gtext=0;

% set the parameters (e.g. population, death rate) if the economy starts from 2000
name_data_2000='data_benchmark.mat';
name_data_load='data_benchmark';
name_exp='benchmark_2013';


% parameters that do not depend on year
parameters_basic;

% parameters starting from 2013 instead of 2000
parameters_t_2013; 

% the pension system in the benchmark reform
pensionsystem_2013; 


%  rural sector
parameters_rural_2013;
% load pension system from the old one, the rural pension
% reform is the new one
pensionsystem_rural_2013_old;

% statistic data
parameters_data_t_2013;


% initial wealth distribution

initialstate_2013;
initialstate_rural_2013;



%% -------------- 1. the Rural Sector --------------

solve_Hr_update_2013; % update Hr to solve the rural model
pension_debt_coh_rural; % pension system in the rural sector


%% ---------------- 2. Solve the Dynamics of the Urban Sector ----------------

t_reform=2013-year_start+1; % year_start is defined in parameters_t_xxxx.m

index_guess=0;
name_data_eq='data_eq_2013_benchmark_w_original.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'replace_w_coh3'); % initial

tol_setting_accurate;
solve_replace_w_coh3_update; % solve the long-run replacement rate


% compute other variables in the equilibrium, dra2w figures, save data
variables_eq;
variables_eq_ur;




%% ----------------- 3. Pension Reform Experiment ------------------------



fig_name='2013';

experiment_benchmark_2013_w_original;  
disp('Experiment_benchmark_2013_w_original finished')
toc


