
% get the exogenous wage growth 
% use a step function to approximate the wage growth
% calculate the partial equilibrium

% we may first run main_2013_HAE_w_original which calculate the exogenous
% wage growth

index_run_main_2013_HAE_w_original=0;
if index_run_main_2013_HAE_w_original==1
    main_2013_HAE_w_original;
end


clear;
clear global;
close all;
tic

%% ----------------- 0. Initial  Setup ---------------------------------

global_claim;  % global variables

name_data_2000='data_benchmark.mat'; % if we need the equilibrium from 2000
name_data_2013='data_benchmark_2013_w_original.mat'; % the equilibrium from 2013
load(name_data_2013); 

name_exp='benchmark_2013'; % this is the benchmark reform
name_data_exp='data_benchmark_2013.mat';

index_fixedlabor=0; % not fixed labor 
index_gtext=0; % no need to add gtext into figures


%% ---------------- 1. Adjust Wage Growth into a Step Function -------------------------
adjust_w_step;


%% ---------------- 2.  Solve the Dynamics of the Urban Sector ----------------

year_reform=year_start;
t_reform=year_reform-year_start+1; 


index_guess=0; % no need to guess, read from data
name_data_eq='data_eq_2013_benchmark.mat';
name_data_guess=name_data_eq;
% name_data_load=name_data_exp;

% initial guess of the dynamics from the data
load(name_data_guess,'H_p_t','H_np_t','p_base_t','replace_w_coh3');
H_p_t=H_p_t(1:t_dyn); H_np_t=H_np_t(1:t_dyn); p_base_t=p_base_t(1:t_dyn);

% tol_setting_accurate;
tol_setting_accurate2; % more accurate
solve_replace_w_coh3_update_pe; % solve the long-run replacement rate
replace_w_coh3


% compute other variables in the equilibrium
variables_eq;
variables_eq_ur;




%% ----------------- 4. Pension Reform Experiment ------------------------

experiment_benchmark_2013;     % benchmark reform in 2013
disp('Experiment_benchmark finished')
toc



