% Pay-as-you-Go Reform


clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables


name_data_2013='data_benchmark_2013.mat';
load(name_data_2013);


name_exp='paygo';
name_data_exp='data_paygo.mat';



index_fixedlabor=0; 
index_gtext=0;




%% ---------------- 1. Solve for Tax Subsidy and Workers Problem ----------------
t_reform=1;
index_guess=0;
name_data_eq='data_eq_2013_paygo.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'tau_subsidy'); % initial guess


tol_setting_accurate;
solve_tau_subsidy_update_pe; % calculate the tax rate subsidy into the pension system (due to initial asset, given 20% tax rate)


% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;


%% ----------------- 4. Pension Reform Experiment Outcomes ------------------------

experiment_paygo;     % current system
disp('Experiment_paygo finished')
toc
