
% Ramsey's problem with the non-negative tax constraint


clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

name_data_2013='data_benchmark_2013.mat';
% load variables from benchmark 2013
load(name_data_2013); 

adjust_Ramsey;

name_exp='Ramsey';
name_data_exp='data_Ramsey.mat';


index_fixedlabor=0; 
index_gtext=0;
index_Ramsey_FB=0; % meaning that we have the non-negative pension constraint
index_constraint=1; % only one constraint as noted above
index_noinitialasset=0; 



%% ---------------- 1. Solve for the Lagrangian Multiplier for Ramsey's Problem ----------------



index_guess=0;
name_data_eq='data_eq_2013_Ramsey.mat';
name_data_guess=name_data_eq;
% name_data_guess=name_data_2013;
name_data_load=name_data_eq;
if index_guess==0
    load(name_data_load,'lagr');
else
    % initial guess for the lagrangian multiplier
    lagr=1;
end


tol_setting_accurate2;


solve_lagr_update_pe;


disp('Ramsey Problem Solved')
toc



if index_Ramsey_FB==1
    name_data_exp='data_Ramsey_FB.mat';
else
    name_data_exp='data_Ramsey.mat';
end

save(name_data_exp);


%% ----------------- 2. Pension Reform Experiment Outcomes ------------------------
index_experiment=1;
if index_experiment==1

experiment_Ramsey;     
disp('Experiment_Ramsey finished')
toc

end


%% ---------------- 3. Figures ------------------------
figures_pension_Ramsey;



