
clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

name_data_2013='data_benchmark_2013.mat';
% load variables from benchmark 2013
load(name_data_2013); 

adjust_Ramsey;

name_exp='Ramsey_2Constraints';
name_data_exp='data_Ramsey_2Constraints.mat';


index_fixedlabor=0; 
index_gtext=0;
index_noinitialasset=0;

index_Ramsey_FB=0; % meaning that we have the non-negative pension constraint
index_constraint=2; % we have a second constraint on the upper bound of the replacement rate
% the constraint is the maximum replacement rate
replace_w_coh_max=max(replace_w_coh,0.6);



%% ---------------- 2. Solve for Lagrangian Multiplier ----------------



index_guess=0;
name_data_eq='data_eq_2013_Ramsey_2Constraints.mat';
name_data_guess=name_data_eq;
name_data_load=name_data_eq;
if index_guess==0
    load(name_data_load,'lagr');
else
    % give a random guess
    lagr=1;
end


tol_setting_accurate2;


solve_lagr_update_pe_2Constraints;


disp('Ramsey Problem Solved')
toc





%% ----------------- 2. Pension Reform Experiment Outcomes ------------------------
index_experiment=1;
if index_experiment==1

experiment_Ramsey;     % current system
disp('Experiment_Ramsey finished')
toc

end


%% ---------------- 3. Figures ------------------------
figures_pension_Ramsey;

tau_w_coh(t_dyn)