% Ramsey Problem without any constraint
% First Best solution


clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables


name_data_2013='data_benchmark_2013.mat';
% load variables from benchmark 2013
load(name_data_2013); 


% Ramsey's problem, no tax or pension
adjust_Ramsey;

name_exp='Ramsey_FB';
name_data_exp='data_Ramsey_FB.mat';


index_fixedlabor=0; 
index_gtext=0;
index_Ramsey_FB=1; % the first best
index_constraint=0; % whether there are two constraints (non-negative tax and replacement rate upper bound) or one constraint (non-negative tax), or no constraint
index_noinitialasset=0; 


%% ---------------- 2. Try Different Lagrangian Multiplier for Ramsey's Problem ----------------

index_guess=0;
name_data_eq='data_eq_2013_Ramsey_FB.mat';
name_data_guess=name_data_eq;
% name_data_guess=name_data_2013;
name_data_load=name_data_eq;
if index_guess==0
    load(name_data_load,'lagr');
else
    lagr=1;
end

tol_setting_accurate2;


solve_lagr_update_pe;


disp('Ramsey Problem Solved')
toc



if index_Ramsey_FB==1
    name_data_exp='data_Ramsey_FB.mat';
else
    name_data_exp='data_Ramsey.mat';
end
save(name_data_exp);


%% ----------------- 3. Pension Reform Experiment Outcomes ------------------------

% whether or not to calculate some more variables
index_experiment=1;

if index_experiment==1

load data_Ramsey_FB

experiment_Ramsey;     % current system
disp('Experiment_Ramsey_FB finished')
toc

end

