% drastic reform, include all urban and rural workers into the pension
% system

clear;
clear global;
close all;
tic

%% ----------------- 0. Setup ---------------------------------

global_claim;  % global variables


% load variables from benchmark 2013
name_data_2013='data_benchmark_2013.mat';
load(name_data_2013);


%% ------------------------- 1. Adjust  Population in the Pension System ---------------------
N_adjust_drasticreform; % coverage jumps to 100%



%% ---------------- 2. Solve for Long-run Replacement Rate ----------------


index_guess=0;
name_data_eq='data_eq_2013_drasticreform.mat';
name_data_exp='data_drasticreform.mat';
name_data_guess=name_data_eq;


load(name_data_guess,'replace_w_coh3','Hr_t'); % initial


tol_setting_accurate;


solve_replace_w_coh3_update_drasticreform_pe;


disp('Dynamic computation finished')
toc
% 
% save(name_data_eq,'H_p_t','H_np_t','p_base_t','replace_w_coh3');

% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;



fig_name='2013';


%% ----------------- 3. Pension Reform Experiment Outcomes ------------------------

experiment_drasticreform;     % current system
disp('Experiment_drasticreform finished')
toc

