 

% fully funded reform

clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

% load variables from benchmark 2013
load('data_benchmark_2013.mat');

name_data_2013='data_benchmark_2013.mat';
name_exp='fullyfunded';
name_data_exp='data_fullyfunded.mat';



index_fixedlabor=0; 
index_gtext=0;
index_iter_display=0;

%%  ------- 1. Adjust for the Fully Funded System  --------------
name_data_bm2=name_data_2013;

initialstate_adjust2_fullyfunded; % using data_bm2 adjust the wealth and government debt according to the pension promise
pensionsystem_adjust_fullyfunded; % fully funded system implies 0 replacement rate


%% ---------------- 2. Solve for Long-run Replacement Rate ----------------
t_reform=1;
index_guess=0;
name_data_eq='data_eq_2013_fullyfunded.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'tau_w_ss'); % initial


tol_setting_accurate;
solve_tau_w_update_pe;
tau_w_ss


disp('Dynamic computation finished')
toc


% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;


%% ----------------- 4. Pension Reform Experiment Outcomes ------------------------


experiment_fullyfunded;     % current system
disp('Experiment_fullyfunded finished')
toc

