
% given the pw_jt in Ramsey's First Best Problem


clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

% name_data_2000='..\Pension34.1_1992_ConstantBeta_111103\data_benchmark.mat';
name_data_2013='data_benchmark_2013.mat';
% load variables from benchmark 2013
load(name_data_2013); 


index_Ramsey_FB=1;
name_exp='given_Ramsey_FB';
name_data_exp='data_given_Ramsey_FB.mat';
name_data_Ramsey='data_Ramsey_FB.mat';
Ramsey=load(name_data_Ramsey);

index_fixedlabor=0; 
index_gtext=0;



%% ---------------- 2. Given pw_jt, what is the solution ----------------

workers_dyn_given_Ramsey; % no need to resolve the equilibrium anymore


index_debtclear=0; % lifetime tax ~= lifetime pension
pension_debt_coh_Ramsey; % not clear, how much less pension are needed?

disp('Dynamic computation finished')
toc

% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;

save(name_data_exp);


%% ----------------- 4. Pension Reform Experiment Outcomes ------------------------



experiment_Ramsey;     % current system
disp('Experiment_delayedreform finished')
toc



%% ---------------- 5. Errors, Compared to Ramsey ---------------------
err_cw_p_t=cw_p_t-Ramsey.cw_p_t;
err_h_p_t=h_p_t-Ramsey.h_p_t;
err_uw_p_sum_coh=uw_p_sum_coh-Ramsey.uw_p_sum_coh;

cw_p_t_Ramsey=Ramsey.cw_p_t;

max(max(abs(err_cw_p_t(1:J,1:t_dyn))))
max(max(abs(err_h_p_t(1:J,1:t_dyn))))
max(max(abs(err_uw_p_sum_coh(1:t_dyn))))