
% try different t_reform to find the optimal reform year for delayed reform



clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables


name_data_2013='data_benchmark_2013.mat';
% load everything from benchmark 2013
load(name_data_2013); 

name_exp='loop_t_reform';
name_data_exp='data_loop_t_reform.mat';


index_fixedlabor=0; 
index_gtext=0;



%% ---------------- 1. Choose different t_reform ---------------------

index_guess=0;
name_data_eq='data_eq_loop_t_reform.mat';
name_data_exp='data_loop_t_reform.mat';
name_data_guess=name_data_eq;

name_data_load=name_data_eq;


grid_reform=[2013:2:2045 2046:1:2054 2055:2:2065 2066:5:2096 2100];
n_reform=length(grid_reform);
for i_reform=1:n_reform


% --------------- Solve for Long-run Replacement Rate ----------------

year_reform=grid_reform(i_reform);
t_reform=year_reform-year_start+1; % year_start is defined in parameters_t_xxxx.m



load(name_data_load,'H_p_t','H_np_t','p_base_t','replace_w_coh3');
H_p_t=H_p_t(1:t_dyn); H_np_t=H_np_t(1:t_dyn); p_base_t=p_base_t(1:t_dyn);

tol_setting_accurate3;
solve_replace_w_coh3_update_pe;


disp('Dynamic computation finished')
toc




% ------------- Save the result for each t_reform ------------------------


experiment_loop_t_reform;     % current system

end



%% ------------------------- 2. Figures -------------------

n_fig=min(2060-2013+1+(2101-2061)/10+1,length(grid_reform));
figures_workers_ev_t_reform;
[max_ev_p_sum_rg,max_t_reform_rg]=max(ev_p_sum_rg_t_reform);
display('max ev and max year with rg (low discount):')
max_ev_p_sum_rg
year_reform_optimal=grid_reform(max_t_reform_rg)

save(name_data_exp)



