% extend the pension system to the rural sector 

clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

% load variables from benchmark 2013
name_data_2013='data_benchmark_2013.mat';
load(name_data_2013);


name_exp='ruralpension';
name_data_exp='data_ruralpension.mat';


%% -------------- 0.5 Adjust Rural Pension System ------------------
pensionsystem_rural_2013_new;


%% -------------- 1. the rural model --------------

variables_eq_rural; % no need to resolve the whole dynamics
pension_debt_coh_rural;


%% ---------------- 2. Solve for Long-run Replacement Rate ----------------

t_reform=2013-year_start+1; % year_start is defined in parameters_t_xxxx.m

index_guess=0;
name_data_eq='data_eq_2013_ruralpension.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'replace_w_coh3'); % initial


tol_setting_accurate;
solve_replace_w_coh3_update_pe;
replace_w_coh3


disp('Dynamic computation finished')
toc

% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;






%% ----------------- 3. Pension Reform Experiment Outcomes ------------------------

experiment_benchmark_2013_ruralpension;     % current system
disp('Experiment_ruralpension finished')
toc

