% increase tax to balance the current pension system with replacement rate 60% 



clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

% load variables from benchmark 2013
load('data_benchmark_2013.mat');

name_data_2013='data_benchmark_2013.mat';
name_exp='taxincrease';
name_data_exp='data_taxincrease.mat';



index_fixedlabor=0; 
index_gtext=0;
index_iter_display=0;

%% ------------- 1. Tax Increase Adjustment --------------
pensionsystem_adjust_taxincrease;




%% ---------------- 2. Solve for Long-run Tax Rate ----------------
t_reform=1;
index_guess=0;
name_data_eq='data_eq_2013_taxincrease.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'tau_w_ss'); % initial


tol_setting_accurate;
solve_tau_w_update_pe;

tau_w_ss


% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;




%% ----------------- 4. Pension Reform Experiment Outcomes ------------------------

experiment_taxincrease;     % current system
disp('Experiment_taxincrease finished')
toc

