% rural pension system


%% --------------------- 1. Tax ----------------------
tax_total_r_t(1:t_dyn)=tau_wr*wr_t(1:t_dyn).*Hr_t(1:t_dyn);
% steady state value, use t_dyn and multiply by 1+N_growth_ss, and grows at
% the rate of N_growth_ss, which is approximately 0 in the baseline model
tax_total_r_ss=tax_total_r_t(t_dyn)*(1+N_growth_ss);

% discounted sum of tax income
tax_lifetime_r=tax_total_r_t(1); 
for t=2:t_dyn
    tax_lifetime_r=tax_lifetime_r+tax_total_r_t(t)*((1+g)/(1+r))^(t-1);
end
% continuation value from steady state
tax_lifetime_r=tax_lifetime_r+tax_total_r_ss*((1+g)/(1+r))^t_dyn/(1-(1+N_growth_ss)*(1+g)/(1+r));



%% ------------------- 2. Pension Payment -----------------
% use the replace_wr defined in corresponding pensionsystem_rural_yyyy.m
% file, where yyyy is the starting year
for t=1:t_dyn
    pension_total_r_t(t)=replace_wr*p_base_r_t(t)*Nr_retire_t(t);
end
pension_total_r_ss=pension_total_r_t(t_dyn)*(1+N_growth_ss); % and then grows at the rate of 1+N_growth_ss
% discounted sum of pension payments
pension_lifetime_r=0;
for t=1:t_dyn
    pension_lifetime_r=pension_lifetime_r+pension_total_r_t(t)*((1+g)/(1+r))^(t-1);
end

% debt of rural pension
pension_debt_lifetime_r=pension_lifetime_r-tax_lifetime_r;
        


