% set the parameters for the pension system


% VAT 17%
tau_g=0.17; 
tau_gr=0.17;


% entrepreneur's contribution and benefit from the pension system is 0
tau_e_ss=0; 
tau_e_t=tau_e_ss*ones(1,t_dyn);
replace_e_ss=0; 
replace_e_t=replace_e_ss*ones(1,t_dyn); 


% pension tax on workers' labor income
tau_w_ss=0.2; 
tau_w_t=tau_w_ss*ones(1,t_dyn);
% replacement rate for workers
replace_w_ini=0.78; % initially very high for cohorts retiring before 1997
replace_w_coh1=replace_w_ini;
replace_w_coh2=0.6; % then goes down for cohorts retiring after 1997

% pension indexation of wage growth
indexation=0.4;


% the government can transfer some resource to the pension system
if index_Ag_transfer_guess==1
    % if we have to guess
    year_transfer=2013;
    Ag_transfer_value_ini=100;
    Ag_transfer=Ag_transfer_value_ini*((1+r)/(1+g))^(year_transfer-year_start);
else
    % in fact we always read from the data
    bm=load(name_data_load, 'year_transfer','Ag_transfer_value_ini','Ag_transfer','Ag_transfer_real_value_ini','Ag_transfer_real');
    year_transfer=bm.year_transfer; % when the transfer is made to the pension fund
    Ag_transfer_value_ini=bm.Ag_transfer_value_ini;
    Ag_transfer=bm.Ag_transfer;
    Ag_transfer_real_value_ini=bm.Ag_transfer_real_value_ini; % in our current setting, the real transfer and transfer are just the same
    Ag_transfer_real=bm.Ag_transfer_real;
end

t_transfer=year_transfer-year_start+1; % the period that the transfer is made 
