% update to get the right ae1: the entrepreneur initial asset
% the by-product of this procedure is to allow us to get the right government transfer to the
% pension fund

initialstate_2000; % find the initial states in 2000

% choose flexible starting year of entrepreneur asset? No. We choose 1995
index_loop_ae_t_pre_e_start=0; 


iter_ae1=0;
dev_ae1=1;

% iterate until initial wealth and government transfer to pension fund
% converges
while iter_ae1<100 && abs(dev_ae1)>tol_ae1
    iter_ae1=iter_ae1+1;
    if index_loop_ae_t_pre_e_start==0
        ae1=[ae_t(:,1)' aw_p_t(:,1)' aw_np_t(:,1)' Ag_transfer];
    else
        ae1=[ae_t(:,1)' aw_p_t(:,1)' aw_np_t(:,1)' Ag_transfer ae_t_pre_e_start];
    end
    
    % given the initial wealth, we can solve for the long-run replacement
    % rate (for the 3rd groups of cohorts: after reform year. The 1st and 2nd groups are before 1997, 1997-reform year) that balances the pension payment and tax 
    load(name_data_guess,'replace_w_coh3');  % initial guess, load from previous calculation
    solve_replace_w_coh3_update; % solve for replace_w_coh3
    disp('Dynamic computation finished')
    toc

    % compute other variables in the equilibrium, draw figures, save data
    variables_eq;
    variables_eq_ur;

    save(name_data_exp); % for initialstate_2000 to load
   
    % update initial wealth ae_t(1), aw_t(1)
    % Ag_transfer is updated in   variables_eq_ur.m
    initialstate_2000;

    if index_loop_ae_t_pre_e_start==0
        ae1_new=[ae_t(:,1)' aw_p_t(:,1)' aw_np_t(:,1)' Ag_transfer];
    else        
        step_ae_t_pre_e_start=(0.2-HE_t(1)/H_t(1))/(HE_t(1)/H_t(1));
        ae_t_pre_e_start=ae_t_pre_e_start*(1+step_ae_t_pre_e_start);
        ae_t(:,1)=ae_t(:,1)*0.2/(HE_t(1)/H_t(1));
        ae1_new=[ae_t(:,1)' aw_p_t(:,1)' aw_np_t(:,1)' Ag_transfer ae_t_pre_e_start];
    end
    dev_ae1=norm(ae1_new-ae1)/norm(ae1);
    
    iter_ae1
    dev_ae1
    ae_t_pre_e_start
    HE_H_1=HE_t(1)/H_t(1)
    toc
    
end
