% iterate on the long-run replacement rate to find the level that balances
% the pension system


iter_replace_w_coh3=0;
dev_replace_w_coh3=1;
step_replace_w_coh3=0.9;


while iter_replace_w_coh3<100 && abs(dev_replace_w_coh3)>tol_replace_w_coh3
    iter_replace_w_coh3=iter_replace_w_coh3+1;
       
   % replacement rate for each cohort
    module_replace_w_coh; % replace_w_coh
    % replacement rate for each age in each year
    module_replace_w_coh2jt; % replace_w_jt
  
    % solve for the steady state
    steadystate;
    
    % solve the equilibrium dynamics, by finding the sequence of labor
    % supply and E firm asset: H_t and AE_t
    initialguess;
    solve_dynamic;
    
    index_debtclear=0; % given the replacement rate, it is possible that lifetime tax ~= lifetime pension
    pension_debt_coh; % given the replacement rate, calculate the pension payments and tax
    
    % try a new replacement rate proportionally to the government debt
    replace_w_coh3_new=(-gov_debt_lifetime/tax_lifetime+1)*replace_w_coh3;
    dev_replace_w_coh3=gov_debt_lifetime/tax_lifetime;

    % new replacement rate
    replace_w_coh3=step_replace_w_coh3*replace_w_coh3_new+(1-step_replace_w_coh3)*replace_w_coh3;
    
    
    iter_replace_w_coh3
    replace_w_coh3
    dev_replace_w_coh3
    toc
    
    save(name_data_eq,'H_p_t','H_np_t','AE_t','p_base_t','replace_w_coh3');
end
