% partial equilibrium
% update on the long-run replacement rate to find the solution that
% balances the pension system



iter_replace_w_coh3=0;
dev_replace_w_coh3=1;
step=1;


while iter_replace_w_coh3<50 && (abs(dev_replace_w_coh3)>tol_replace_w_coh3 || abs(dev)>tol)
    iter_replace_w_coh3=iter_replace_w_coh3+1;
   
    
    if iter_replace_w_coh3>1
        name_data_guess=name_data_eq; % use the result from last iter_replace_w_coh3
    end


    module_replace_w_coh; % replace_w_coh, replace_w_ss
    module_replace_w_coh2jt; % replace_w_jt

    
    %% ------------------- set the steady state variables -----------
  
    steadystate_pe;

  
    %% ----------------- solve the workers' problem ---------------------
    workers_ss;
    workers_dyn; 

    
    %% ---------------- update labor supply and pension base -----------------------
    H_p_base_t_ini=real([H_p_t H_np_t p_base_t(1:t_dyn)]);
    update_H_p_base_once;
      
    
    index_debtclear=0; 
    pension_debt_coh; 
    % if the pension system is not balanced, how to adjust the replacement rate?
    replace_w_coh3_new=replace_w_coh3-gov_debt_lifetime/pension_base_t_reform;
    dev_replace_w_coh3=gov_debt_lifetime/tax_lifetime;
    replace_w_coh3=step*replace_w_coh3_new+(1-step)*replace_w_coh3;

    
    save(name_data_eq,'H_p_t','H_np_t','p_base_t','replace_w_coh3');
end
