% calculate the steady state (after transition)
% population normalized to 1, therefore AE (entrepreneur asset) is in fact
% AE per labor
% since the number of entrepreneur is constant while the worker population
% changes over time
% w_ss, AE_ss (AE per Labor) is constant, but 
% me_ss changes


%%  ---------- 1. Initial Guess, H, AE -----------
w_ss_ini=1.2*alp^(alp/(1-alp))*(1-alp)*(1-tau_g)^(1/(1-alp))*Z_ss*(rl_ss+dep)^(-alp/(1-alp));
H_ss_ini=1;
H_p_ss_ini=0.6;
H_np_ss_ini=H_ss_ini-H_p_ss_ini;
KE_ss_ini = ((1-psai_ss)*(1-alp)*(1-tau_g)*Z_ss^(1-alp)*chi_ss^(1-alp)*1^(-alp)*w_ss_ini^(-1))^(-1/alp);
AE_ss_ini=KE_ss_ini/(1+eta_ss*(1+rl_ss/(1+rl_ss-eta_ss*(1+rl_ss)))); % full borrowing and rho=rl_ss
H_AE_ss_ini=[H_p_ss_ini,H_np_ss_ini,AE_ss_ini];


%%  --------- 2. Solve for H and AE -----------

% approach 2, iteration
iter_ss=1;
iter_ss_max=300;
dev_ss=1;
tol_ss=1e-7;
step=0.2;
H_AE_ss=H_AE_ss_ini;


% update H and AE until they converge
while iter_ss<iter_ss_max && dev_ss>tol_ss
    update_ss;
    iter_ss=iter_ss+1;
    dev_ss=max(abs(H_AE_ss_new./H_AE_ss-1));
    H_AE_ss = step*H_AE_ss_new + (1- step) * H_AE_ss;
end

H_p_ss=H_AE_ss(1);
H_np_ss=H_AE_ss(2);
AE_ss=H_AE_ss(3);
H_ss=H_p_ss+H_np_ss;

%% -------- 3. Check the Error ---------

update_ss;
error_ss=[H_p_ss_new - H_p_ss , H_np_ss_new - H_np_ss , AE_ss_new-AE_ss];


%% --------- 4. Useful Variables -----------
% asset of all entrepreneurs, including managers and E firm owners
Ae_ss=ae_ss(1:J)*Ne_ss(1:J)';
% F firm capital and labor
if case_ss==0
    HF_ss=H_ss;
    KF_ss=(alp*Z_ss/(rl_ss+dep))^(1/(1-alp))*HF_ss;
elseif case_ss==1
    HF_ss=H_ss-HE_ss;
    KF_ss=(alp*Z_ss/(rl_ss+dep))^(1/(1-alp))*HF_ss;
else
    HF_ss=0;
    KF_ss=0;
end

