% some variables we calculate only in the benchmark reform GE2000

%% ---------------------------- Wage Growth --------------------

%  wage growth and labor income growth
growth_ave_yw_0013=(ave_wageincome_t(t_2013)/ave_wageincome_t(t_2000))^(1/(t_2013-t_2000))-1;
growth_ave_yw_1330=(ave_wageincome_t(t_2030)/ave_wageincome_t(t_2013))^(1/(t_2030-t_2013))-1;
growth_w_0013=(w_t(t_2013)/w_t(t_2000))^(1/(t_2013-t_2000))-1;
growth_w_1331=(w_t(t_2031)/w_t(t_2013))^(1/(t_2031-t_2013))-1;
growth_w_3140=(w_t(t_2040)/w_t(t_2031))^(1/(t_2040-t_2031))-1;
growth_w_4050=(w_t(t_2050)/w_t(t_2040))^(1/(t_2050-t_2040))-1;


%% --------------------------- Wealth ------------------------------
% wealth of workers w./w.o. pension, before 2000
aw_pre_t=(aw_p_pre_t(1:J,1:T_pre)*Perc_w_p_ini+aw_np_pre_t(1:J,1:T_pre)*(1-Perc_w_p_ini));
yw_pre_t=(yw_p_pre_t(1:J,1:T_pre)*Perc_w_p_ini+yw_np_pre_t(1:J,1:T_pre)*(1-Perc_w_p_ini));
ave_yw_pre_t=sum(yw_pre_t.*(Nw_t(1:J,1)*ones(1,T_pre)),1)./sum(Nw_t(1:J,1)*ones(1,T_pre),1);

% wealth of workers w./w.o. pension, after 2000
aw_t=(aw_p_t(1:J,1:t_dyn).*Nw_p_t+aw_np_t(1:J,1:t_dyn).*Nw_np_t)./(Nw_p_t+Nw_np_t);
yw_t=(yw_p_t(1:J,1:t_dyn).*Nw_p_t+yw_np_t(1:J,1:t_dyn).*Nw_np_t)./(Nw_p_t+Nw_np_t);
ave_yw_includingretire_t=sum(yw_t.*Nw_t,1)./sum(Nw_t,1);


%% ---------------- GDP: CN v.s. US ----------------
% -------- Population
% CN population
data_pop_CN=[1263638
1270744
1277595
1284303
1291002
1297765
1304262
1310584
1317066
1323592
];

% US pop
data_pop_US=[282172
285082
287804
290326
293046
295753
298593
301580
304375
307007
307907
310532
313166
315806
318446
321085
323716
326339
328949
331545
334123
336681
339215
341724
344205
346655
349072
351457
353808
356124
358407
360657
362874
365060
367214
369339
371435
373503
375544
377560
379551
381519
383466
385394
387304
389200
391083
392954
394816
396674
398528
];

% GDPpc China, Data 1 from PWT
data_gdppc_CN1=[2885.387864
3117.865097
3408.410098
3776.895875
4188.736908
4735.81457
5249.988462
5889.959325
6415.391577
7011.573153
];

% real GDPpc China, Data 2 from PWT
data_gdppc_CN2=[3261.004255
3449.557132
3839.269737
4207.480872
4676.721941
5218.064576
5868.894619
6605.898878
6996.124621
7430.751909
];

% real GDPpc US, Data from PWT
data_gdppc_US=[39174.89195
38959.34451
39149.1802
39788.6679
40907.97317
42534.81791
43258.39307
43691.52574
43326.0262
41101.86498
];


year_start_data=2000;
year_end_data=2009;
t_start_data=1;
t_end_data=year_end_data-year_start_data+1;
t_fig=101; % 2000-2100

% --------------- GDPpc
% keep the GDPpc growth in data
growth_CN1_data(2:t_end_data)=data_gdppc_CN1(2:t_end_data)./data_gdppc_CN1(1:t_end_data-1)-1;
growth_CN2_data(2:t_end_data)=data_gdppc_CN2(2:t_end_data)./data_gdppc_CN2(1:t_end_data-1)-1;
growth_US_data(2:t_end_data)=data_gdppc_US(2:t_end_data)./data_gdppc_US(1:t_end_data-1)-1;
% GDPpc growth in model
growth_CN(1:t_dyn)=g+growth_yur_t(1:t_dyn);
growth_US=g*ones(1,t_dyn);
% use the  US growth in data
growth_US(2:t_end_data)=growth_US_data(2:t_end_data); 

% GDPpc in 2009 is taken from data
gdppc_CN1(t_end_data)=data_gdppc_CN1(t_end_data);
gdppc_CN2(t_end_data)=data_gdppc_CN2(t_end_data);
gdppc_US(t_end_data)=data_gdppc_US(t_end_data);

% use our model to predict the gdp 2000-2009
for t=t_end_data-1:-1:t_start_data
    gdppc_CN1(t)=gdppc_CN1(t+1)/(1+growth_CN(t+1));
    gdppc_CN2(t)=gdppc_CN2(t+1)/(1+growth_CN(t+1));
    gdppc_US(t)=gdppc_US(t+1)/(1+growth_US(t+1));
end

% until today, use the data and model's growth rates to calculate the GDP pc
% CN2 v.s. US

for t=t_end_data+1:t_2013
    gdppc_CN1(t)=gdppc_CN1(t_end_data)*yur_t(t)/yur_t(t_end_data)*(1+g)^(t-t_end_data);
    gdppc_CN2(t)=gdppc_CN2(t_end_data)*yur_t(t)/yur_t(t_end_data)*(1+g)^(t-t_end_data);
    gdppc_US(t)=gdppc_US(t_end_data)*(1+g)^(t-t_end_data);
end

% starting from today, use the model's growth rates to calculate the GDP pc
% CN2 v.s. US
for t=t_2013+1:t_dyn
    gdppc_CN1(t)=gdppc_CN1(1)*yur_t(t)/yur_t(1)*(1+g)^(t-1);
    gdppc_CN2(t)=gdppc_CN2(1)*yur_t(t)/yur_t(1)*(1+g)^(t-1);
    gdppc_US(t)=gdppc_US(1)*(1+g)^(t-1);
end



ratio_gdppc_CN2_US=gdppc_CN2./gdppc_US;





save data_gdppc_CN_US gdppc_CN1 gdppc_CN2 gdppc_US ratio_gdppc_CN2_US

%------------- population
load data_benchmark pop_ur_total_t pop_t_mig_sum
% population growth from the model
g_pop_CN(2:t_fig)=pop_ur_total_t(2:t_fig)./pop_ur_total_t(1:t_fig-1)-1;
% population from the data
pop_CN(1:t_end_data)=data_pop_CN(1:t_end_data);
pop_US(1:length(data_pop_US))=data_pop_US; % we have data until 2050
g_pop_US(2:length(data_pop_US))=pop_US(2:length(data_pop_US))./pop_US(1:length(data_pop_US)-1)-1;
g_pop_US(length(data_pop_US)+1:t_fig)=0; % assume that after 2050, there is no population growth in the US

% use our model's prediction to project the future population
for t=t_end_data+1:t_fig
    pop_CN(t)=pop_CN(t-1)*(1+g_pop_CN(t));
    pop_US(t)=pop_US(t-1)*(1+g_pop_US(t));
end

% --------------- GDP
for t=1:t_fig
    gdp_CN1(t)=pop_CN(t)*gdppc_CN1(t);
    gdp_CN2(t)=pop_CN(t)*gdppc_CN2(t);
    gdp_US(t)=pop_US(t)*gdppc_US(t);
end

for t=1:t_end_data
    data_gdp_CN1(t)=pop_CN(t)*data_gdppc_CN1(t);
    data_gdp_CN2(t)=pop_CN(t)*data_gdppc_CN2(t);
    data_gdp_US(t)=pop_US(t)*data_gdppc_US(t);
end