
%% --------------- 0. Prepare Steady State Variables ---------------


wagepension_np_t(1:J,1:t_dyn)=wagepension_p_t(1:J,1:t_dyn); 

% given w_t, tau_w_t, solve aw_t, cw_t
% those cohorts already exist in period 1
t=1;
for j=1:J % j is the age in period 1
    Length=J-j+1;
    coh=J-j+1;
    Interest(1:Length)=1+r;
    for l=1:Length
        WagePension(l)=wagepension_np_t(j+l-1,l); % year l, age depends positively on j
    end
    Surv(1:Length)=lam_jcoh(j:j+Length-1,coh);
    Asset_ini=aw_np_t(j,1);
    Beta=bet_w_coh(coh);
    [cw_np_j,h_np_j,yw_np_j,aw_np_j]=fun_c_a_j_kpr(Beta,Length, Interest, WagePension,  Surv, Asset_ini);
    

    % put cw_j, aw_j into cw_t, aw_t
    for l=1:Length
        cw_np_t(j+l-1,l)=cw_np_j(l);
        h_np_t(j+l-1,l)=h_np_j(l);
        yw_np_t(j+l-1,l)=yw_np_j(l);
        yw_disp_np_t(j+l-1,l)=yw_np_j(l)+(Interest(l)-1)*aw_np_j(l); % disposible income
        aw_np_t(j+l-1,l)=aw_np_j(l);

        cw_np_coh(j+l-1,coh)=cw_np_j(l);        
        h_np_coh(j+l-1,coh)=h_np_j(l);        
        yw_np_coh(j+l-1,coh)=yw_np_j(l);        
        aw_np_coh(j+l-1,coh)=aw_np_j(l);
        

        uw_np_coh(j+l-1,coh)=fun_u_kpr(cw_np_coh(j+l-1,coh),h_np_coh(j+l-1,coh));
        

    end
end
uw_np_sum_coh=zeros(1,t_dyn+J-1);
% first J cohorts, born before T_pre
for coh=1:J
    for j=1:J % look at their whole life
        Surv(j)=lam_jcoh(j,coh);
        uw_np_sum_coh(coh)=uw_np_sum_coh(coh)+prod(Surv(1:j))*(bet_w_coh(coh)*(1+g)^(1-sig))^(j-1)*uw_np_coh(j,coh);
    end
end



% those born in period t>1
j=1; 
for t=2:t_dyn
    Length=J;
    coh=J+t-1;
    Interest(1:Length)=1+r;
    for l=1:Length
        WagePension(l)=wagepension_np_t(l,t+l-1); % year l, age depends positively on j
    end
    Surv(1:Length)=lam_jcoh(1:Length,coh);
    Asset_ini=0;
    Beta=bet_w_coh(coh);
    [cw_np_j,h_np_j,yw_np_j,aw_np_j]=fun_c_a_j_kpr(Beta,Length, Interest, WagePension, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t
    
    uw_np_sum_coh(coh)=0;
    for l=1:Length
        cw_np_t(l,t+l-1)=cw_np_j(l);
        h_np_t(l,t+l-1)=h_np_j(l);
        yw_np_t(l,t+l-1)=yw_np_j(l);
        yw_disp_np_t(l,t+l-1)=yw_np_j(l)+(Interest(l)-1)*aw_np_t(l,t+l-1);
        aw_np_t(l,t+l-1)=aw_np_j(l);
        
        cw_np_coh(l,coh)=cw_np_j(l);
        h_np_coh(l,coh)=h_np_j(l);
        yw_np_coh(l,coh)=yw_np_j(l);
        aw_np_coh(l,coh)=aw_np_j(l);
        
        
            uw_np_coh(j+l-1,coh)=fun_u_kpr(cw_np_coh(j+l-1,coh),h_np_coh(j+l-1,coh));
        
        uw_np_sum_coh(coh)=uw_np_sum_coh(coh)+prod(Surv(1:l))*(bet_w_coh(coh)*(1+g)^(1-sig))^(l-1)*uw_np_coh(l,coh);
    end
end



