% get lagr and index_Ramsey_FB
% now only works for log utility

if sig~=1
    disp('Not log utility! Not working with the current code')
    pause;
end

%% --------------- 1. Given lagr, decide each cohort's consumption and labor ---------------


%% ------------------  Worker with Pension -----------------
% initial wealth is given in initialstate.m

% wage
for t=1:t_dyn
    for j=1:Jw-1
        wage_jt(j,t)=w_t(t)*prod_jt(j,t);
    end
end
wage_jt(1:Jw-1,t_dyn+1:t_end)=wage_jt(1:Jw-1,t_dyn)*ones(1,t_end-t_dyn);
wage_jt(Jw:J,1:t_end)=0;

% initialize pension
pw_jt=zeros(J,t_end);

% given w_t, tau_w_t, solve aw_t, cw_t
% those cohorts already exist in period 1
t=1;
for j=1:J % j is the age in period 1
    Length=J-j+1;
    Lw=Jw-j+1; % the period of retirement
    coh=J-j+1;
    Interest(1:Length)=1+r;
    for l=1:Length
        Wage(l)=wage_jt(j+l-1,t+l-1); % year l, age depends positively on j
    end
%     Surv(1)=1;
%     for l=2:Length
%         Surv(l)=lam_jt(j+l-1,t+l-1);
%     end
    Surv(1:Length)=lam_jcoh(j:j+Length-1,coh);
    Asset_ini=aw_p_t(j,1);
    
    Beta=bet_w_coh(coh);
    Beta_hat_coh(1,coh)=1;
    R_hat_coh(1,coh)=1;
    Beta_hat_coh(2:j,coh)=Beta*lam_jcoh(2:j,coh);
    R_hat_coh(2:J,coh)=(1+r)./(lam_jcoh(2:J,coh)*(1+g));
    Prod_Beta_hat_l1=prod(Beta_hat_coh(2:j,coh));
    Prod_R_hat_l1=prod(R_hat_coh(2:j,coh));

    if index_Ramsey_FB==1
        [cw_p_j,h_p_j,yw_p_j,aw_p_j, transfer_p_coh(coh)]=...
            fun_c_a_j_Ramsey_FB(Beta, Prod_Beta_hat_l1, Length, Interest, Prod_R_hat_l1 , Wage, Surv, Asset_ini, lagr);
        tau_w_coh(coh)=0;
    else
        [cw_p_j,h_p_j,yw_p_j,aw_p_j, transfer_p_coh(coh), tau_w_coh(coh)]=...
            fun_c_a_j_Ramsey(Beta, Prod_Beta_hat_l1, Length, Interest, Prod_R_hat_l1 , Wage, Surv, Asset_ini, lagr);
    end
    
    % put cw_j, aw_j into cw_t, aw_t, cw_coh
    % l means the lth period he appears in the sample
    for l=1:Length
        cw_p_t(j+l-1,t+l-1)=cw_p_j(l);
        h_p_t(j+l-1,t+l-1)=h_p_j(l);
        yw_p_t(j+l-1,t+l-1)=yw_p_j(l);
        aw_p_t(j+l-1,t+l-1)=aw_p_j(l); % asset if the transfer happens in the last period
                
        cw_p_coh(j+l-1,coh)=cw_p_j(l);  
        h_p_coh(j+l-1,coh)=h_p_j(l);  
        yw_p_coh(j+l-1,coh)=yw_p_j(l);  
        aw_p_coh(j+l-1,coh)=aw_p_j(l);  
        
        uw_p_coh(j+l-1,coh)=fun_u_kpr(cw_p_coh(j+l-1,coh),h_p_coh(j+l-1,coh));
    end
    tax_w_coh(coh)=0;
    for l=1:Lw-1
        tau_w_jt(j+l-1,t+l-1)=tau_w_coh(coh);
        tax_w_jt(j+l-1,t+l-1)=tau_w_jt(j+l-1,t+l-1)*wage_jt(j+l-1,t+l-1)*h_p_t(j+l-1,t+l-1);
        tax_w_jt2(j+l-1,t+l-1)=yw_p_t(j+l-1,t+l-1)/(1-tau_w_coh(coh))*tau_w_coh(coh);
        tax_w_coh(coh)=tax_w_coh(coh)+tax_w_jt(j+l-1,t+l-1)*((1+g)/(1+r))^(l-1)*prod(lam_jcoh(j+2-1:j+l-1,coh));
    end
    
    
    
    if j>=Jw 
        % already retired, transfer in t=1
        pw_jt(j,1)=transfer_p_coh(coh);
        net_transfer_p_coh(coh)=transfer_p_coh(coh) - tax_w_coh(coh);
        net_transfer_p_t(j,1)=net_transfer_p_coh(coh);
    else
        % not retired, transfer in j=Jw, t=1+Jw-j
        pw_jt(Jw,1+Jw-j)=transfer_p_coh(coh);
        net_transfer_p_coh(coh)=transfer_p_coh(coh) - tax_w_coh(coh)*((1+r)/(1+g))^(Jw-j)/prod(lam_jcoh(j+2-1:Jw,coh));
        net_transfer_p_t(Jw,1+Jw-j)=net_transfer_p_coh(coh);
    end
    
    
    % check errors
    for l=1:Length
        if l>1
            error_c_coh(j+l-1,coh)=cw_p_coh(j+l-1,coh)-bet_w_coh(coh)*(1+r)/(1+g)*cw_p_coh(j+l-1-1,coh);
            error_a_coh(j+l-1,coh)=aw_p_coh(j+l-1,coh)-((1+r)*aw_p_coh(j+l-1-1,coh)+yw_p_coh(j+l-1-1,coh)-cw_p_coh(j+l-1-1,coh))/lam_jcoh(j+l-1,coh)/(1+g);
        end
        if l<Lw
        error_h_coh(j+l-1,coh)=h_p_coh(j+l-1,coh)-((1-tau_w_coh(coh))*wage_jt(j+l-1,t+l-1)/cw_p_coh(j+l-1,coh))^phi;
        end
    end
    l=Length+1;
    error_a_coh(j+l-1,coh)=((1+r)*aw_p_coh(j+l-1-1,coh)+yw_p_coh(j+l-1-1,coh)-cw_p_coh(j+l-1-1,coh))/(1+g);
    
    for l=1:Length
        mu_c_jt(j+l-1,t+l-1)=1/cw_p_t(j+l-1,t+l-1);
        
        mu_h_jt(j+l-1,t+l-1)=h_p_t(j+l-1,t+l-1)^(1/phi);
        if l<Lw
            err_mu_c_h_jt(j+l-1,t+l-1)=mu_c_jt(j+l-1,t+l-1)*wage_jt(j+l-1,t+l-1) - mu_h_jt(j+l-1,t+l-1);
            err_mu_c_h_tau_jt(j+l-1,t+l-1)=(1-tau_w_jt(j+l-1,t+l-1))*mu_c_jt(j+l-1,t+l-1)*wage_jt(j+l-1,t+l-1) - mu_h_jt(j+l-1,t+l-1);
        end
        if l>2
            err_mu_c_jt(j+l-1,t+l-1)=bet_w_coh(coh)*(1+r)/(1+g)*mu_c_jt(j+l-1,t+l-1)-mu_c_jt(j+l-2,t+l-2);
        end
    end

    
end
uw_p_sum_coh=zeros(1,t_dyn+J-1);

% first J cohorts, born before T_pre
for coh=1:J
    for j=1:J % look at their whole life
        Surv(j)=lam_jcoh(j,coh);
        uw_p_sum_coh(coh)=uw_p_sum_coh(coh)+prod(Surv(1:j))*(bet_w_coh(coh)*(1+g)^(1-sig))^(j-1)*uw_p_coh(j,coh);
    end
end



% those born in period t>1
j=1;  % start with age 1
for t=2:t_dyn
    Length=J;
    Lw=Jw;
    coh=J+t-1;
    Interest(1:Length)=1+r;
    for l=1:Length
        Wage(l)=wage_jt(j+l-1,t+l-1); % year l, age depends positively on j
    end
    Surv(1:Length)=lam_jcoh(1:Length,coh);
    Asset_ini=0;
    
    Beta=bet_w_coh(coh);
    R_hat_coh(1,coh)=1;
    R_hat_coh(2:J,coh)=(1+r)./(lam_jcoh(2:J,coh)*(1+g));
    Prod_Beta_hat_l1=1;
    Prod_R_hat_l1=1;
    
    if index_Ramsey_FB==1
        [cw_p_j,h_p_j,yw_p_j,aw_p_j, transfer_p_coh(coh)]=...
            fun_c_a_j_Ramsey_FB(Beta, Prod_Beta_hat_l1, Length, Interest, Prod_R_hat_l1 , Wage, Surv, Asset_ini, lagr);
        tau_w_coh(coh)=0;
    else
        [cw_p_j,h_p_j,yw_p_j,aw_p_j, transfer_p_coh(coh), tau_w_coh(coh)]=...
            fun_c_a_j_Ramsey(Beta, Prod_Beta_hat_l1, Length, Interest, Prod_R_hat_l1 , Wage, Surv, Asset_ini, lagr);
    end
    % put cw_j, aw_j into cw_t, aw_t
    uw_p_sum_coh(coh)=0;
    for l=1:Length
        cw_p_t(j+l-1,t+l-1)=cw_p_j(l);
        h_p_t(j+l-1,t+l-1)=h_p_j(l);
        yw_p_t(j+l-1,t+l-1)=yw_p_j(l);
        aw_p_t(j+l-1,t+l-1)=aw_p_j(l); % asset if the transfer happens in the last period
                
        cw_p_coh(l,coh)=cw_p_j(l); 
        h_p_coh(l,coh)=h_p_j(l); 
        yw_p_coh(l,coh)=yw_p_j(l);
        aw_p_coh(l,coh)=aw_p_j(l); 
       
        uw_p_coh(j+l-1,coh)=fun_u_kpr(cw_p_coh(j+l-1,coh),h_p_coh(j+l-1,coh));
        uw_p_sum_coh(coh)=uw_p_sum_coh(coh)+prod(Surv(1:l))*(bet_w_coh(coh)*(1+g)^(1-sig))^(l-1)*uw_p_coh(l,coh);
    end
    tax_w_coh(coh)=0;
    for l=1:Lw-1
        tau_w_jt(j+l-1,t+l-1)=tau_w_coh(coh);
        tax_w_jt(j+l-1,t+l-1)=tau_w_jt(j+l-1,t+l-1)*wage_jt(j+l-1,t+l-1)*h_p_t(j+l-1,t+l-1);
        tax_w_jt2(j+l-1,t+l-1)=yw_p_t(j+l-1,t+l-1)/(1-tau_w_coh(coh))*tau_w_coh(coh);
        tax_w_coh(coh)=tax_w_coh(coh)+tax_w_jt(j+l-1,t+l-1)*((1+g)/(1+r))^(l-1)*prod(lam_jcoh(j+2-1:j+l-1,coh));
    end
    
    % the transfer is given in the retirement

    pw_jt(Jw,t+Jw-1)=transfer_p_coh(coh);
    net_transfer_p_coh(coh)=transfer_p_coh(coh) - tax_w_coh(coh)*((1+r)/(1+g))^(Jw-j)/prod(lam_jcoh(j+2-1:Jw,coh));
    net_transfer_p_t(Jw,t+Jw-1)=net_transfer_p_coh(coh);
    
    % check errors
    for l=1:Length
        if l>1
            error_c_coh(j+l-1,coh)=cw_p_coh(j+l-1,coh)-bet_w_coh(coh)*(1+r)/(1+g)*cw_p_coh(j+l-1-1,coh);
            error_a_coh(j+l-1,coh)=aw_p_coh(j+l-1,coh)-((1+r)*aw_p_coh(j+l-1-1,coh)+yw_p_coh(j+l-1-1,coh)-cw_p_coh(j+l-1-1,coh))/lam_jcoh(j+l-1,coh)/(1+g);
        end
        if l<Lw
            error_h_coh(j+l-1,coh)=h_p_coh(j+l-1,coh)-((1-tau_w_coh(coh))*wage_jt(j+l-1,t+l-1)/cw_p_coh(j+l-1,coh))^phi;
        end
    end
    l=Length+1;
    error_a_coh(j+l-1,coh)=((1+r)*aw_p_coh(j+l-1-1,coh)+yw_p_coh(j+l-1-1,coh)-cw_p_coh(j+l-1-1,coh))/(1+g);
    
    % marginal utility of c, h, wh
    for l=1:Length
        mu_c_jt(j+l-1,t+l-1)=1/cw_p_t(j+l-1,t+l-1);
        mu_h_jt(j+l-1,t+l-1)=h_p_t(j+l-1,t+l-1)^(1/phi);
        if l<Lw
            err_mu_c_h_jt(j+l-1,t+l-1)=mu_c_jt(j+l-1,t+l-1)*wage_jt(j+l-1,t+l-1) - mu_h_jt(j+l-1,t+l-1);
            err_mu_c_h_tau_jt(j+l-1,t+l-1)=(1-tau_w_jt(j+l-1,t+l-1))*mu_c_jt(j+l-1,t+l-1)*wage_jt(j+l-1,t+l-1) - mu_h_jt(j+l-1,t+l-1);
        end
        if l>2
            err_mu_c_jt(j+l-1,t+l-1)=bet_w_coh(coh)*(1+r)/(1+g)*mu_c_jt(j+l-1,t+l-1)-mu_c_jt(j+l-2,t+l-2);
        end
    end
    
end




%% -------------------- 3. utilitarian welfare of workers ------------------------
uw_p_sum=0;
uw_np_sum=0;

% the older person, the higher weight
% existing cohorts, age j=1:J
t=1;
for j=1:J % j is the age in period 1
    coh=J-j+1;
    uw_p_sum=uw_p_sum+uw_p_sum_coh(coh)*Nw_p_t(j,t)*((1+g)/(1+r))^(1-j);
    if uw_np_sum_coh(coh)~=-Inf
        uw_np_sum=uw_np_sum+uw_np_sum_coh(coh)*Nw_np_t(j,t)*((1+g)/(1+r))^(1-j);
    end
end

% those born in period t>1
for t=2:t_dyn
    coh=J+t-1;
    uw_p_sum=uw_p_sum+uw_p_sum_coh(coh)*Nw_p_t(1,t)*((1+g)/(1+r))^(t-1);
    if uw_np_sum_coh(coh)~=-Inf
        uw_np_sum=uw_np_sum+uw_np_sum_coh(coh)*Nw_np_t(1,t)*((1+g)/(1+r))^(t-1);
    end
end

% the continuation value is very very small, ignored?
uw_p_sum=uw_p_sum+uw_p_sum_coh(J+t_dyn-1)*Nw_p_t(1,t_dyn)*(((1+g)/(1+r))^t_dyn/(1-(1+g)/(1+r)));
uw_np_sum=uw_np_sum+uw_np_sum_coh(J+t_dyn-1)*Nw_np_t(1,t_dyn)*((1+g)/(1+r))^t_dyn/(1-(1+g)/(1+r));

uw_sum=uw_p_sum+uw_np_sum;

% to get the same name as other experiments
pw_sum_coh=transfer_p_coh;
