

%% ----- 1. Workers with Pension -------

% age specific pension base and pension payment
for j=Jw:J
    p_base_jss(j)=(1-indexation)*p_base_ss/(1+g)^(j-Jw+1)+indexation*p_base_ss/(1+g);
    pw_jss(j)=replace_w_ss*p_base_jss(j);
end

% wage and pension vector
wagepension_p_ss(1:Jw-1)=(1-tau_w_ss)*w_ss*prod_jss(1:Jw-1);
wagepension_p_ss(Jw:J)=pw_jss(Jw:J);


Rw(1:J)=1+r;    % interest rates 
aw_p_ss(1)=0; % initial asset

% the worker's problem
Beta=bet_w_ss;
Length=J;
Interest=Rw(1:J);
WagePension=wagepension_p_ss(1:J);
Surv=lam_jss(1:J);
Asset_ini=aw_p_ss(1);
[cw_p_ss,h_p_ss, yw_p_ss, aw_p_ss]=fun_c_a_j_kpr(Beta, Length, Interest, WagePension, Surv, Asset_ini);

error_ave_yw_p_labor_ss= yw_p_ss(1:Jw-1)*Nw_p_ss(1:Jw-1)'/Nw_labor_p_ss/(1-tau_w_ss) - p_base_ss;
% error_ave_yw_p_labor_ss



%% ----- 2. Workers without Pension -------
% wage and pension vector
wagepension_np_ss(1:Jw-1)=w_ss*prod_jss(1:Jw-1);
wagepension_np_ss(Jw:J)=0;

% interest rates for  saving
Rw(1:J)=1+r;
aw_np_ss(1)=0; % initial asset

Beta=bet_w_ss;
Length=J;
Interest=Rw(1:J);
WagePension=wagepension_np_ss(1:J);
Surv=lam_jss(1:J);
Asset_ini=aw_np_ss(1);
[cw_np_ss,h_np_ss,yw_np_ss,aw_np_ss]=fun_c_a_j_kpr(Beta, Length, Interest, WagePension, Surv, Asset_ini);



