% suppose that the fertility is low
% the population is different

%% ---------
load('../Demography3_LowFertility/data_demography_zengyi1_forever', 'N_t_mig', 'Nr_t_mig')

Nw_t_bm2=Nw_t;
Nw_p_t_bm2=Nw_p_t;



%% ----- new N_t 
dif_year=year_start-year_data;

for t=1:t_dyn
    N_t(1:J,t)=N_t_mig(t+dif_year,1:J);
    Nr_t(1:J,t)=Nr_t_mig(t+dif_year,1:J);
end

N_total_t(1)=sum(N_t(1:J,1));
for t=2:t_dyn
    N_total_t(t)=sum(N_t(1:J,t));
    N_growth_t(t)=N_total_t(t)/N_total_t(t-1)-1;
end 

Nw_t=N_t; % all the people are workers

% covered by pension
Perc_w_p_ini=0.6;
Perc_w_p_ss=0.6;

% pension coverage rate for the existing cohorts in 2000 is Perc_w_p_ini
for j=1:J
    coh=J-j+1;
    Perc_w_p_coh(coh)=Perc_w_p_ini;
end
% pension coverage rate for cohorts born before 2013 is Perc_w_p_ini
for t=2:t_2013-1
    coh=J+t-1;
    Perc_w_p_coh(coh)=Perc_w_p_ini;
end
% pension coverage rate for cohorts born between 2013 and 2050 steadily
% increase to Perc_w_p_ss
for t=t_2013:t_2050 % 2052
    coh=J+t-1;
    Perc_w_p_coh(coh)=Perc_w_p_ini+(t-(t_2013-1))/(t_2050-(t_2013-1))*(Perc_w_p_ss-Perc_w_p_ini);
end
% after 2052, Perc_w_p_ss
for t=t_2050+1:t_dyn
    coh=J+t-1;
    Perc_w_p_coh(coh)=Perc_w_p_ss;
end

Perc_w_np_coh=1-Perc_w_p_coh;


for t=1:t_dyn
   
    Nw_total_t(t)=sum(Nw_t(1:J,t));
    % population gaining labor income
    Ne_labor_t(t)=sum(Ne_t(1:Je-1,t));
    Nw_labor_t(t)=sum(Nw_t(1:Jw-1,t));
    % population gaining capital
    Ne_retire_t(t)=sum(Ne_t(Je:J,t));
    Nw_retire_t(t)=sum(Nw_t(Jw:J,t));



    % rural population
    Nr_total_t(t)=sum(Nr_t(1:J,t));
    Nr_labor_t(t)=sum(Nr_t(1:Jw-1,t));
    Nr_retire_t(t)=sum(Nr_t(Jw:J,t));

end


for t=1:t_dyn
    for j=1:J
        % for different age
        Nw_p_t(j,t)=Nw_t(j,t)*Perc_w_p_coh(J-j+t);
        Nw_np_t(j,t)=Nw_t(j,t)*Perc_w_np_coh(J-j+t);
    end
    Nw_labor_p_t(t)=sum(Nw_p_t(1:Jw-1,t));
    Nw_labor_np_t(t)=sum(Nw_np_t(1:Jw-1,t));
    Nw_retire_p_t(t)=sum(Nw_p_t(Jw:J,t));
    Nw_retire_np_t(t)=sum(Nw_np_t(Jw:J,t));
end


Nur_t=N_t+Nr_t;
Nur_total_t(1:t_dyn)=Nw_total_t(1:t_dyn)+Nr_total_t(1:t_dyn);
Nur_labor_t(1:t_dyn)=Nw_labor_t(1:t_dyn)+Nr_labor_t(1:t_dyn);

% test if N_t converges (growth allowed)
check_N_converge=max(N_t(1:J,t_dyn)./sum(N_t(1:J,t_dyn)) - N_t(1:J,t_dyn-1)./sum(N_t(1:J,t_dyn-1)));

% N_ss is the distribution, ( sum normalize to 1, diffrent from sum(N_t(t)))
N_growth_ss=sum(N_t(1:J,t_dyn))/sum(N_t(1:J,t_dyn-1))-1;
scale_N_ss=sum(N_t(1:J,t_dyn)); % scale the population down such that sum(N_ss)=1
N_ss=N_t(1:J,t_dyn)'/scale_N_ss;
Nw_ss=N_ss;
Ne_ss=Ne_t(1:J,t_dyn)'/scale_N_ss; % also need to scale down the entrepreneurs
% percentage gaining labor income
Ne_labor_ss=sum(Ne_ss(1:Je-1));
Nw_labor_ss=sum(Nw_ss(1:Jw-1));
% percentage only gaining capital income
Ne_retire_ss=sum(Ne_ss(Je:J));
Nw_retire_ss=sum(Nw_ss(Jw:J));

Nw_p_ss=Nw_ss*Perc_w_p_ss;
Nw_np_ss=Nw_ss*(1-Perc_w_p_ss);
Nw_labor_p_ss=Nw_labor_ss*Perc_w_p_ss;
Nw_labor_np_ss=Nw_labor_ss*(1-Perc_w_p_ss);
Nw_retire_p_ss=Nw_retire_ss*Perc_w_p_ss;
Nw_retire_np_ss=Nw_retire_ss*(1-Perc_w_p_ss);



%% --------- adjust Fertility rate -------
% no change on fertility rate


