% based on the wage sequence in the baseline scenario
% we adjust the population dynamics



clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

% load variables from the benchmark reform in the baseline scenario
name_data_2013='../Pension1_BaselineScenario/data_benchmark_2013.mat';
load(name_data_2013); 
name_data_2000='../Pension1_BaselineScenario/data_benchmark.mat';


name_exp='benchmark';
name_data_exp='data_benchmark.mat';


index_fixedlabor=0; 
index_gtext=0;

%% --------------- 1.5 Low Fertility Forever --------------------
adjust_pop;


%% ---------------- 2. Solve for Long-run Replacement Rate ----------------

t_reform=2013-year_start+1; % year_start is defined in parameters_t_xxxx.m

index_guess=0;
name_data_eq='data_eq_2013_benchmark.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'replace_w_coh3'); % initial

solve_replace_w_coh3_update_pe;


disp('Dynamic computation finished')
toc
% 
% save(name_data_eq,'H_p_t','H_np_t','p_base_t','replace_w_coh3');

% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;



fig_name='2013';


%% ----------------- 4. Pension Reform Experiment Outcomes ------------------------






experiment_benchmark_2013;     % current system
disp('Experiment_benchmark_2013 finished')
toc


%% ------------------ 5. temp, but may be useful ------------------
figure;
plot(ave_h_p_t(1:100))
hold on
plot(ave_h_np_t(1:100),'color','g')
hold on
plot(ave_h_t(1:100),'color','r')
hold off
title('average working hour from 2013, blue: workers in pension, green: not in pension, red: all workers')

