 

% read the partial equilibrium from the baseline scenario
% here we assume that the interest rate is high

% pension_debt_coh and workers_dyn need to be modified compared to the file
% in the baseline scenario
% so is initialstate_adjust2_fullyfunded


clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

%  load the equilibrium variables from the benchmark reform in the baseline
%  scenario
name_data_2013='../Pension1_BaselineScenario/data_benchmark_2013.mat';
load(name_data_2013); 
name_data_2000='../Pension1_BaselineScenario/data_benchmark.mat';

name_exp='benchmark';
name_data_exp='data_benchmark_2013.mat';

index_fixedlabor=0; 
index_gtext=0;



%%  ------------------- 1 Higher Interest Rate -----------------
adjust_interest;




%% ---------------- 2. Solve for the Long-run Replacement Rate ----------------

t_reform=2013-year_start+1; % year_start is defined in parameters_t_xxxx.m

index_guess=0;
name_data_eq='data_eq_2013_benchmark.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'replace_w_coh3'); % initial

solve_replace_w_coh3_update_pe;


disp('Dynamic computation finished')
toc


% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;



fig_name='2013';


%% ----------------- 4. Pension Reform Experiment Outcomes ------------------------


experiment_benchmark_2013;     % current system
disp('Experiment_benchmark_2013 finished')
toc


