 

% fully funded
% high interest rate


clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

% we can read the equilibrium variables from the benchmark reform in the
% high interest scenario
load('data_benchmark_2013.mat');
name_data_2000='../Pension1_BaselineScenario/data_benchmark.mat';
name_data_2013='data_benchmark_2013.mat';
name_exp='fullyfunded';
name_data_exp='data_fullyfunded.mat';



index_fixedlabor=0; 
index_gtext=0;

%% ------------------- 1  Higher Interest Rate -----------------
adjust_interest;

% -------fully funded adjust initial state --------------
name_data_bm2=name_data_2013;
initialstate_adjust2_fullyfunded; % using data_bm2 adjust the wealth and government debt according to the pension promise

pensionsystem_adjust_fullyfunded;




%% ---------------- 2. Solve for Long-run Replacement Rate ----------------
t_reform=1;
index_guess=0;
name_data_eq='data_eq_2013_fullyfunded.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'tau_w_ss'); % initial

solve_tau_w_update_pe;


disp('Dynamic computation finished')
toc
% save(name_data_eq,'H_p_t','H_np_t','p_base_t','tau_w_ss');

% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;




%% ----------------- 4. Pension Reform Experiment Outcomes ------------------------






experiment_fullyfunded;     % current system
disp('Experiment_fullyfunded finished')
toc
