% adjust the workers' problem, by taking this wage sequence and resolve
% their problem from 1995 with asset from data
% remember to compare the asset in 2013 

%% ------------------ 1. save some old variables ----------------
old.aw_p_t=aw_p_t;
old.aw_np_t=aw_np_t;
old.awr_t=awr_t;



%% ---------------------- 2. Past Wage Sequence -----------------------
bm=load(name_data_2000,'w_t','w_pre_t','T_pre','prod_jt','prod_pre_jt')

% p_base_pre_t is already known
% w_pre_t
if T_pre~=bm.T_pre+t_start-1 || year_start~=2013
    Display('Warning: T_pre~=bm.T_pre+t_start-1, or year_start~=2013')
    pause;
end
year_pre_start=year_start-T_pre;
year_w_start=1995; % from 1995, workers lives starts
t_pre_w_start=T_pre+1+(year_w_start-year_start); % year_start is T_pre+1
t_pre_firstcohort=1+year_start-2000; % the first cohort in 2013 start from this year in pre-periods


% extend p_base_pre_t
p_base_pre_t(T_pre+1:T_pre+J)=p_base_t(1:J);

% temporary w_pre_t, to get g_w_pre_t
w_pre_t=[bm.w_pre_t(1:bm.T_pre) bm.w_t(1:t_start-1)];
t=T_pre+1;
g_w_pre_t(T_pre+1)=w_t(1)/w_pre_t(T_pre)-1;
for t=T_pre:-1:2
    g_w_pre_t(t)=w_pre_t(t)/w_pre_t(t-1)-1;
end

w_pre_t(T_pre)=w_t(1)/(1+g_w_pre_t(T_pre+1));
for t=T_pre-1:-1:1
    w_pre_t(t)=w_pre_t(t+1)/(1+g_w_pre_t(t+1));
end
w_pre_t(T_pre+1:T_pre+J)=w_t(1:J);

tau_w_pre_t(1:T_pre+J)=tau_w_t(1);
prod_pre_jt(1:Jw-1,1:bm.T_pre)=prod_cd*bm.prod_pre_jt(1:Jw-1,1:bm.T_pre);
prod_pre_jt(1:Jw-1,bm.T_pre:T_pre)=prod_cd*bm.prod_jt(1:Jw-1,1:t_start);
prod_pre_jt(1:Jw-1,T_pre+1:T_pre+J)=prod_jt(1:Jw-1,1:J);


%% -------------------- 3. Past p_base_pre_jt --------------------

% age-year specific indexed pension
t=1;
for j=Jw:J
        t_retire=t-j+Jw;
        if t_retire<=1 % retirement goes before pre_t
            % t_retire+J-1 gives the t_retire in pre_t
%             p_base_pre_jt(j,t)=(1-indexation)*p_base_pre_t(1)/(1+growth_p_base_pre_t(1))^(1-t_retire+1)/(1+g)^(j-Jw+1)+indexation*p_base_pre_t(1)/(1+growth_p_base_pre_t(1))/(1+g); % can not track back to earlier, just use the growth rate
            p_base_pre_jt(j,t)=p_base_pre_t(1); % can't go further
        else
            p_base_pre_jt(j,t)=(1-indexation)*p_base_pre_t(t_retire-1)/(1+g)^(j-Jw+1)+indexation*p_base_pre_t(t-1)/(1+g); % from last year
        end
end
for t=2:T_pre+J
    for j=Jw:J
        t_retire=t-j+Jw;
        if t_retire<=1
            % t_retire+J-1 gives the t_retire in pre_t
            p_base_pre_jt(j,t)=(1-indexation)*p_base_pre_t(1)/(1+g)^(t-1)+indexation*p_base_pre_t(t-1)/(1+g); % can not track back to earlier, just use the growth rate
        else
            p_base_pre_jt(j,t)=(1-indexation)*p_base_pre_t(t_retire-1)/(1+g)^(j-Jw+1)+indexation*p_base_pre_t(t-1)/(1+g); % from last year
        end
    end
end


for t=t_start:T_pre % born after 2013-J
    coh=J+t-1+year_pre_start-year_start;
    Length=J;
    for l=1:Length
        replace_w_pre_jt(l,t+l-1)=(l>=Jw)*replace_w_coh(coh);
    end
end
replace_w_pre_jt(Jw:J,T_pre+1:T_pre+J)=replace_w_jt(Jw:J,1:J);
replace_w_pre_jt(1:Jw-1,1:T_pre+J)=0;

pw_pre_jt(Jw:J,1:T_pre+J)=p_base_pre_jt(Jw:J,1:T_pre+J).*replace_w_pre_jt(Jw:J,1:T_pre+J);



%% ---------------------------- 4. Workers Problem from t_pre_w_start -------------------------------
% ------ 4.1 pensioned workers ---------
% income
for t=t_pre_w_start:T_pre
    for j=1:Jw-1
        wagepension_p_pre_t(j,t)=(1-tau_w_pre_t(t))*w_pre_t(t)*prod_pre_jt(j,t);
    end
    for j=Jw:J
        wagepension_p_pre_t(j,t)=pw_pre_jt(j,t);
    end
end
wagepension_p_pre_t(1:J,T_pre+1:T_pre+J)=wagepension_p_t(1:J,1:J);

% given w_t, tau_w_t, solve aw_t, cw_t
% those cohorts already exist in period 1
t=t_pre_w_start;
for j=1:J+(t-T_pre-1) % j is the age in the starting period, the first cohort's age is J+(t-T_pre-1)
    Length=J-j+1;
    coh=1+(t-T_pre-1)+(J-j); % age J in t=T_pre+1 is cohort 1
    Interest(1:Length)=1+r;
    for l=1:Length
        WagePension(l)=wagepension_p_pre_t(j+l-1,t+l-1); % year l, age depends positively on j
    end
    Surv(1:Length)=lam_jcoh(j:j+Length-1,coh);
    Asset_ini=0;
    Beta=bet_w_coh(coh);
    [cw_p_j,h_p_j,yw_p_j,aw_p_j]=fun_c_a_j_kpr(Beta,Length, Interest, WagePension, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t, cw_coh
    
    % l means the lth period he appears in the sample
    for l=1:Length
        cw_p_pre_t(j+l-1,t+l-1)=cw_p_j(l);
        h_p_pre_t(j+l-1,t+l-1)=h_p_j(l);
        yw_p_pre_t(j+l-1,t+l-1)=yw_p_j(l);
        aw_p_pre_t(j+l-1,t+l-1)=aw_p_j(l);
        
        cw_p_coh(j+l-1,coh)=cw_p_j(l);  
        h_p_coh(j+l-1,coh)=h_p_j(l);  
        yw_p_coh(j+l-1,coh)=yw_p_j(l);  
        aw_p_coh(j+l-1,coh)=aw_p_j(l);  


        if sig~=1
            uw_p_coh(j+l-1,coh)=(cw_p_coh(j+l-1,coh)^gamma*(1-h_p_coh(j+l-1,coh))^(1-gamma))^(1-sig)/(1-sig);
        elseif sig==1
            uw_p_coh(j+l-1,coh)=log(cw_p_coh(j+l-1,coh)^gamma*(1-h_p_coh(j+l-1,coh))^(1-gamma));
        end
        
    end
end


% those born in period t>t_pre_w_start
j=1;  % start with age 1
for t=t_pre_w_start+1:T_pre
    Length=J;
    coh=J+(t-T_pre-1); % born in T_pre+1 is cohort J
    Interest(1:Length)=1+r;
    for l=1:Length
        WagePension(l)=wagepension_p_pre_t(l,t+l-1); % year l, age depends positively on j
    end
    Surv(1:Length)=lam_jcoh(1:Length,coh);
    Asset_ini=0;
    Beta=bet_w_coh(coh);
    [cw_p_j,h_p_j,yw_p_j,aw_p_j]=fun_c_a_j_kpr(Beta,Length, Interest, WagePension, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t
    uw_p_sum_coh(coh)=0;
    for l=1:Length
        cw_p_pre_t(l,t+l-1)=cw_p_j(l);
        h_p_pre_t(l,t+l-1)=h_p_j(l);
        yw_p_pre_t(l,t+l-1)=yw_p_j(l);
        aw_p_pre_t(l,t+l-1)=aw_p_j(l);
        
        cw_p_pre_coh(l,coh)=cw_p_j(l); 
        h_p_pre_coh(l,coh)=h_p_j(l); 
        yw_p_pre_coh(l,coh)=yw_p_j(l);
        aw_p_pre_coh(l,coh)=aw_p_j(l); 

        if sig~=1
            uw_p_coh(j+l-1,coh)=(cw_p_coh(j+l-1,coh)^gamma*(1-h_p_coh(j+l-1,coh))^(1-gamma))^(1-sig)/(1-sig);
        elseif sig==1
            uw_p_coh(j+l-1,coh)=log(cw_p_coh(j+l-1,coh)^gamma*(1-h_p_coh(j+l-1,coh))^(1-gamma));
        end
    end
end

aw_p_t(1:J,1)=aw_p_pre_t(1:J,T_pre+1);


% ------------ 4.2 non-pensioned workers -----------

% income
for t=t_pre_w_start:T_pre
    for j=1:Jw-1
        wagepension_np_pre_t(j,t)=w_pre_t(t)*prod_pre_jt(j,t);
    end
    for j=Jw:J
        wagepension_np_pre_t(j,t)=0;
    end
end
wagepension_np_pre_t(1:J,T_pre+1:T_pre+J)=wagepension_np_t(1:J,1:J);

% given w_t, tau_w_t, solve aw_t, cw_t
% those cohorts already exist in period 1
t=t_pre_w_start;
for j=1:J+(t-T_pre-1) % j is the age in the starting period, the first cohort's age is J+(t-T_pre-1)
    Length=J-j+1;
    coh=1+(t-T_pre-1)+(J-j); % age J in t=T_pre+1 is cohort 1
    Interest(1:Length)=1+r;
    for l=1:Length
        WagePension(l)=wagepension_np_pre_t(j+l-1,t+l-1); % year l, age depends positively on j
    end
    Surv(1:Length)=lam_jcoh(j:j+Length-1,coh);
    Asset_ini=0;
    Beta=bet_w_coh(coh);
    [cw_np_j,h_np_j,yw_np_j,aw_np_j]=fun_c_a_j_kpr(Beta,Length, Interest, WagePension, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t, cw_coh
    
    % l means the lth period he appears in the sample
    for l=1:Length
        cw_np_pre_t(j+l-1,t+l-1)=cw_np_j(l);
        h_np_pre_t(j+l-1,t+l-1)=h_np_j(l);
        yw_np_pre_t(j+l-1,t+l-1)=yw_np_j(l);
        aw_np_pre_t(j+l-1,t+l-1)=aw_np_j(l);
        
        cw_np_coh(j+l-1,coh)=cw_np_j(l);  
        h_np_coh(j+l-1,coh)=h_np_j(l);  
        yw_np_coh(j+l-1,coh)=yw_np_j(l);  
        aw_np_coh(j+l-1,coh)=aw_np_j(l);  


        if sig~=1
            uw_np_coh(j+l-1,coh)=(cw_np_coh(j+l-1,coh)^gamma*(1-h_np_coh(j+l-1,coh))^(1-gamma))^(1-sig)/(1-sig);
        elseif sig==1
            uw_np_coh(j+l-1,coh)=log(cw_np_coh(j+l-1,coh)^gamma*(1-h_np_coh(j+l-1,coh))^(1-gamma));
        end
        
    end
end


% those born in period t>t_pre_w_start
j=1;  % start with age 1
for t=t_pre_w_start+1:T_pre
    Length=J;
    coh=J+(t-T_pre-1); % born in T_pre+1 is cohort J
    Interest(1:Length)=1+r;
    for l=1:Length
        WagePension(l)=wagepension_np_pre_t(l,t+l-1); % year l, age depends positively on j
    end
    Surv(1:Length)=lam_jcoh(1:Length,coh);
    Asset_ini=0;
    Beta=bet_w_coh(coh);
    [cw_np_j,h_np_j,yw_np_j,aw_np_j]=fun_c_a_j_kpr(Beta,Length, Interest, WagePension, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t
    uw_np_sum_coh(coh)=0;
    for l=1:Length
        cw_np_pre_t(l,t+l-1)=cw_np_j(l);
        h_np_pre_t(l,t+l-1)=h_np_j(l);
        yw_np_pre_t(l,t+l-1)=yw_np_j(l);
        aw_np_pre_t(l,t+l-1)=aw_np_j(l);
        
        cw_np_pre_coh(l,coh)=cw_np_j(l); 
        h_np_pre_coh(l,coh)=h_np_j(l); 
        yw_np_pre_coh(l,coh)=yw_np_j(l);
        aw_np_pre_coh(l,coh)=aw_np_j(l); 

        if sig~=1
            uw_np_coh(j+l-1,coh)=(cw_np_coh(j+l-1,coh)^gamma*(1-h_np_coh(j+l-1,coh))^(1-gamma))^(1-sig)/(1-sig);
        elseif sig==1
            uw_np_coh(j+l-1,coh)=log(cw_np_coh(j+l-1,coh)^gamma*(1-h_np_coh(j+l-1,coh))^(1-gamma));
        end
    end
end

aw_np_t(1:J,1)=aw_np_pre_t(1:J,T_pre+1);

%% ------------------------ 5. Workers Problem from 2013 ----------------------
workers_dyn;

% 1+1
