% draw figures of the solutions

%% ----------------------- Wage Sequence, Approxmiate ----------------------------

figure;
t_fig=50;
x_fig=year_start:year_start+t_fig-1;
y1_fig(2:t_fig)=w_t(2:t_fig)./w_t(1:t_fig-1)-1+g;
y2_fig(2:t_2013)=growth_w_0013+g;
y2_fig(t_2013+1:t_2031)=growth_w_1331+g;
y2_fig(t_2031+1:t_2040)=growth_w_3140+g;
y2_fig(t_2040+1:t_2050)=growth_w_4050+g;

plot(x_fig(2:t_fig),y1_fig(2:t_fig),'LineWidth',2);
hold on
plot(x_fig(2:t_fig),y2_fig(2:t_fig),'-.','color','r','LineWidth',2);
hold off
xlabel('year')
% ylabel('')
title('Wage Growth')
axis tight% print -dpng 'Capital_EFirm.png'


print( '-dpng', ['Wage_Growth_Exogenous.png']);



%% ------------------------ Wage Sequence, Compared to Before -----------------------

bm44_1=load('../Pension1_BaselineScenario/data_benchmark','w_t');

figure;
t_fig=50;
x_fig=year_start:year_start+t_fig-1;

subplot(2,1,1)
plot(x_fig,w_t(1:t_fig),'LineWidth',2);
hold on
plot(x_fig,bm44_1.w_t(1:t_fig),'-.','color','red','LineWidth',2);
hold off
xlabel('year')
% ylabel('')
title('Wage Sequence')
axis tight
% print -dpng 'wage.png'

subplot(2,1,2)
plot(x_fig(2:t_fig),w_t(2:t_fig)./w_t(1:t_fig-1)+0.02,'LineWidth',2);
hold on
plot(x_fig(2:t_fig),bm44_1.w_t(2:t_fig)./bm44_1.w_t(1:t_fig-1)+0.02,'-.','color','r','LineWidth',2);
hold off
xlabel('year')
% ylabel('')
title('Wage Growth')
axis tight% print -dpng 'Capital_EFirm.png'


print( '-dpng', ['Wage_Compare.png']);


%% ------------------------ Household Saving Rate -------------------------
figure;
t_fig=11;
x_fig=year_start:year_start+t_fig-1;
subplot(2,2,1)
plot(x_fig,Sav_rate_w_t(1:t_fig),'LineWidth',1.5);
xlabel('year')
% ylabel('')
title('Urban Household Saving Rate')
axis tight
% print -dpng 'wage.png'

subplot(2,2,2)
plot(x_fig,Sav_rate_wr_t(1:t_fig),'LineWidth',1.5);
xlabel('year')
% ylabel('')
title('Rural Household Saving Rate')
axis tight% print -dpng 'Capital_EFirm.png'


subplot(2,2,3)
plot(x_fig,Sav_rate_e_t(1:t_fig),'LineWidth',1.5);
xlabel('year')
% ylabel('')
title('Entrepreneur Saving Rate')
axis tight

% subplot(3,2,4)
% plot(x_fig,RE_t(1:t_fig));
% xlabel('year')
% ylabel('RE')
% title('Entrepreneur saving return')
% % print -dpng 'SavingReturn_Entrepreneur.png'

subplot(2,2,4)

y1_fig=Sav_rate_ure_t(1:t_fig);
y2_fig=Sav_rate_ur_t(1:t_fig);


plot(x_fig,y1_fig,'LineWidth',1.5);
hold on
plot(x_fig,y2_fig,'-.','color','r','LineWidth',1.5);
hold off
xlabel('year')
% ylabel('')
title('All Household Saving Rate')
axis tight

x_text=2007;
i_x_text=x_text-x_fig(1)+1;
y1_text=y1_fig(i_x_text);
y2_text=y2_fig(i_x_text);
text(x_text,y1_text,'With Entrepreneurs', 'VerticalAlignment','bottom');
text(x_text,y2_text,'Without Entrepreneurs','VerticalAlignment','top');


print( '-dpng', ['HouseholdSavingRate_2000_2010.png']);




%% -------------------------- Wealth Distribution 1995, 2000, 2002 --------------------------------
%  ----------- 1995



% wealth of workers w./w.o. pension
aw_pre_t=(aw_p_pre_t(1:J,1:T_pre)*Perc_w_p_ini+aw_np_pre_t(1:J,1:T_pre)*(1-Perc_w_p_ini));
yw_pre_t=(yw_p_pre_t(1:J,1:T_pre)*Perc_w_p_ini+yw_np_pre_t(1:J,1:T_pre)*(1-Perc_w_p_ini));
ave_yw_pre_t=sum(yw_pre_t.*(Nw_t(1:J,1)*ones(1,T_pre)),1)./sum(Nw_t(1:J,1)*ones(1,T_pre),1);
% x_fig=age_ini:age_ini+Jw-1-1; % from age 22 to 100
% y1_fig=aw_p_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% y2_fig=aw_np_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% y3_fig=aw_t(1:Jw-1,1)./yw_t(1:Jw-1,1);

x_fig=age_ini:age_ini+J-1; % from age 22 to 100
% y1_fig=aw_p_t(1:J,1)./yw_t(1:J,1);
% y2_fig=aw_np_t(1:J,1)./yw_t(1:J,1);
% y3_fig=aw_t(1:J,1)./yw_t(1:J,1);
y1_fig=aw_p_pre_t(1:J,t_pre_w_start)/ave_yw_pre_t(t_pre_w_start);
y2_fig=aw_np_pre_t(1:J,t_pre_w_start)/ave_yw_pre_t(t_pre_w_start);
y3_fig=aw_pre_t(1:J,t_pre_w_start)/ave_yw_pre_t(t_pre_w_start);

width_line=3;

pos_fromleft=200; pos_frombottom=50; figure('Position',[pos_fromleft pos_frombottom 800 600])
% semilogy(x_fig,100*(1+g).^([1:t_fig]-1).*ave_yw_netprod_t(1:t_fig)./ave_yw_netprod_t(1),'LineWidth',width_line);
plot(x_fig,y1_fig,'LineWidth',width_line);
hold on
plot(x_fig,y2_fig,'-.','LineWidth',width_line,'color','black');
hold on
plot(x_fig,y3_fig,'LineWidth',width_line,'color','r');
hold off

% set(gca,'YTick',[100,200,400,800,1600,3200])
xlabel('Age')
ylabel('Wealth over Average Wage')
title('\fontsize{14} Wealth Distribution in 1995')
axis tight

% x_text=45;
% i_x_text=x_text-x_fig(1)+1;
% y1_text=y1_fig(i_x_text)+0.2;
% y2_text=y2_fig(i_x_text)-0.1;
% y3_text=y3_fig(i_x_text)+0.2;
% text(x_text,y1_text,'With Pension', 'VerticalAlignment','bottom');
% text(x_text,y2_text,'Without Pension','VerticalAlignment','top');
% text(x_text,y3_text,'Unconditional','VerticalAlignment','bottom');


print -dpng 'aw_1995.png'
print( '-depsc2', ['aw_1995.eps']);

% 
% % x_fig=age_ini:age_ini+Jw-1-1; % from age 22 to 100
% % y1_fig=aw_p_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% % y2_fig=aw_np_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% % y3_fig=aw_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% 
% x_fig=age_ini:age_ini+J-1; % from age 22 to 100
% y1_fig=aw_p_pre_t(1:J,t_pre_w_start)./yw_pre_t(1:J,t_pre_w_start);
% y2_fig=aw_np_pre_t(1:J,t_pre_w_start)./yw_pre_t(1:J,t_pre_w_start);
% y3_fig=aw_pre_t(1:J,t_pre_w_start)./yw_pre_t(1:J,t_pre_w_start);
% % y1_fig=aw_p_t(1:J,1)/ave_yw_t(1);
% % y2_fig=aw_np_t(1:J,1)/ave_yw_t(1);
% % y3_fig=aw_t(1:J,1)/ave_yw_t(1);
% 
% width_line=3;
% 
% pos_fromleft=200; pos_frombottom=50; figure('Position',[pos_fromleft pos_frombottom 800 600])
% % semilogy(x_fig,100*(1+g).^([1:t_fig]-1).*ave_yw_netprod_t(1:t_fig)./ave_yw_netprod_t(1),'LineWidth',width_line);
% plot(x_fig,y1_fig,'LineWidth',width_line);
% hold on
% plot(x_fig,y2_fig,'-.','LineWidth',width_line,'color','black');
% hold on
% plot(x_fig,y3_fig,'LineWidth',width_line,'color','r');
% hold off
% 
% % set(gca,'YTick',[100,200,400,800,1600,3200])
% xlabel('Age')
% ylabel('Wealth over Income')
% title('\fontsize{14} Wealth Income Ratio in 1995')
% axis tight
% 
% % x_text=45;
% % i_x_text=x_text-x_fig(1)+1;
% % y1_text=y1_fig(i_x_text)+0.2;
% % y2_text=y2_fig(i_x_text)-0.1;
% % y3_text=y3_fig(i_x_text)+0.2;
% % text(x_text,y1_text,'With Pension', 'VerticalAlignment','bottom');
% % text(x_text,y2_text,'Without Pension','VerticalAlignment','top');
% % text(x_text,y3_text,'Unconditional','VerticalAlignment','bottom');
% 
% 
% print -dpng 'awyw_1995.png'
% print( '-depsc2', ['awyw_1995.eps']);





% wealth of workers w./w.o. pension
aw_t=(aw_p_t(1:J,1:t_dyn).*Nw_p_t+aw_np_t(1:J,1:t_dyn).*Nw_np_t)./(Nw_p_t+Nw_np_t);
yw_t=(yw_p_t(1:J,1:t_dyn).*Nw_p_t+yw_np_t(1:J,1:t_dyn).*Nw_np_t)./(Nw_p_t+Nw_np_t);
ave_yw_includingretire_t=sum(yw_t.*Nw_t,1)./sum(Nw_t,1);

% x_fig=age_ini:age_ini+Jw-1-1; % from age 22 to 100
% y1_fig=aw_p_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% y2_fig=aw_np_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% y3_fig=aw_t(1:Jw-1,1)./yw_t(1:Jw-1,1);

x_fig=age_ini:age_ini+J-1; % from age 22 to 100
% y1_fig=aw_p_t(1:J,1)./yw_t(1:J,1);
% y2_fig=aw_np_t(1:J,1)./yw_t(1:J,1);
% y3_fig=aw_t(1:J,1)./yw_t(1:J,1);
y1_fig=aw_p_t(1:J,1)/ave_yw_includingretire_t(1);
y2_fig=aw_np_t(1:J,1)/ave_yw_includingretire_t(1);
y3_fig=aw_t(1:J,1)/ave_yw_includingretire_t(1);

width_line=3;

pos_fromleft=200; pos_frombottom=50; figure('Position',[pos_fromleft pos_frombottom 800 600])
% semilogy(x_fig,100*(1+g).^([1:t_fig]-1).*ave_yw_includingretire_netprod_t(1:t_fig)./ave_yw_includingretire_netprod_t(1),'LineWidth',width_line);
plot(x_fig,y1_fig,'LineWidth',width_line);
hold on
plot(x_fig,y2_fig,'-.','LineWidth',width_line,'color','black');
hold on
plot(x_fig,y3_fig,'LineWidth',width_line,'color','r');
hold off

% set(gca,'YTick',[100,200,400,800,1600,3200])
xlabel('Age')
ylabel('Wealth over Average Wage')
title('\fontsize{14} Wealth Distribution in 2000')
axis tight

x_text=45;
i_x_text=x_text-x_fig(1)+1;
y1_text=y1_fig(i_x_text)+0.2;
y2_text=y2_fig(i_x_text)-0.1;
y3_text=y3_fig(i_x_text)+0.2;
text(x_text,y1_text,'With Pension', 'VerticalAlignment','bottom');
text(x_text,y2_text,'Without Pension','VerticalAlignment','top');
text(x_text,y3_text,'Unconditional','VerticalAlignment','bottom');


print -dpng 'aw_2000.png'
print( '-depsc2', ['aw_2000.eps']);


% 
% % wealth of workers w./w.o. pension
% aw_t=(aw_p_t(1:J,1:t_dyn).*Nw_p_t+aw_np_t(1:J,1:t_dyn).*Nw_np_t)./(Nw_p_t+Nw_np_t);
% yw_t=(yw_p_t(1:J,1:t_dyn).*Nw_p_t+yw_np_t(1:J,1:t_dyn).*Nw_np_t)./(Nw_p_t+Nw_np_t);
% ave_yw_includingretire_t=sum(yw_t.*Nw_t,1)./sum(Nw_t,1);
% 
% % x_fig=age_ini:age_ini+Jw-1-1; % from age 22 to 100
% % y1_fig=aw_p_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% % y2_fig=aw_np_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% % y3_fig=aw_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% 
% x_fig=age_ini:age_ini+J-1; % from age 22 to 100
% y1_fig=aw_p_t(1:J,1)./yw_t(1:J,1);
% y2_fig=aw_np_t(1:J,1)./yw_t(1:J,1);
% y3_fig=aw_t(1:J,1)./yw_t(1:J,1);
% % y1_fig=aw_p_t(1:J,1)/ave_yw_includingretire_t(1);
% % y2_fig=aw_np_t(1:J,1)/ave_yw_includingretire_t(1);
% % y3_fig=aw_t(1:J,1)/ave_yw_includingretire_t(1);
% 
% width_line=3;
% 
% pos_fromleft=200; pos_frombottom=50; figure('Position',[pos_fromleft pos_frombottom 800 600])
% % semilogy(x_fig,100*(1+g).^([1:t_fig]-1).*ave_yw_includingretire_netprod_t(1:t_fig)./ave_yw_includingretire_netprod_t(1),'LineWidth',width_line);
% plot(x_fig,y1_fig,'LineWidth',width_line);
% hold on
% plot(x_fig,y2_fig,'-.','LineWidth',width_line,'color','black');
% hold on
% plot(x_fig,y3_fig,'LineWidth',width_line,'color','r');
% hold off
% 
% % set(gca,'YTick',[100,200,400,800,1600,3200])
% xlabel('Age')
% ylabel('Wealth over Income')
% title('\fontsize{14} Wealth Income Ratio in 2000')
% axis tight
% 
% x_text=45;
% i_x_text=x_text-x_fig(1)+1;
% y1_text=y1_fig(i_x_text)+0.2;
% y2_text=y2_fig(i_x_text)-0.1;
% y3_text=y3_fig(i_x_text)+0.2;
% text(x_text,y1_text,'With Pension', 'VerticalAlignment','bottom');
% text(x_text,y2_text,'Without Pension','VerticalAlignment','top');
% text(x_text,y3_text,'Unconditional','VerticalAlignment','bottom');
% 
% 
% print -dpng 'awyw_2000.png'
% print( '-depsc2', ['awyw_2000.eps']);






% x_fig=age_ini:age_ini+Jw-1-1; % from age 22 to 100
% y1_fig=aw_p_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% y2_fig=aw_np_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% y3_fig=aw_t(1:Jw-1,1)./yw_t(1:Jw-1,1);

t_2002=1+2002-year_start;
x_fig=age_ini:age_ini+J-1; % from age 22 to 100
% y1_fig=aw_p_t(1:J,1)./yw_t(1:J,1);
% y2_fig=aw_np_t(1:J,1)./yw_t(1:J,1);
% y3_fig=aw_t(1:J,1)./yw_t(1:J,1);
y1_fig=aw_p_t(1:J,t_2002)/ave_yw_includingretire_t(t_2002);
y2_fig=aw_np_t(1:J,t_2002)/ave_yw_includingretire_t(t_2002);
y3_fig=aw_t(1:J,t_2002)/ave_yw_includingretire_t(t_2002);

width_line=3;

pos_fromleft=200; pos_frombottom=50; figure('Position',[pos_fromleft pos_frombottom 800 600])
% semilogy(x_fig,100*(1+g).^([1:t_fig]-1).*ave_yw_includingretire_netprod_t(1:t_fig)./ave_yw_includingretire_netprod_t(1),'LineWidth',width_line);
plot(x_fig,y1_fig,'LineWidth',width_line);
hold on
plot(x_fig,y2_fig,'-.','LineWidth',width_line,'color','black');
hold on
plot(x_fig,y3_fig,'LineWidth',width_line,'color','r');
hold off

% set(gca,'YTick',[100,200,400,800,1600,3200])
xlabel('Age')
ylabel('Wealth over Average Wage')
title('\fontsize{14} Wealth Distribution in 2002')
axis tight

x_text=45;
i_x_text=x_text-x_fig(1)+1;
y1_text=y1_fig(i_x_text)+0.2;
y2_text=y2_fig(i_x_text)-0.1;
y3_text=y3_fig(i_x_text)+0.2;
text(x_text,y1_text,'With Pension', 'VerticalAlignment','bottom');
text(x_text,y2_text,'Without Pension','VerticalAlignment','top');
text(x_text,y3_text,'Unconditional','VerticalAlignment','bottom');


print -dpng 'aw_2002.png'
print( '-depsc2', ['aw_2002.eps']);

% 
% 
% % x_fig=age_ini:age_ini+Jw-1-1; % from age 22 to 100
% % y1_fig=aw_p_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% % y2_fig=aw_np_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% % y3_fig=aw_t(1:Jw-1,1)./yw_t(1:Jw-1,1);
% 
% x_fig=age_ini:age_ini+J-1; % from age 22 to 100
% y1_fig=aw_p_t(1:J,t_2002)./yw_t(1:J,t_2002);
% y2_fig=aw_np_t(1:J,t_2002)./yw_t(1:J,t_2002);
% y3_fig=aw_t(1:J,t_2002)./yw_t(1:J,t_2002);
% % y1_fig=aw_p_t(1:J,1)/ave_yw_includingretire_t(1);
% % y2_fig=aw_np_t(1:J,1)/ave_yw_includingretire_t(1);
% % y3_fig=aw_t(1:J,1)/ave_yw_includingretire_t(1);
% 
% width_line=3;
% 
% pos_fromleft=200; pos_frombottom=50; figure('Position',[pos_fromleft pos_frombottom 800 600])
% % semilogy(x_fig,100*(1+g).^([1:t_fig]-1).*ave_yw_includingretire_netprod_t(1:t_fig)./ave_yw_includingretire_netprod_t(1),'LineWidth',width_line);
% plot(x_fig,y1_fig,'LineWidth',width_line);
% hold on
% plot(x_fig,y2_fig,'-.','LineWidth',width_line,'color','black');
% hold on
% plot(x_fig,y3_fig,'LineWidth',width_line,'color','r');
% hold off
% 
% % set(gca,'YTick',[100,200,400,800,1600,3200])
% xlabel('Age')
% ylabel('Wealth over Income')
% title('\fontsize{14} Wealth Income Ratio in 2002')
% axis tight
% 
% x_text=45;
% i_x_text=x_text-x_fig(1)+1;
% y1_text=y1_fig(i_x_text)+0.2;
% y2_text=y2_fig(i_x_text)-0.1;
% y3_text=y3_fig(i_x_text)+0.2;
% text(x_text,y1_text,'With Pension', 'VerticalAlignment','bottom');
% text(x_text,y2_text,'Without Pension','VerticalAlignment','top');
% text(x_text,y3_text,'Unconditional','VerticalAlignment','bottom');
% 
% 
% print -dpng 'awyw_2002.png'
% print( '-depsc2', ['awyw_2002.eps']);


%% ------------------- Growth
index_growth=11; % 1st digit means using urban+rural/urban, 2st means using moving average/noma


% for t_fig=[21,41,61,121]
% for t_fig=[41,101]
for t_fig=[41]
    
    x_fig=year_start:year_start+t_fig-1;



    




figure
subplot(3,2,1)
plot(x_fig,w_t(1:t_fig)./w_t(1),'LineWidth',1.5);
xlabel('year')
ylabel('w')
title('wage')
axis tight
% print -dpng 'wage.png'

subplot(3,2,2)
plot(x_fig,AE_t(1:t_fig)./N_total_t(1:t_fig),'-','color','b','LineWidth',1.5);
hold on
plot(x_fig,KE_t(1:t_fig)./N_total_t(1:t_fig),'-.','color','r','LineWidth',1.5);
hold off
xlabel('year')
ylabel('KE')
title('asset and capital in E firms over population')
axis tight
% print -dpng 'Capital_EFirm.png'


subplot(3,2,3)
plot(x_fig,rho_t(1:t_fig),'LineWidth',1.5);
xlabel('year')
ylabel('\rho')
title('E firms capital return')
axis tight
% print -dpng 'CapitalReturn_EFirm.png'

% subplot(3,2,4)
% plot(x_fig,RE_t(1:t_fig));
% xlabel('year')
% ylabel('RE')
% title('Entrepreneur saving return')
% % print -dpng 'SavingReturn_Entrepreneur.png'

subplot(3,2,4)
plot(x_fig,KE_t(1:t_fig)./H_t(1:t_fig),'LineWidth',1.5);
xlabel('year')
ylabel('KE/H')
title('E Firm Capital - Total Labor Ratio')
axis tight
% print -dpng 'SavingReturn_Entrepreneur.png'


subplot(3,2,5)
% plot(1:t_dyn,N_total_t(1:t_dyn));
% hold on
% plot(1:t_dyn,Ne_labor_t(1:t_dyn));
% hold on
% plot(1:t_dyn,Nw_labor_t(1:t_dyn));
% % hold off
% plot(x_fig,N_total_t(1:t_fig),'-','color','b');
% hold on
% plot(x_fig,Ne_labor_t(1:t_fig)*19,'-','color','g');
% hold on
% plot(x_fig,Nw_labor_t(1:t_fig),'-','color','r');
% hold off
% t_HEshare=30;
% xlabel('year')
% ylabel('Population')
% title('Population of Workers')

% t_HEshare=30;
% plot(1:t_HEshare,HE_t(1:t_HEshare)./H_t(1:t_HEshare),'-','color','r');
% hold on
% plot(1:length(target_share_HE),target_share_HE/100,'.','color','b');
% hold on
% plot(1:length(target2_share_HE),target2_share_HE/100,'-','color','g');
% hold off
plot(x_fig,HE_t(1:t_fig)./H_t(1:t_fig),'-','color','r','LineWidth',1.5);
hold on
plot(year_start:year_start+length(target_share_HE)-1,target_share_HE/100,'.','color','b','LineWidth',1.5);
hold on
plot(year_start:year_start+length(target2_share_HE)-1,target2_share_HE/100,'-','color','g','LineWidth',1.5);
hold off
xlabel('year')
ylabel('HE/H')
title('E Firm Labor')

axis([year_start year_start+t_fig-1 0 1])

subplot(3,2,6)
if index_growth==11
    plot(x_fig(2:t_fig),growth_Yur_t_ma(2:t_fig),'color','b','LineWidth',1.5);
elseif index_growth==21
    plot(x_fig(2:t_fig),growth_Y_t_ma(2:t_fig),'color','b','LineWidth',1.5);
elseif index_growth==22
    plot(x_fig(2:t_fig),growth_Y_t(2:t_fig),'color','b','LineWidth',1.5);
end

% hold on
% plot(2:t_fig,growth_y_t(2:t_fig),'-.','color','r');
% hold off
xlabel('year')
ylabel('Growth')
title('GDP Growth (in excess of world growth)')
axis tight
print( '-dpng', '-r300', ['transition_' fig_name '_' num2str(year_start) '-' num2str(year_start+t_fig-1) '.png']);
print( '-depsc2', ['transition_' fig_name '_' num2str(year_start) '-' num2str(year_start+t_fig-1) '.eps']);

figure;
if index_growth==11
    plot(x_fig(2:t_fig),growth_Yur_t_ma(2:t_fig),'color','b','LineWidth',1.5);
    hold on
    plot(x_fig(2:t_fig),growth_yur_t_ma(2:t_fig),'color','g','LineWidth',1.5);
    hold on
    plot(x_fig(2:t_fig),growth_yur_pw_t_ma(2:t_fig),'color','r','LineWidth',1.5);
    hold off
elseif index_growth==21
    plot(x_fig(2:t_fig),growth_Y_t_ma(2:t_fig),'color','b','LineWidth',1.5);
    hold on
    plot(x_fig(2:t_fig),growth_y_t_ma(2:t_fig),'color','g','LineWidth',1.5);
    hold on
    plot(x_fig(2:t_fig),growth_y_pw_t_ma(2:t_fig),'color','r','LineWidth',1.5);
    hold off
elseif index_growth==22
plot(x_fig(2:t_fig),growth_Y_t(2:t_fig),'color','b','LineWidth',1.5);
hold on
plot(x_fig(2:t_fig),growth_y_t(2:t_fig),'color','g','LineWidth',1.5);
hold on
plot(x_fig(2:t_fig),growth_y_pw_t(2:t_fig),'color','r','LineWidth',1.5);
hold off
end
xlabel('year')
ylabel('Growth')
title(' Growth of GDP, GDP per capita, GDP per worker (in excess of world growth)')
axis tight
print( '-dpng', '-r300', ['growth_' fig_name '_' num2str(year_start) '-' num2str(year_start+t_fig-1) '.png']);
print( '-depsc2', ['growth_' fig_name '_' num2str(year_start) '-' num2str(year_start+t_fig-1) '.eps']);


end


%% ----------------------- Population and Labor Supply ----------------

t_fig=41;
x_fig=year_start:year_start+t_fig-1;
x_fig_grow=year_start+1:year_start+t_fig;


figure

subplot(3,2,1)
% plot(x_fig,N_total_t(1:t_fig),'color','b');
plot(x_fig,pop_total_t(1:t_fig),'color','b','LineWidth',1.5);
hold on 
% plot(x_fig,Nw_labor_t(1:t_fig),'color','g');
plot(x_fig,pop_labor_t(1:t_fig),'color','g','LineWidth',1.5);
hold off
xlabel('year')
ylabel('N')
title('Population and Working Population in Urban')
axis tight

subplot(3,2,2)
% plot(x_fig_grow,N_total_t(2:t_fig+1)./N_total_t(1:t_fig)-1,'color','b');
plot(x_fig_grow,pop_total_t(2:t_fig+1)./pop_total_t(1:t_fig)-1,'color','b','LineWidth',1.5);
hold on 
% plot(x_fig_grow,Nw_labor_t(2:t_fig+1)./Nw_labor_t(1:t_fig)-1,'color','g');
plot(x_fig_grow,pop_labor_t(2:t_fig+1)./pop_labor_t(1:t_fig)-1,'color','g','LineWidth',1.5);
hold off
xlabel('year')
ylabel('growth N')
title('Growth of Population and Working Population in Urban')
axis tight

subplot(3,2,3)
plot(x_fig,H_t(1:t_fig),'color','b','LineWidth',1.5);
hold on
plot(x_fig,agg_prod_t(1:t_fig),'color','g','LineWidth',1.5);
hold off
xlabel('year')
ylabel('H, agg-eff-unit')
title('Labor Supply, Total Efficient Unit')
axis tight

subplot(3,2,4)
plot(x_fig_grow,H_t(2:t_fig+1)./H_t(1:t_fig)-1,'color','b','LineWidth',1.5);
hold on
plot(x_fig_grow,agg_prod_t(2:t_fig+1)./agg_prod_t(1:t_fig)-1,'color','g','LineWidth',1.5);
hold off
xlabel('year')
ylabel('growth H, agg-eff-unit')
title('Growth of Labor Supply, Total Efficient Unit')
axis tight

subplot(3,2,5)
plot(x_fig,w_t(1:t_fig),'color','b','LineWidth',1.5);
xlabel('year')
ylabel('w')
title('Wage')
axis tight

subplot(3,2,6)
plot(x_fig_grow,w_t(2:t_fig+1)./w_t(1:t_fig)-1,'color','b','LineWidth',1.5);
xlabel('year')
ylabel('growth of w')
title('Growth of Wage')
axis tight

% for t=1:t_fig+1
%     N_total_t_nomig(t)=sum(N_t_no_mig(t,:));
%     Nw_labor_t_nomig(t)=sum(N_t_no_mig(t,1:Jw-1));
% end
% 
% subplot(4,2,7)
% plot(x_fig,N_total_t_nomig(1:t_fig),'color','b');
% hold on 
% plot(x_fig,Nw_labor_t_nomig(1:t_fig),'color','g');
% hold off
% xlabel('year')
% ylabel('N-nomig')
% title('Population and Worker Population without Migration')
% axis tight

% 
% subplot(4,2,8)
% plot(x_fig_grow,N_total_t_nomig(2:t_fig+1)./N_total_t_nomig(1:t_fig)-1,'color','b');
% hold on 
% plot(x_fig_grow,Nw_labor_t_nomig(2:t_fig+1)./Nw_labor_t_nomig(1:t_fig)-1,'color','g');
% hold off
% xlabel('year')
% ylabel('growth N-nomig')
% title('Growth of Population and Worker Population without Migration')
% axis tight


print( '-dpng', '-r300', ['labor_' fig_name '_' num2str(year_start) '-' num2str(year_start+t_fig-1) '.png']);
print( '-depsc2', ['labor_' fig_name '_' num2str(year_start) '-' num2str(year_start+t_fig-1) '.eps']);


