
% partial equilibrium from 2013
% then use the step function for the wage growth

index_run_main_2013_HAE_w_original=0;
if index_run_main_2013_HAE_w_original==1
    main_2013_HAE_w_original;
end


clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

name_data_2000='data_benchmark.mat';
name_data_2013='data_benchmark_2013_w_original.mat';
% load variables from benchmark 2013
load(name_data_2013); 

name_exp='benchmark';
name_data_exp='data_benchmark_2013.mat';



index_fixedlabor=0; 
index_gtext=0;


%% ---------------- 1. Adjust wage growth into the step function -------------------------
adjust_w_step;


%% ---------------- 2. Solve for Long-run Replacement Rate ----------------


year_reform=year_start;


t_reform=year_reform-year_start+1; % year_start is defined in parameters_t_xxxx.m


index_guess=0;
name_data_eq='data_eq_2013_benchmark.mat';
name_data_guess=name_data_eq;
% name_data_guess=name_data_2013;
name_data_load=name_data_exp;
load(name_data_guess,'H_p_t','H_np_t','p_base_t','replace_w_coh3');
H_p_t=H_p_t(1:t_dyn); H_np_t=H_np_t(1:t_dyn); p_base_t=p_base_t(1:t_dyn);

tol_setting_accurate;
tol_setting_accurate2;

solve_replace_w_coh3_update_pe;


disp('Dynamic computation finished')
replace_w_coh3
toc

save(name_data_eq,'H_p_t','H_np_t','p_base_t','replace_w_coh3');

% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur_noupdateAg;






%% ----------------- 3. Pension Reform Experiment Outcomes ------------------------
experiment_benchmark_2013;     % current system
disp('Experiment_benchmark finished')
toc



