% from transfer to replace_w_coh


% those cohorts already exist in period 1
t=1;
for j=1:J % j is the age in period 1
    Length=J-j+1;
    Lw=Jw-j+1; % the period of retirement
    coh=J-j+1;
    
    p_base_sum_coh(coh)=0;
    if Lw<1
        for l=1:Length
            p_base_l(l)=p_base_jt(j+l-1,t+l-1); % year l, age depends positively on j
            p_base_sum_coh(coh)=p_base_sum_coh(coh)+p_base_l(l)/prod(R_hat_coh(1+j+1-1:j+l-1,coh));
        end
    else
        for l=Lw:Length
            p_base_l(l)=p_base_jt(j+l-1,t+l-1); % year l, age depends positively on j
            p_base_sum_coh(coh)=p_base_sum_coh(coh)+p_base_l(l)/prod(R_hat_coh(j+Lw+1-1:j+l-1,coh));
        end
    end
    
    
    replace_w_coh(coh)=transfer_p_coh(coh)/p_base_sum_coh(coh);
    
    % check error
    pw_sum_coh2(coh)=0;
    pw_sum_coh3(coh)=0;
    if Lw<1
        for l=1:Length
            pw_sum_coh2(coh)=pw_sum_coh2(coh)+replace_w_coh(coh)*p_base_jt(j+l-1,t+l-1)/prod(R_hat_coh(j+1+1-1:j+l-1,coh));
            pw_sum_coh3(coh)=pw_sum_coh3(coh)+pw_jt(j+l-1,t+l-1)/prod(R_hat_coh(j+1+1-1:j+l-1,coh));
        end
    else
        for l=Lw:Length
            pw_sum_coh2(coh)=pw_sum_coh2(coh)+replace_w_coh(coh)*p_base_jt(j+l-1,t+l-1)/prod(R_hat_coh(j+Lw+1-1:j+l-1,coh));
            pw_sum_coh3(coh)=pw_sum_coh3(coh)+pw_jt(j+l-1,t+l-1)/prod(R_hat_coh(j+Lw+1-1:j+l-1,coh));
        end        
    end    
end


% those born in period t>1
j=1;  % start with age 1
for t=2:t_dyn
    Length=J;
    Lw=Jw;
    coh=J+t-1;
    
   
    p_base_sum_coh(coh)=0;
    for l=Lw:Length
        p_base_l(l)=p_base_jt(j+l-1,t+l-1); % year l, age depends positively on j
        p_base_sum_coh(coh)=p_base_sum_coh(coh)+p_base_l(l)/prod(R_hat_coh(j+Lw+1-1:j+l-1,coh));
    end

    replace_w_coh(coh)=transfer_p_coh(coh)/p_base_sum_coh(coh);
    
    % check error
    pw_sum_coh2(coh)=0;
    pw_sum_coh3(coh)=0;
    for l=Lw:Length
        pw_sum_coh2(coh)=pw_sum_coh2(coh)+replace_w_coh(coh)*p_base_jt(j+l-1,t+l-1)/prod(R_hat_coh(j+Lw+1-1:j+l-1,coh));
        pw_sum_coh3(coh)=pw_sum_coh3(coh)+pw_jt(j+l-1,t+l-1)/prod(R_hat_coh(j+Lw+1-1:j+l-1,coh));
    end        
    
end

err_pw_sum_coh=pw_sum_coh2-pw_sum_coh3;
err_pw_sum_coh2=pw_sum_coh-pw_sum_coh3;

% pw_jt;


