% parameters related to time, or starting year
% all the population are workers, entrepreneur come from an island


%% -------------- Year -------------------
year_data=2000; % data start from year 2000
year_start=2000; % our model start from year 2000
year_pre_wr_start=1995; % start from 1995
year_pre_w_start=year_pre_wr_start; % start from 1995
year_pre_e_start=year_pre_wr_start;
t_2000=2000-year_start+1;
t_2010=2010-year_start+1;
t_2013=2013-year_start+1;
t_2030=2030-year_start+1;
t_2031=2031-year_start+1;
t_2038=2038-year_start+1;
t_2040=2040-year_start+1;
t_2050=2050-year_start+1; % time of change
t_2100=2100-year_start+1; % time of stable



%% ----- demography ------
load('../demography8.2_TFRjump2013_MigrationMichael_130116/data_demography')
age_start=22; % entering market at age_ini, in the model, j=1
% age_end=100; % last period of life
age_end=100; % last period of life
J=age_end-age_start+1;
Jw=60-age_start+1; % workers retire at age 60
% Jw=58-age_start+1; % workers retire at age 58
% Jw=50-age_start+1; % workers retire at age 58
Je=47-age_start+1; 
% Je=40-age_start+1; 
% Je=30-age_start+1; 
% t_dyn=200;  % end of the dynamics
t_dyn=500; 
t_end=t_dyn+100; % from t_dyn to t_end, all variables are in steady state



%% ------- Transition of Economic Parameters --------
coh_betachange=J+t_2013-1;
for coh=1:coh_betachange-1
    bet_e_coh(coh)=bet_e_ini;
    bet_w_coh(coh)=bet_w_ini;
end
for coh=coh_betachange:J+t_dyn-1
    bet_e_coh(coh)=bet_e_ss;
    bet_w_coh(coh)=bet_w_ss;
end


psai_ini=0.26714;
psai_ss=psai_ini;
eta_ini=0.43; % set eta_t instead of eta?
% eta_ss=999; % 999 is just a number, its actual meanning is that there's no borrowing constraint
eta_ss=eta_ini; 

for t=1:t_2050
    psai_t(t)=psai_ini;
    eta_t(t)=eta_ini;
end
for t=t_2050+1:t_2100
    psai_t(t)=psai_ini+(psai_ss-psai_ini)/(t_2100-t_2050)*(t-t_2050);
    eta_t(t)=eta_ss; % no borrowing constaint
end
for t=t_2100+1:t_end
    psai_t(t)=psai_ss;
    eta_t(t)=eta_ss; % no borrowing constaint
end



chi_ini=2.729; % E firm technology over F firm
chi_ss=chi_ini; % F firm doesn't catch up
Z_ini=1;
Z_t(1)=Z_ini;
% 
% g_extra_ini=0.0241;
% T_g_extra=t_2030;

load data_g_extra g_extra_ini T_g_extra

for t=2:t_2010
    g_extra_t(t)=g_extra_ini;
end
g_extra_t(T_g_extra)=0; % no extra growth in 2030
% slow down until 2030
for t=t_2010+1:T_g_extra
    g_extra_t(t)=g_extra_t(t_2010)+(g_extra_t(T_g_extra)-g_extra_t(t_2010))/(T_g_extra-t_2010)*(t-t_2010);
end
for t=T_g_extra+1:t_end
    g_extra_t(t)=0;
end
for t=2:t_end
    Z_t(t)=Z_t(t-1)*(1+g_extra_t(t));
end
Z_ss=Z_t(t_end);

chi_t=chi_ini*ones(1,t_end);


load data_mort2
for t=1:t_end
lam_jt(1,t)=1; % no need for survival rate to j=1 from 0
% data_mort contains mortality rate from age 0, so the age_ini+1 element
% corresponds to mortality rate of age_ini, which is the survival rate from
% age_ini to age_ini+1, in other words, from 1st period to j=2
lam_jt(2:J,t)=1-mort_u_jt(age_start+1:age_start+J-1,t)/1000; % survivial rate to j-1 from j
lam_prod_jt(1,t)=1; % cummulative survivial rate to j from 1
% for j=2:J
%     lam_prod_jt(j,t)=prod(lam_jt(2:j,t));
% end
lamr_jt(1,t)=1;
lamr_jt(2:J,t)=1-mort_r_jt(age_start+1:age_start+J-1,t)/1000;
end
lam_jss=lam_jt(:,t_end);
% lam_prod_jss=lam_prod_jt(:,t_end);




%% ----- N_t, N_ss -----
index_N_t_data=1; % 1, load from data; 0, self test
index_N_t_mig=1; % 1, migration; 0, without migration

if index_N_t_data==0
    pop_simu_simple;

 else % load from data
    if index_N_t_mig==1 % data with migration
        for t=1:t_dyn
            N_t(1:J,t)=N_t_mig(t,1:J);
            Nr_t(1:J,t)=Nr_t_mig(t,1:J);

        end
    else
        for t=1:t_dyn
            N_t(1:J,t)=N_t_no_mig(t,1:J);
 
        end
    end
end
N_total_t(1)=sum(N_t(1:J,1));
for t=2:t_dyn
    N_total_t(t)=sum(N_t(1:J,t));
    N_growth_t(t)=N_total_t(t)/N_total_t(t-1)-1;
end 

% constant population given lam
N_con=fun_N_con(lam_jss);
Ne_t=N_con'*ones(1,t_dyn)*0.05*sum(N_t(:,1))/sum(N_con);
Nw_t=N_t; % all the people are workers

% covered by pension
Perc_w_p_ini=0.6;
Perc_w_p_ss=0.6;

% pension coverage rate for the existing cohorts in 2000 is Perc_w_p_ini
for j=1:J
    coh=J-j+1;
    Perc_w_p_coh(coh)=Perc_w_p_ini;
end
% pension coverage rate for cohorts born before 2013 is Perc_w_p_ini
for t=2:t_2013-1
    coh=J+t-1;
    Perc_w_p_coh(coh)=Perc_w_p_ini;
end
% pension coverage rate for cohorts born between 2013 and 2050 steadily
% increase to Perc_w_p_ss
for t=t_2013:t_2050 % 2052
    coh=J+t-1;
    Perc_w_p_coh(coh)=Perc_w_p_ini+(t-(t_2013-1))/(t_2050-(t_2013-1))*(Perc_w_p_ss-Perc_w_p_ini);
end
% after 2052, Perc_w_p_ss
for t=t_2050+1:t_dyn
    coh=J+t-1;
    Perc_w_p_coh(coh)=Perc_w_p_ss;
end

Perc_w_np_coh=1-Perc_w_p_coh;


for t=1:t_dyn
   
    Nw_total_t(t)=sum(Nw_t(1:J,t));
    % population gaining labor income
    Ne_labor_t(t)=sum(Ne_t(1:Je-1,t));
    Nw_labor_t(t)=sum(Nw_t(1:Jw-1,t));
    % population gaining capital
    Ne_retire_t(t)=sum(Ne_t(Je:J,t));
    Nw_retire_t(t)=sum(Nw_t(Jw:J,t));



    % rural population
    Nr_total_t(t)=sum(Nr_t(1:J,t));
    Nr_labor_t(t)=sum(Nr_t(1:Jw-1,t));
    Nr_retire_t(t)=sum(Nr_t(Jw:J,t));

end


for t=1:t_dyn
    for j=1:J
        % for different age
        Nw_p_t(j,t)=Nw_t(j,t)*Perc_w_p_coh(J-j+t);
        Nw_np_t(j,t)=Nw_t(j,t)*Perc_w_np_coh(J-j+t);
    end
    Nw_labor_p_t(t)=sum(Nw_p_t(1:Jw-1,t));
    Nw_labor_np_t(t)=sum(Nw_np_t(1:Jw-1,t));
    Nw_retire_p_t(t)=sum(Nw_p_t(Jw:J,t));
    Nw_retire_np_t(t)=sum(Nw_np_t(Jw:J,t));
end


Nur_t=N_t+Nr_t;
Nur_total_t(1:t_dyn)=Nw_total_t(1:t_dyn)+Nr_total_t(1:t_dyn);
Nur_labor_t(1:t_dyn)=Nw_labor_t(1:t_dyn)+Nr_labor_t(1:t_dyn);

% test if N_t converges (growth allowed)
check_N_converge=max(N_t(1:J,t_dyn)./sum(N_t(1:J,t_dyn)) - N_t(1:J,t_dyn-1)./sum(N_t(1:J,t_dyn-1)));

% N_ss is the distribution, ( sum normalize to 1, diffrent from sum(N_t(t)))
N_growth_ss=sum(N_t(1:J,t_dyn))/sum(N_t(1:J,t_dyn-1))-1;
scale_N_ss=sum(N_t(1:J,t_dyn)); % scale the population down such that sum(N_ss)=1
N_ss=N_t(1:J,t_dyn)'/scale_N_ss;
Nw_ss=N_ss;
Ne_ss=Ne_t(1:J,t_dyn)'/scale_N_ss; % also need to scale down the entrepreneurs
% percentage gaining labor income
Ne_labor_ss=sum(Ne_ss(1:Je-1));
Nw_labor_ss=sum(Nw_ss(1:Jw-1));
% percentage only gaining capital income
Ne_retire_ss=sum(Ne_ss(Je:J));
Nw_retire_ss=sum(Nw_ss(Jw:J));

Nw_p_ss=Nw_ss*Perc_w_p_ss;
Nw_np_ss=Nw_ss*(1-Perc_w_p_ss);
Nw_labor_p_ss=Nw_labor_ss*Perc_w_p_ss;
Nw_labor_np_ss=Nw_labor_ss*(1-Perc_w_p_ss);
Nw_retire_p_ss=Nw_retire_ss*Perc_w_p_ss;
Nw_retire_np_ss=Nw_retire_ss*(1-Perc_w_p_ss);


% N truncates the population from age_ini
% pop keeps all the population
% divide pop by 1e6, so it's about 1200 in 2000
pop_t=pop_u_t_mig/1e6;
pop_r_t=pop_r_t_mig/1e6;
pop_ur_t=pop_t+pop_r_t;
pop_total_t=sum(pop_t); % urban
pop_labor_t=sum(pop_t(age_ini+1:age_ini+Jw-1,:));
pop_r_total_t=sum(pop_r_t); % urban
pop_r_labor_t=sum(pop_r_t(age_ini+1:age_ini+Jw-1,:));
pop_ur_total_t=sum(pop_ur_t);
pop_ur_labor_t=sum(pop_ur_t(age_ini+1:age_ini+Jw-1,:));



% pop_ur_labor_t(2:10)./pop_ur_labor_t(1:9)-Nur_labor_t(2:10)./Nur_labor_t(1:9)

% 
% figure(1)
% for i=1:60
%     plot(22:21+J,N_t(1:J,i));
%     title(['population over age in year ' num2str(1999+i)] )
% %     pause(0.2);
%     pause;
% end

%% ----- Productivity Profile -----
% productivity, put it here because we need N
% increase 0.5% per year until Jw-1
step_prod=0.005;

for j=1:Jw-1
    prod_j(j)=1+step_prod*(j-1);
end

load data_edu_coh edu_coh % edu_coh(2,:) saves the education from the cohort born in 1900, which is the 1st cohort in our model
n_coh=J-1+t_dyn;
% use 9 as a benchmark
for coh=1:n_coh
    prod_coh(coh)=1.1^(edu_coh(2,coh)-9); % 1 year more education means 10% higher productivity
end

% include education into productivity
for t=1:t_dyn
    for j=1:Jw-1
        coh_jt(j,t)=J-j+t;
        prod_jt(j,t)=prod_j(j)*prod_coh(coh_jt(j,t));
    end
end

prod_jss(1:Jw-1)=prod_jt(1:Jw-1,t_dyn);

% (roughly) normalize the steady state productivity to 1
temp_prod_sum=sum(prod_jss(1:Jw-1).*N_ss(1:Jw-1));
prod_jt=prod_jt/temp_prod_sum;
prod_jss=prod_jss/temp_prod_sum;




%% ----- xi_t ------

% xi is the iceberg cost
% xi_ini=0.07;
xi_ini=0.062; % to match 9.3% aggregate capital return
t_xi=25; % at t_xi the cost coverges to 0
for t=1:t_xi
%     xi_t(t)=xi_ss+(xi_ini-xi_ss)*(1-((t-1)/t_xi)^2.95); % rl_t concave
%     xi_t(t)=xi_ss+(xi_ini-xi_ss)*(1-((t-1)/t_xi)^1); % xi_t linear
    xi_t(t)=xi_ini+(xi_ss-xi_ini)*((t-1)/(t_xi-1))^1; % xi_t linear
end
xi_t(t_xi+1:t_dyn)=xi_ss;
rl_t=(1+r)./(1-xi_t)-1;


%% ------- pre-2000 ---------
% always use 2000, instead of year_start

year_pre_start=2000-J+1; % the year workers start, birthyear of the oldest cohort in 2000
T_pre=year_start-1-year_pre_start+1;

lamr_pre_jt(1:J,1:T_pre)=lamr_jt(1:J,1)*ones(1,T_pre);
lamr_pre_jt(1:J,T_pre+1:T_pre+t_end)=lamr_jt(1:J,1:t_end);

for coh=1:J+t_dyn
    Length=J;
    for len=1:Length
        lamr_jcoh(len,coh)=lamr_pre_jt(len,coh+len-1);
    end  
end

lam_pre_jt(1:J,1:T_pre)=lam_jt(1:J,1)*ones(1,T_pre);
lam_pre_jt(1:J,T_pre+1:T_pre+t_end)=lam_jt(1:J,1:t_end);

for coh=1:J+t_dyn
    Length=J;
    for len=1:Length
        lam_jcoh(len,coh)=lam_pre_jt(len,coh+len-1);
    end  
end

