% test fun_c_a_j_kpr

%% ----------------------- parameters ----------------------
clear
clear global
load data_benchmark_34_1
global sig g phi nu J Jw gamma
gamma=1/3;
sig=1.00001;

t=1;
j=8;
Length=J-j+1;
coh=J-j+1;
Interest(1:Length)=1+r;
for l=1:Length
%     Inc(l)=yw_p_t(j+l-1,l); % year l, age depends positively on j
    Inc(l)=1; % constant
    if index_fixedlabor==1
        Labor(l)=0;
    else
        Labor(l)=h_p_t(j+l-1,l);
    end
end
Surv(1:Length)=lam_jcoh(j:j+Length-1,coh);
Asset_ini=aw_p_t(j,1);

Beta=bet_w_coh(coh);
Interest(1:Length)=1+r;
Prod_Beta_hat_l(1)=1;
Prod_R_hat_l(1)=1;
R_hat_l(1)=Interest(1);

for l=2:Length
    Beta_hat_l(l)=Beta*Surv(l)*(1+g)^(gamma*(1-sig));
    Prod_Beta_hat_l(l)=Prod_Beta_hat_l(l-1)*Beta_hat_l(l);
    
    R_hat_l(l)=Interest(l)/(Surv(l)*(1+g));
    Prod_R_hat_l(l)=Prod_R_hat_l(l-1)*R_hat_l(l);
end

%% ----------------------- 1. fun_c_a_j_ghh -------------------

[cw_p_j,aw_p_j]=fun_c_a_j_ghh(bet_w_coh(coh),Length, Interest, Inc, Surv, Asset_ini);
% error_ghh=[cw_p_j(1:Length)-cw_p_coh(j:J,coh)' aw_p_j(1:Length)-aw_p_coh(j:J,coh)' aw_p_j(Length+1)]

%% ------------------- 2. fun_c_a_j_kpr ----------------------
[c_cd, l_cd, y_cd, a_cd]=fun_c_a_j_kpr(bet_w_coh(coh), Length, Interest, Inc, Surv, Asset_ini);


mu_cd(1:Jw-j)=Prod_Beta_hat_l(1:Jw-j).*Prod_R_hat_l(1:Jw-j)*(1-gamma).*c_cd(1:Jw-j).^(gamma*(1-sig)).*(1-l_cd(1:Jw-j)).^((1-gamma)*(1-sig)-1)./Inc(1:Jw-j);
mu_cd(Jw-j+1:Length)=Prod_Beta_hat_l(Jw-j+1:Length).*Prod_R_hat_l(Jw-j+1:Length)*gamma.*c_cd(Jw-j+1:Length).^(gamma*(1-sig)-1).*(1-l_cd(Jw-j+1:Length)).^((1-gamma)*(1-sig));
err_cl_cd(1:Jw-j)=1-l_cd(1:Jw-j)-(1-gamma)/gamma*c_cd(1:Jw-j)./Inc(1:Jw-j);
err_cl_cd(Jw-j+1:Length)=l_cd(Jw-j+1:Length);
err_euler_cd(1:Jw-j)=Prod_Beta_hat_l(1:Jw-j).*Prod_R_hat_l(1:Jw-j).*c_cd(1:Jw-j).^(gamma*(1-sig)-1).*(1-l_cd(1:Jw-j)).^((1-gamma)*(1-sig))./c_cd(1)^(gamma*(1-sig)-1)./(1-l_cd(1))^((1-gamma)*(1-sig))-1;
err_euler_cd(Jw-j+1:Length)=Prod_Beta_hat_l(Jw-j+1:Length).*Prod_R_hat_l(Jw-j+1:Length).*c_cd(Jw-j+1:Length).^(gamma*(1-sig)-1)/c_cd(1)^(gamma*(1-sig)-1)/(1-l_cd(1))^((1-gamma)*(1-sig))-1;

%% ------------------- 3. fun_c_a_j_kpr2 ----------------------
[c_cd2, l_cd2, y_cd2, a_cd2]=fun_c_a_j_kpr2(bet_w_coh(coh), Length, Interest, Inc, Surv, Asset_ini);
mu_cd2(1:Jw-j)=Prod_Beta_hat_l(1:Jw-j).*Prod_R_hat_l(1:Jw-j)*(1-gamma).*c_cd2(1:Jw-j).^(gamma*(1-sig)).*(1-l_cd2(1:Jw-j)).^((1-gamma)*(1-sig)-1)./Inc(1:Jw-j);
mu_cd2(Jw-j+1:Length)=Prod_Beta_hat_l(Jw-j+1:Length).*Prod_R_hat_l(Jw-j+1:Length)*gamma.*c_cd2(Jw-j+1:Length).^(gamma*(1-sig)-1).*(1-l_cd(Jw-j+1:Length)).^((1-gamma)*(1-sig));
err_cl_cd2(1:Jw-j)=1-l_cd2(1:Jw-j)-(1-gamma)/gamma*c_cd2(1:Jw-j)./Inc(1:Jw-j);
err_cl_cd2(Jw-j+1:Length)=l_cd2(Jw-j+1:Length);
err_euler_cd2(1:Jw-j)=Prod_Beta_hat_l(1:Jw-j).*Prod_R_hat_l(1:Jw-j).*c_cd2(1:Jw-j).^(gamma*(1-sig)-1).*(1-l_cd2(1:Jw-j)).^((1-gamma)*(1-sig))./c_cd2(1)^(gamma*(1-sig)-1)./(1-l_cd2(1))^((1-gamma)*(1-sig))-1;
err_euler_cd2(Jw-j+1:Length)=Prod_Beta_hat_l(Jw-j+1:Length).*Prod_R_hat_l(Jw-j+1:Length).*c_cd2(Jw-j+1:Length).^(gamma*(1-sig)-1)./c_cd2(1)^(gamma*(1-sig)-1)./(1-l_cd2(1))^((1-gamma)*(1-sig))-1;


%% ------------------- 4. log, fun_c_a_j_kpr ----------------------
sig=1;
[c_cd_log, l_cd_log, y_cd_log, a_cd_log]=fun_c_a_j_kpr(bet_w_coh(coh), Length, Interest, Inc, Surv, Asset_ini);


%% ------------------- 5. log, fun_c_a_j_kpr2 ----------------------
[c_cd2_log, l_cd2_log, y_cd2_log, a_cd2_log]=fun_c_a_j_kpr2(bet_w_coh(coh), Length, Interest, Inc, Surv, Asset_ini);


%% ------------------- errors ----------------------
error(1)=max(abs(c_cd2-c_cd));
error(2)=max(abs(c_cd_log-c_cd));
error(3)=max(abs(c_cd2_log-c_cd_log));

error(4)=max(abs(l_cd2-l_cd));
error(5)=max(abs(l_cd_log-l_cd));
error(6)=max(abs(l_cd2_log-l_cd_log));

error(7)=max(abs(y_cd2-y_cd));
error(8)=max(abs(y_cd_log-y_cd));
error(9)=max(abs(y_cd2_log-y_cd_log));

error(10)=max(abs(a_cd2-a_cd));
error(11)=max(abs(a_cd_log-a_cd));
error(12)=max(abs(a_cd2_log-a_cd_log));
