
% ignore workers without pension


%% --------------- 0. prepare some steady state variables ---------------

w_t(t_dyn+1:t_end)=w_ss;
p_base_jt(Jw:J,t_dyn+1:t_end)=p_base_jss(Jw:J)'*ones(1,t_end-t_dyn);
tau_w_t(t_dyn+1:t_end)=tau_w_ss;
replace_w_coh(t_dyn+1:t_end)=replace_w_ss;


for t=t_dyn+1:t_end
    wagepension_p_t(1:J,t)=wagepension_p_ss(1:J);
    wagepension_np_t(1:J,t)=wagepension_np_ss(1:J);
end


% p_base_pre_t(1:J-1) are for year -77:0
% ------------  Pension Base: age-year specific --------------------
t=1;
for j=Jw:J
        t_retire=t-j+Jw;
        if t_retire<=1-T_pre; % earlier than or equal to t_pre_w_start
            p_base_jt(j,t)=(1-indexation)*p_base_pre_t(1)/(1+g)^(t-(1-T_pre))+indexation*p_base_pre_t(T_pre)/(1+g);
        elseif t_retire<=1 % goes back to earlier than or equal to 2000
            p_base_jt(j,t)=(1-indexation)*p_base_pre_t(t_retire+T_pre-1)/(1+g)^(t-t_retire+1)+indexation*p_base_pre_t(T_pre)/(1+g); % from last year
        else
            p_base_jt(j,t)=(1-indexation)*p_base_t(t_retire-1)/(1+g)^(t-t_retire+1)+indexation*p_base_pre_t(T_pre)/(1+g); % from last year
        end
end
for t=2:t_dyn
    for j=Jw:J
        t_retire=t-j+Jw;
        if t_retire<=1-T_pre; % earlier than or equal to t_pre_w_start
            p_base_jt(j,t)=(1-indexation)*p_base_pre_t(1)/(1+g)^(t-(1-T_pre))+indexation*p_base_t(t-1)/(1+g);
        elseif t_retire<=1 % goes back to earlier than or equal to 2000
            p_base_jt(j,t)=(1-indexation)*p_base_pre_t(t_retire-1+T_pre)/(1+g)^(t-t_retire+1)+indexation*p_base_t(t-1)/(1+g); % from last year
        else
            p_base_jt(j,t)=(1-indexation)*p_base_t(t_retire-1)/(1+g)^(t-t_retire+1)+indexation*p_base_t(t-1)/(1+g); % from last year
        end
    end
end



%% ------------------ 1. Worker with Pension -----------------
% initial wealth is given in initialstate.m

% pension payment
pw_jt(Jw:J,1:t_dyn)=replace_w_jt(Jw:J,1:t_dyn).*p_base_jt(Jw:J,1:t_dyn); % pension payment to workers
pw_jt(Jw:J, t_dyn+1:t_end)=replace_w_ss*p_base_jss(Jw:J)'*ones(1,t_end-t_dyn);
pw_jt(1:Jw-1,1:t_end)=0;

% income
for t=1:t_dyn
    for j=1:Jw-1
        wagepension_p_t(j,t)=(1-tau_w_t(t))*w_t(t)*prod_jt(j,t);
    end
    for j=Jw:J
        wagepension_p_t(j,t)=pw_jt(j,t);
    end
end


% given w_t, tau_w_t, solve aw_t, cw_t
% those cohorts already exist in period 1
t=1;
for j=1:J % j is the age in period 1
    Length=J-j+1;
    coh=J-j+1;
    Interest(1:Length)=1+r;
    for l=1:Length
        WagePension(l)=wagepension_p_t(j+l-1,l); % year l, age depends positively on j
    end
%     Surv(1)=1;
%     for l=2:Length
%         Surv(l)=lam_jt(j+l-1,l);
%     end
    Surv(1:Length)=lam_jcoh(j:j+Length-1,coh);
    Asset_ini=aw_p_t(j,1);
    Beta=bet_w_coh(coh);
    [cw_p_j,h_p_j,yw_p_j,aw_p_j]=fun_c_a_j_kpr(Beta,Length, Interest, WagePension, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t, cw_coh
    
    % l means the lth period he appears in the sample
    for l=1:Length
        cw_p_t(j+l-1,l)=cw_p_j(l);
        h_p_t(j+l-1,l)=h_p_j(l);
        yw_p_t(j+l-1,l)=yw_p_j(l);
        aw_p_t(j+l-1,l)=aw_p_j(l);
        
        cw_p_coh(j+l-1,coh)=cw_p_j(l);  
        h_p_coh(j+l-1,coh)=h_p_j(l);  
        yw_p_coh(j+l-1,coh)=yw_p_j(l);  
        aw_p_coh(j+l-1,coh)=aw_p_j(l);  


        uw_p_coh(j+l-1,coh)=fun_u_kpr(cw_p_coh(j+l-1,coh),h_p_coh(j+l-1,coh));
        
    end
end
uw_p_sum_coh=zeros(1,t_dyn+J-1);

% first J cohorts, born before T_pre
for coh=1:J
    for j=1:J % look at their whole life
        Surv(j)=lam_jcoh(j,coh);
        uw_p_sum_coh(coh)=uw_p_sum_coh(coh)+prod(Surv(1:j))*(bet_w_coh(coh)*(1+g)^(1-sig))^(j-1)*uw_p_coh(j,coh);
    end
end



% those born in period t>1
j=1;  % start with age 1
for t=2:t_dyn
    Length=J;
    coh=J+t-1;
    Interest(1:Length)=1+r;
    for l=1:Length
        WagePension(l)=wagepension_p_t(l,t+l-1); % year l, age depends positively on j
    end
    Surv(1:Length)=lam_jcoh(1:Length,coh);
    Asset_ini=0;
    Beta=bet_w_coh(coh);
    [cw_p_j,h_p_j,yw_p_j,aw_p_j]=fun_c_a_j_kpr(Beta,Length, Interest, WagePension, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t
    uw_p_sum_coh(coh)=0;
    for l=1:Length
        cw_p_t(l,t+l-1)=cw_p_j(l);
        h_p_t(l,t+l-1)=h_p_j(l);
        yw_p_t(l,t+l-1)=yw_p_j(l);
        aw_p_t(l,t+l-1)=aw_p_j(l);
        
        cw_p_coh(l,coh)=cw_p_j(l); 
        h_p_coh(l,coh)=h_p_j(l); 
        yw_p_coh(l,coh)=yw_p_j(l);
        aw_p_coh(l,coh)=aw_p_j(l); 

        uw_p_coh(j+l-1,coh)=fun_u_kpr(cw_p_coh(j+l-1,coh),h_p_coh(j+l-1,coh));
        
        uw_p_sum_coh(coh)=uw_p_sum_coh(coh)+prod(Surv(1:l))*(bet_w_coh(coh)*(1+g)^(1-sig))^(l-1)*uw_p_coh(l,coh);
    end
end

for t=1:t_dyn
    error_ave_yw_p_labor_t(t)= sum(yw_p_t(1:Jw-1,t).*Nw_p_t(1:Jw-1,t))/Nw_labor_p_t(t)/(1-tau_w_t(t)) - p_base_t(t);
end
max(abs(error_ave_yw_p_labor_t));


% pension lifetime, discounted to the value in retirement year
pw_sum_coh=zeros(1,t_dyn+J-1);
t=1; % cohorts existing in period 1
for j=1:J
    coh=J-j+1;
    Interest(1:J)=1+r;
    Surv(1:J)=lam_jcoh(1:J,coh);
    for j=Jw:J
        pw_sum_coh(coh)=pw_sum_coh(coh)+prod(Surv(Jw+1:j))*yw_p_coh(j,coh)*(1+g)^(j-Jw)/prod(Interest(Jw+1:j));
    end
end
j=1; % cohorts born in period t
for t=2:t_dyn
    coh=t+J-1;
    Interest(1:J)=1+r;
    Surv(1:J)=lam_jcoh(1:J,coh);
    for j=Jw:J 
        pw_sum_coh(coh)=pw_sum_coh(coh)+prod(Surv(Jw+1:j))*yw_p_coh(j,coh)*((1+g))^(j-Jw)/prod(Interest(Jw+1:j));
    end    
end