% calculate the constant population distribution (no growth)
N_con_tot=1; % total population normalized to 1, or interpret N_con as percentage distribution
% N_con_tran is the transition matrix to next period,
% N_con=N_con_tran*N_con
for j=1:J-1
    N_con_tran(1,j)=1-lam(j+1); % death=birth
end
N_con_tran(1,J)=1;
for i=2:J
    N_con_tran(i,i-1)=lam(i);   % live to the next period
end
% actually the first row is redundant, ignoring it improves the accuracy
TT=N_con_tran-eye(J);
AA=[TT(2:J,1:J); ones(1,J)];
bb(1:J-1,1)=zeros(J-1,1);
bb(J,1)=N_con_tot;
N_con=(AA\bb)';
error_N_con=norm(N_con_tran*N_con'-N_con');



% N evolves according to lam
N_t(1:J,1)=N_con;    % initial population distribution
N_total_t(1)=sum(N_t(1:J,1));
for t=2:t_end
    ratio_birth_death=0.99;     % birth is decreasing, less than the death
    birth_t(t)=N_t(1,t-1)*(1-lam(2))*ratio_birth_death;
    for j=2:J-1
        birth_t(t)=birth_t(t)+N_t(j,t-1)*(1-lam(j))*ratio_birth_death;
    end
    birth_t(t)=birth_t(t)+N_t(J,t-1)*ratio_birth_death;
    N_t(1,t)=birth_t(t);
    for j=2:J
        N_t(j,t)=N_t(j-1,t-1)*lam(j);
    end
    N_total_t(t)=sum(N_t(1:J,t));
    N_growth_t(t)=N_total_t(t)/N_total_t(t-1)-1;
end
