% experiment_delayedreform2;
% the current pension system tau_w=0.2, replace_w_t=0.8 is not sustainable
% from 2000, households expect that there is a pension reform in 2013
% but at 2013, they announce that the pension reoform will be in 2032
% 

if year_start~=2013
disp('Warning: year_start~=2013');
pause;
end

N_adjust_coverageincrease; H_adjust_coverageincrease;

%% ----------- 1.  Pension System -----------



t_reform=2040-year_start+1; % year_start is defined in parameters_t_xxxx.m
t_pencoh1=1997-year_start+1; % those born before 1997 get 78%
t_pencoh2=t_reform; % after 1997, before 2013, get 60%
replace_w_coh1=replace_w_ini;
replace_w_coh2=0.6;

% reform for which cohort in reform year
index1=2; % 1 for "entering", 2 for "retiring", 1997
index2=2; % 1 for "entering", 2 for "retiring", t_reform
module_replace_w_coh;

index_debtclear=1; % lifetime tax = lifetime pension
pension_debt_coh; % keep the current system, rep_w=0.8, tau_w=0.2


%% -------------- 2. Workers' Problem in Steady State ----------------
workers_ss;

%% ------------- 3. Workers' Problem in the Dynamic ---------------
workers_dyn;

%% ------------- 4. Aggregate Variables ------------
variables_exp;


%% -------------- 5. Figures ------------------
fig_name='delayedreform_coverageincrease';
name_data_compare='data_coverageincrease.mat';
name_fig_title='delayed reform';
figures_pension_coh;
% figures_workers;

workers_ev;
figures_workers_ev;





% for growth
Y_t_dr=Y_t;
Yur_t_dr=Yur_t;
yur_t_dr=yur_t;
yur_pw_t_dr=yur_pw_t;
B_t_dr=B_t;

% for pension graph
tax_total_t_dr=tax_total_t;
pension_total_t_dr=pension_total_t;
gov_debt_t_dr=gov_debt_t;
replace_w_coh_dr=replace_w_coh;

save data_delayedreform_coverageincrease

