% figures of the labor supply, income, consumption, asset
% by cohorts

close all
%% ------------------- data ----------------------
bm34=load('data_benchmark_2013_34','h_p_coh','h_np_coh','yw_p_coh','yw_np_coh','cw_p_coh','cw_np_coh','aw_p_coh','aw_np_coh','H_t','AE_t','w_t');
size_h=size(h_p_coh);
bm34.h_p_coh=ones(size_h(1),size_h(2));
bm34.h_np_coh=ones(size_h(1),size_h(2));


%% ----------------- aggregate variables 
figure;
subplot(3,1,1)
plot(H_t);
hold on
plot(bm34.H_t,'-.','color','g')
axis tight
xlabel('year from 2013')
title('aggregate labor')
subplot(3,1,2)
plot(AE_t);
hold on
plot(bm34.AE_t,'-.','color','g')
axis tight
xlabel('year from 2013')
title('asset in E firm')
subplot(3,1,3)
plot(w_t);
hold on
plot(bm34.w_t,'-.','color','g')
axis tight
xlabel('year from 2013')
title('wage')


%% -------------------- labor
coh_start=30;
coh_step=15;
x_coh=3;
y_coh=3;
n_coh=x_coh*y_coh;
coh_end=coh_start+(n_coh-1)*coh_step;

figure;
x_fig=age_start:age_start+Jw-1-1;
for i_coh=1:n_coh
    coh=coh_start+coh_step*(i_coh-1);
    subplot(x_coh,y_coh,i_coh)
    plot(x_fig,h_p_coh(1:Jw-1,coh))
    hold on
%     plot(x_fig,bm34.h_p_coh(1:Jw-1,coh),'-.')
%     hold on 
    plot(x_fig,h_np_coh(1:Jw-1,coh),'color','g')
%     hold on
%     plot(x_fig,bm34.h_np_coh(1:Jw-1,coh),'-.','color','g')
    xlabel('age')
    title(['labor of cohort ' num2str(coh)])
    axis tight

end




%% --------------------- income
figure;
x_fig=age_start:age_start+J-1;
for i_coh=1:n_coh
    coh=coh_start+coh_step*(i_coh-1);
    subplot(x_coh,y_coh,i_coh)
    plot(x_fig,yw_p_coh(1:J,coh))
    hold on
    plot(x_fig,bm34.yw_p_coh(1:J,coh),'-.')
    hold on 
    plot(x_fig,yw_np_coh(1:J,coh),'color','g')
    hold on
    plot(x_fig,bm34.yw_np_coh(1:J,coh),'-.','color','g')
    axis tight
    xlabel('age')
    title(['income of cohort ' num2str(coh)])
end


%% --------------------- consumption
figure;
x_fig=age_start:age_start+J-1;
for i_coh=1:n_coh
    coh=coh_start+coh_step*(i_coh-1);
    subplot(x_coh,y_coh,i_coh)
    plot(x_fig,cw_p_coh(1:J,coh))
    hold on
    plot(x_fig,bm34.cw_p_coh(1:J,coh),'-.')
    hold on 
    plot(x_fig,cw_np_coh(1:J,coh),'color','g')
    hold on
    plot(x_fig,bm34.cw_np_coh(1:J,coh),'-.','color','g')
    axis tight
    xlabel('age')
    title(['consumption of cohort ' num2str(coh)])
end

%% --------------------- asset
figure;
x_fig=age_start:age_start+J-1;
for i_coh=1:n_coh
    coh=coh_start+coh_step*(i_coh-1);
    subplot(x_coh,y_coh,i_coh)
    plot(x_fig,aw_p_coh(1:J,coh))
    hold on
    plot(x_fig,bm34.aw_p_coh(1:J,coh),'-.')
    hold on 
    plot(x_fig,aw_np_coh(1:J,coh),'color','g')
    hold on
    plot(x_fig,bm34.aw_np_coh(1:J,coh),'-.','color','g')
    axis tight
    xlabel('age')
    title(['asset of cohort ' num2str(coh)])
end