



%% --------------------- required by Kjetil 120417 ---------------------

% income of different cohorts
step_coh=5;
coh_start=J-3*step_coh;
a_coh=4;
b_coh=4;
n_coh=a_coh*b_coh;
coh_end=coh_start+step_coh*(n_coh-1);


figure
x_fig=age_start:age_start+Jw-2;
for a=1:a_coh
    for b=1:b_coh
        c=(a-1)*a_coh+b;
        subplot(a_coh,b_coh,c)
        coh=coh_start+(c-1)*step_coh;
        
        plot(x_fig,yw_p_coh(1:Jw-1,coh))
        hold on
        plot(x_fig,yw_np_coh(1:Jw-1,coh),'-.')
        hold off
        axis tight
        title(['enter in ' num2str(2000+(coh-J))])
        
%         xlabel('age')
%         ylabel('h')
%         title('labor supply')
   
    end
end
mtit('income over age, different cohorts')
print( '-dpng', '-r300', ['income_cohorts.png']);

% asset of different cohorts

figure
for a=1:a_coh
    for b=1:b_coh
        c=(a-1)*a_coh+b;
        subplot(a_coh,b_coh,c)
        coh=coh_start+(c-1)*step_coh;
        
        plot(x_fig,aw_p_coh(1:Jw-1,coh))
        hold on
        plot(x_fig,aw_np_coh(1:Jw-1,coh),'-.')
        hold off
        axis tight
        title(['enter in ' num2str(2000+(coh-J))])
        
%         xlabel('age')
%         ylabel('h')
%         title('labor supply')
    end
end
mtit('asset over age, different cohorts')
print( '-dpng', '-r300', ['asset_cohorts.png']);

% consumption of different cohorts

figure
for a=1:a_coh
    for b=1:b_coh
        c=(a-1)*a_coh+b;
        subplot(a_coh,b_coh,c)
        coh=coh_start+(c-1)*step_coh;
        
        plot(x_fig,cw_p_coh(1:Jw-1,coh))
        hold on
        plot(x_fig,cw_np_coh(1:Jw-1,coh),'-.')
        hold off
        axis tight
        title(['enter in ' num2str(2000+(coh-J))])
        
%         xlabel('age')
%         ylabel('h')
%         title('labor supply')
    end
end
mtit('consumption over age, different cohorts')
print( '-dpng', '-r300', ['consumption_cohorts.png']);

% labor of different cohorts


figure
for a=1:a_coh
    for b=1:b_coh
        c=(a-1)*a_coh+b;
        subplot(a_coh,b_coh,c)
        coh=coh_start+(c-1)*step_coh;
        
        plot(x_fig,h_p_coh(1:Jw-1,coh))
        hold on
        plot(x_fig,h_np_coh(1:Jw-1,coh),'-.')
        hold off
%         axis([min(x_fig) max(x_fig) 0 1])
        axis tight
        title(['enter in ' num2str(2000+(coh-J))])
        
%         xlabel('age')
%         ylabel('h')
%         title('labor supply')
    end
end
mtit('labor supply over age, different cohorts')
print( '-dpng', '-r300', ['labor_cohorts.png']);


% average labor supply in different years


figure
t_fig=81;
x_fig=year_start:year_start+t_fig-1;

        
plot(x_fig,ave_h_p_t(x_fig-year_start+1),'LineWidth',2)
hold on
plot(x_fig,ave_h_np_t(x_fig-year_start+1),'-.','LineWidth',2)
hold off
xlabel('year')
ylabel('avg_h')
title('average labor supply')
print( '-dpng', '-r300', ['ave_labor_year.png']);


% average labor supply of different cohorts

for coh=1:t_dyn
    ave_h_p_coh(coh)=mean(h_p_coh(1:Jw-1,coh));
    ave_h_np_coh(coh)=mean(h_np_coh(1:Jw-1,coh));
end


figure
coh_start=J-15;
n_coh=100;
coh_end=coh_start+n_coh-1;

x_fig=[coh_start:coh_end]-J+2000;

plot(x_fig,ave_h_p_coh(coh_start:coh_end),'LineWidth',2)
hold on
plot(x_fig,ave_h_np_t(coh_start:coh_end),'-.','LineWidth',2)
hold off
xlabel('year entering market')
ylabel('avg_h')
title('average labor supply of different cohorts')
axis tight
print( '-dpng', '-r300', ['ave_labor_cohort.png']);

% close all
%% --------------------------- wage


t_fig=111;
x_fig=year_start:year_start+t_fig-1;


figure
semilogy(x_fig,100*(1+g).^([1:t_fig]-1).*w_t(1:t_fig)./w_t(1),'LineWidth',1.5);
set(gca,'YTick',[100,200,400,800,1600,3200])
xlabel('year')
ylabel('w')
title('wage')
axis tight
print -dpng 'wage.png'
print( '-depsc2', ['wage.eps']);


%% --------------------------- labor earning


t_fig=101;
x_fig=year_start:year_start+t_fig-1;


figure
semilogy(x_fig,100*(1+g).^([1:t_fig]-1).*ave_yw_netprod_t(1:t_fig)./ave_yw_netprod_t(1),'LineWidth',1.5);
set(gca,'YTick',[100,200,400,800,1600,3200])
xlabel('Time')
ylabel('labor earning (logarithmic scale)')
title('Labor Earning without Human Capital: 2000-2100')
axis tight
print -dpng 'ave_yw_nohumancapital.png'
print( '-depsc2', ['ave_yw_nohumancapital.eps']);


%% ------------------------- required by Fabrizio 010811 -------------------

% ------------ E firm
for t_fig=[8 41]
    
    x_fig=year_start:year_start+t_fig-1;
    

figure


plot(x_fig,HE_t(1:t_fig)./H_t(1:t_fig),'LineWidth',1.5);
xlabel('year')
ylabel('HE/H')
title('E-Firms Employment Share')
print( '-dpng', '-r300', ['E-firms_emp_' num2str(year_start+t_fig-1) '.png']);
% print( '-depsc2', ['E-firms_emp_' num2str(year_start+t_fig-1) '.eps']);
end

% ----------- Four-Panel Graph 

figure
t_fig=41;
x_fig=year_start:year_start+t_fig-1;
subplot(2,2,1)
plot(x_fig,log(w_t(1:t_fig)),'LineWidth',1.5);
xlabel('year')
ylabel('logw')
title('Log Wage')
axis tight
subplot(2,2,2)
plot(x_fig,AE_t(1:t_fig)./N_total_t(1:t_fig),'-','color','b','LineWidth',1.5);
hold on
plot(x_fig,KE_t(1:t_fig)./N_total_t(1:t_fig),'-.','color','r','LineWidth',1.5);
hold off
xlabel('year')
ylabel('Ae/N,KE/N')
title('Asset and Capital in E Firms over Population')
axis tight
subplot(2,2,3)
plot(x_fig,(rho_t(1:t_fig).*KE_t(1:t_fig)+rl_t(1:t_fig).*KF_t(1:t_fig))./(KE_t(1:t_fig)+KF_t(1:t_fig)),'LineWidth',1.5);
hold on
plot(x_fig,rho_t(1:t_fig),'-.','color','r','LineWidth',1.5);
hold on
plot(x_fig,rl_t(1:t_fig),':','color','black','LineWidth',1.5);
hold off

xlabel('year')
ylabel('return')
title('Return to Capital: Aggregate, E Firm, F Firm')
axis tight
subplot(2,2,4)
plot(x_fig,K_t(1:t_fig)./H_t(1:t_fig),'LineWidth',1.5);
xlabel('year')
ylabel('K/H')
title('Capital-Labor Ratio')
axis tight
print( '-dpng', '-r300', ['transition_fourpanel.png']);
print( '-depsc2', ['transition_fourpanel.eps']);


% ----------- B/Y
% for t_fig=[41 51 101]
% 
% figure
% x_fig=year_start:year_start+t_fig-1;
% plot(x_fig,B_t(1:t_fig)./Yur_t(1:t_fig),'color','b','LineWidth',1.5);
% xlabel('year')
% ylabel('B/Y')
% title('Foreign Reserves over GDP')
% axis tight
% print( '-dpng', '-r300', ['foreign_reserves_gdp_' num2str(year_start+t_fig-1) '.png']);
% print( '-depsc2', ['foreign_reserves_gdp_' num2str(year_start+t_fig-1) '.eps']);
% end

% ----------- Ae Aw / Y

figure
t_fig=101;
x_fig=year_start:year_start+t_fig-1;
subplot(2,1,1)
plot(x_fig,Ae_t(1:t_fig)./Y_t(1:t_fig),'color','b','LineWidth',1.5);
hold on
plot(x_fig,10*Ae_49_t(1:t_fig)./Y_t(1:t_fig),'color','g','LineWidth',1.5);
hold off
xlabel('year')
ylabel(['Ae, Ae-' num2str(age_ini+Je-1-1) ' /Y'])
title(['Entr. + Managers, ' num2str(age_ini+Je-1-1) '-old Managers Asset / GDP'])
axis tight
subplot(2,1,2)
plot(x_fig,Aw_t(1:t_fig)./Y_t(1:t_fig),'color','b','LineWidth',1.5);
hold on
plot(x_fig,Aw_young_t(1:t_fig)./Y_t(1:t_fig),'color','g','LineWidth',1.5);
hold off
xlabel('year')
ylabel('Aw, Aw-young/Y')
title('Workers + Retirees Asset, Workers Asset / GDP')
axis tight
print( '-dpng', '-r300', ['asset_gdp.png']);
print( '-depsc2', ['asset_gdp.eps']);


% ------------ GDPpc growth
for t_fig=[41 51 101]

figure

x_fig=year_start:year_start+t_fig-1;
plot(x_fig(2:t_fig),g+growth_yur_t_ma(2:t_fig),'color','b','LineWidth',1.5);
xlabel('year')
ylabel('g_y')
title('GDPpc Growth')
axis tight
print( '-dpng', '-r300', ['growth_GDPpc_' num2str(year_start+t_fig-1)  '.png']);
print( '-depsc2', ['growth_GDPpc_' num2str(year_start+t_fig-1)  '.eps']);
end

% 
% %% --------------------
% for t_fig=[41 101];
% x_fig=year_start:year_start+t_fig-1;
% % foreign surplus
% 
% figure
% plot(x_fig,B_t(1:t_fig)./Y_t(1:t_fig),'color','b','LineWidth',1.5);
% xlabel('year')
% ylabel('B/Y')
% title('Foreign Surplus / GDP')
% axis tight
% print( '-dpng', '-r300', ['foreign_surplus_' num2str(year_start+t_fig-1) '.png']);
% print( '-depsc2',  ['foreign_surplus_' num2str(year_start+t_fig-1) '.eps']);
% 
% end


% 
% %% ---------- over GDP ---------
% 
% % for t_fig=[21,41,61,161]
% for t_fig=[41,101]
% x_fig=year_start:year_start+t_fig-1;
% 
% figure
% subplot(3,2,1)
% plot(x_fig,AE_t(1:t_fig)./Y_t(1:t_fig),'color','b','LineWidth',1.5);
% hold on
% plot(x_fig,LE_t(1:t_fig)./Y_t(1:t_fig),'color','g','LineWidth',1.5);
% hold on
% plot(x_fig,KE_t(1:t_fig)./Y_t(1:t_fig),'color','r','LineWidth',1.5);
% hold off
% xlabel('year')
% ylabel('AE, LE, KE/Y')
% % h_legend=legend('AE','LE','KE');
% % set(h_legend,'FontSize',5);
% title('E-firm Equity, Loans, Capital / GDP')
% axis tight
% 
% subplot(3,2,2)
% plot(x_fig,K_t(1:t_fig)./Y_t(1:t_fig),'-','color','b','LineWidth',1.5);
% % hold on
% % plot(x_fig,KE_stor_t(1:t_fig)./Y_t(1:t_fig),'-','color','r');
% % hold off
% xlabel('year')
% % ylabel('K, Kstor /Y')
% ylabel('K /Y')
% % title('Total, Storage Capital / GDP')
% title('Total Capital / GDP')
% axis tight
% 
% subplot(3,2,3)
% plot(x_fig,B_t(1:t_fig)./Y_t(1:t_fig),'color','b','LineWidth',1.5);
% hold on
% plot(x_fig,L_t(1:t_fig)./Y_t(1:t_fig),'color','g','LineWidth',1.5);
% hold off
% xlabel('year')
% ylabel('B, L/Y')
% title('Foreign Surplus, Domestic Lending / GDP')
% axis tight
% 
% subplot(3,2,4)
% plot(x_fig,H_t(1:t_fig),'color','b','LineWidth',1.5);
% hold on
% plot(x_fig,agg_prod_t(1:t_fig),'color','g','LineWidth',1.5);
% xlabel('year')
% ylabel('H, agg-eff-unit')
% title('Labor Supply, Total Efficient Unit')
% axis tight
% 
% subplot(3,2,5)
% plot(x_fig,Ae_t(1:t_fig)./Y_t(1:t_fig),'color','b','LineWidth',1.5);
% hold on
% plot(x_fig,(Ae_t(1:t_fig)-AE_t(1:t_fig))./Y_t(1:t_fig),'color','g','LineWidth',1.5);
% hold on
% plot(x_fig,10*Ae_49_t(1:t_fig)./Y_t(1:t_fig),'color','r','LineWidth',1.5);
% hold off
% xlabel('year')
% ylabel('Ae/Y')
% title(['Entr + Manager, Manager ' num2str(age_ini+Je-1-1) '-old Manager Asset / GDP'])
% axis tight
% 
% subplot(3,2,6)
% plot(x_fig,Aw_t(1:t_fig)./Y_t(1:t_fig),'color','b','LineWidth',1.5);
% hold on
% plot(x_fig,Aw_young_t(1:t_fig)./Y_t(1:t_fig),'color','g','LineWidth',1.5);
% hold off
% xlabel('year')
% ylabel('Aw, Aw-young/Y')
% title('Worker + Retiree Asset, Worker Asset / GDP')
% axis tight
% 
% 
% 
% % print( '-dpng', '-r300', ['transition_' fig_name '_'   num2str(year_start+t_fig-1) '_overGDP.png']);
% print( '-dpng', '-r300', ['transition_'  num2str(year_start+t_fig-1) '_overGDP.png']);
% print( '-depsc2', '-r300', ['transition_'  num2str(year_start+t_fig-1) '_overGDP.eps']);
% 
% end
