close all

i_fig=0;

%% ------------------- compare pension replacement rate ------------------
clearvars -except i_fig
index_rural=0;

if index_rural==0
    load('data_delayedreform','ev_p_coh','ev_np_coh','year_start','J','Jw');
    ev_p_coh_dr=ev_p_coh;
    load('data_delayedreform_2100','ev_p_coh');
    ev_p_coh_dr2=ev_p_coh;
    load('data_fullyfunded','ev_p_coh');
    ev_p_coh_ff=ev_p_coh;
    load('data_paygo','ev_p_coh');
    ev_p_coh_pg=ev_p_coh;
else
    load('data_delayedreform_ruralpension','ev_p_coh','ev_np_coh','year_start','J','Jw');
    ev_p_coh_dr=ev_p_coh;
    load('data_delayedreform_2100_ruralpension','ev_p_coh');
    ev_p_coh_dr2=ev_p_coh;
    load('data_fullyfunded_ruralpension','ev_p_coh');
    ev_p_coh_ff=ev_p_coh;
    
end

y_min=-20;
y_max=30;


figure
t_fig=111;
year_fig_start=2000;

coh_fig_start=1+(J-Jw)+(year_fig_start-year_start);
x_fig=year_fig_start:year_fig_start+t_fig-1;
subplot(2,2,1)
plot(x_fig,(ev_p_coh_dr(coh_fig_start:coh_fig_start+t_fig-1)-1)*100,'color','b','LineWidth',2);
hold on
plot(x_fig,(ev_np_coh(coh_fig_start:coh_fig_start+t_fig-1)-1)*100,'-.','color','k','LineWidth',2)
hold off
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
% legend('pension','without pension')
xlabel('Year of Retirement')
title(['Delayed Reform Until 2040'])

subplot(2,2,2)
plot(x_fig,(ev_p_coh_dr2(coh_fig_start:coh_fig_start+t_fig-1)-1)*100,'color','b','LineWidth',2);
hold on
plot(x_fig,(ev_np_coh(coh_fig_start:coh_fig_start+t_fig-1)-1)*100,'-.','color','k','LineWidth',2)
hold off
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
xlabel('Year of Retirement')
title(['Delayed Reform Until 2100'])

subplot(2,2,3)
plot(x_fig,(ev_p_coh_ff(coh_fig_start:coh_fig_start+t_fig-1)-1)*100,'color','b','LineWidth',2);
hold on
plot(x_fig,(ev_np_coh(coh_fig_start:coh_fig_start+t_fig-1)-1)*100,'-.','color','k','LineWidth',2)
hold off
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
xlabel('Year of Retirement')
title(['Fully Funded Reform'])

subplot(2,2,4)
plot(x_fig,(ev_p_coh_pg(coh_fig_start:coh_fig_start+t_fig-1)-1)*100,'color','b','LineWidth',2);
hold on
plot(x_fig,(ev_np_coh(coh_fig_start:coh_fig_start+t_fig-1)-1)*100,'-.','color','k','LineWidth',2)
hold off
% axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
axis([x_fig(1) x_fig(length(x_fig)) y_min ceil((max(ev_p_coh_pg(coh_fig_start:coh_fig_start+t_fig-1))-1)*100/10)*10])
xlabel('Year of Retirement')
title(['PAYGO Reform'])

mtit('Welfare Gain (Equiv. Variation) by Year of Retirement','xoff',0,'yoff',0.03)

if index_rural==0
    print( '-dpng', '-r300', ['equivalence_variation_4panel.png']);
    print( '-depsc2', ['equivalence_variation_4panel.eps']);  
end




%% -------------------------- 3 panel, rural --------------------------



%% -------------------- compare gdppc growth and B/Y in three experiments -----------------

load('data_benchmark','Yur_t_bm','B_t_bm','yur_t_bm');
load('data_delayedreform','Yur_t_dr','B_t_dr','yur_t_dr');
load('data_fullyfunded','Yur_t_ff','B_t_ff','yur_t_ff');

year_start_bm=2000;
year_start_exp=2013;
t_dyn=length(Yur_t_bm);
dif_year=year_start_exp-year_start_bm;


% GDPpc growth
yur_t_1=yur_t_bm;
yur_t_2=[yur_t_bm(1:dif_year) yur_t_dr];
yur_t_3=[yur_t_bm(1:dif_year) yur_t_ff];

g=0.02;
g_yur_t_1(2:t_dyn)=yur_t_1(2:t_dyn)./yur_t_1(1:t_dyn-1)-1+0.02;
g_yur_t_2(2:t_dyn)=yur_t_2(2:t_dyn)./yur_t_2(1:t_dyn-1)-1+0.02;
g_yur_t_3(2:t_dyn)=yur_t_3(2:t_dyn)./yur_t_3(1:t_dyn-1)-1+0.02;

span_ma=11;
g_yur_t_1_ma(2:t_dyn)=smooth(g_yur_t_1(2:t_dyn),span_ma,'moving');
g_yur_t_2_ma(2:t_dyn)=smooth(g_yur_t_2(2:t_dyn),span_ma,'moving');
g_yur_t_3_ma(2:t_dyn)=smooth(g_yur_t_3(2:t_dyn),span_ma,'moving');


% B/Y
B_t_1=B_t_bm;
B_t_2=[B_t_bm(1:dif_year) B_t_dr];
B_t_3=[B_t_bm(1:dif_year) B_t_ff];

Yur_t_1=Yur_t_bm;
Yur_t_2=[Yur_t_bm(1:dif_year) Yur_t_dr];
Yur_t_3=[Yur_t_bm(1:dif_year) Yur_t_ff];

%% -------------------- figures ---------------------

t_fig=41;
x_fig=year_start_bm:year_start_bm+t_fig-1;
i_fig=1;
figure;
subplot(2,1,1)
plot(x_fig(2:t_fig),g_yur_t_1_ma(2:t_fig),'LineWidth',2);
hold on
plot(x_fig(2:t_fig),g_yur_t_2_ma(2:t_fig),'color','k','LineWidth',2);
hold on
plot(x_fig(2:t_fig),g_yur_t_3_ma(2:t_fig),'color','r','LineWidth',2);
hold off
xlabel('year')
ylabel('g_y')
title({'GDPpc Growth Under The Three Regimes';'(benchmark, delayed reform, fully funded)'})
axis tight
subplot(2,1,2)
plot(x_fig,B_t_1(1:t_fig)./Yur_t_1(1:t_fig),'color','b','LineWidth',2);
hold on
plot(x_fig,B_t_2(1:t_fig)./Yur_t_2(1:t_fig),'color','k','LineWidth',2);
hold on
plot(x_fig,B_t_3(1:t_fig)./Yur_t_3(1:t_fig),'color','r','LineWidth',2);
hold off
xlabel('year')
ylabel('B/Y')
title({'Foreign Reserves / GDP Under The Three Regimes';'(benchmark, delayed reform, fully funded)'})
axis tight
print( '-dpng', '-r300', ['comparison.png']);
print( '-depsc2', ['comparison.eps']);





%% ------------------- compare pension system in three experiments ---------------------

load('data_benchmark','gov_debt_t_bm','tax_total_t_bm','pension_total_t_bm','replace_w_coh_bm');
load('data_delayedreform','gov_debt_t_dr','tax_total_t_dr','pension_total_t_dr','replace_w_coh_dr');
load('data_fullyfunded','gov_debt_t_ff','tax_total_t_ff','pension_total_t_ff','replace_w_coh_ff');
load('data_benchmark','J','Jw');

year_start_bm=2000;
year_start_exp=2013;
t_dyn=length(Yur_t_bm);
dif_year=year_start_exp-year_start_bm;


% replacement rate
replace_w_coh_1=replace_w_coh_bm;
replace_w_coh_2=[replace_w_coh_bm(1:dif_year) replace_w_coh_dr];
replace_w_coh_3=[replace_w_coh_bm(1:dif_year) replace_w_coh_ff];

% pension and tax
pension_total_t_1=pension_total_t_bm;
pension_total_t_2=[pension_total_t_bm(1:dif_year) pension_total_t_dr];
pension_total_t_3=[pension_total_t_bm(1:dif_year) pension_total_t_ff];
tax_total_t_1=tax_total_t_bm;
tax_total_t_2=[tax_total_t_bm(1:dif_year) tax_total_t_dr];
tax_total_t_3=[tax_total_t_bm(1:dif_year) tax_total_t_ff];

% government debt
gov_debt_t_1=gov_debt_t_bm;
gov_debt_t_2=[gov_debt_t_bm(1:dif_year) gov_debt_t_dr];
gov_debt_t_3=[gov_debt_t_bm(1:dif_year) gov_debt_t_ff];


%% -------------------- figures ---------------------

% benchmark
name_fig='benchmark';
for t_fig=[41 101];


figure

subplot(3,1,1)
coh_fig=141; % retirement year 1960-2100
x_fig=year_start_bm-(J-Jw):year_start_bm-(J-Jw)+coh_fig-1;
plot(x_fig,replace_w_coh_1(1:coh_fig),'LineWidth',2)
hold on 
axis([x_fig(1) x_fig(coh_fig) 0.3 0.8]);
xlabel('year retiring')
title('Replacement Ratio by Cohort')

subplot(3,1,2)
x_fig=year_start_bm:year_start_bm+t_fig-1;
plot(x_fig,tax_total_t_1(1:t_fig)./Yur_t_1(1:t_fig),'LineWidth',2)
hold on 
plot(x_fig,pension_total_t_1(1:t_fig)./Yur_t_1(1:t_fig),'color','k','LineWidth',2)
hold off
axis('tight');
xlabel('year')
title('Tax Revenue / GDP and Pension Payments / GDP')

subplot(3,1,3)
x_fig=year_start_bm:year_start_bm+t_fig-1;
plot(x_fig,gov_debt_t_1(1:t_fig)./Yur_t_1(1:t_fig),'LineWidth',2)
axis('tight');
xlabel('year')
title('Government Debt / GDP')
print('-dpng','-r300',['pension_' name_fig '_' num2str(year_start_bm+t_fig-1)  '.png'])
print('-depsc2',['pension_' name_fig '_' num2str(year_start_bm+t_fig-1) '.eps'])

end



% delayed reform
name_fig='delayedreform';
for t_fig=[41 101];


figure

subplot(3,1,1)
coh_fig=141; % retirement year 1960-2100
x_fig=year_start_bm-(J-Jw):year_start_bm-(J-Jw)+coh_fig-1;
plot(x_fig,replace_w_coh_2(1:coh_fig),'LineWidth',2)
hold on 
plot(x_fig,replace_w_coh_1(1:coh_fig),'-.','LineWidth',2)
axis([x_fig(1) x_fig(coh_fig) 0.3 0.8]);
xlabel('year retiring')
title('Replacement Ratio by Cohort')


subplot(3,1,2)
x_fig=year_start_bm:year_start_bm+t_fig-1;
plot(x_fig,tax_total_t_2(1:t_fig)./Yur_t_2(1:t_fig),'LineWidth',2)
hold on
plot(x_fig,tax_total_t_1(1:t_fig)./Yur_t_1(1:t_fig),'-.','LineWidth',2)
hold on 
plot(x_fig,pension_total_t_2(1:t_fig)./Yur_t_2(1:t_fig),'color','k','LineWidth',2)
hold on
plot(x_fig,pension_total_t_1(1:t_fig)./Yur_t_1(1:t_fig),'-.','color','k','LineWidth',2)
hold off
axis('tight');
xlabel('year')
title('Tax Revenue / GDP and Pension Payments / GDP')


subplot(3,1,3)
x_fig=year_start_bm:year_start_bm+t_fig-1;
plot(x_fig,gov_debt_t_2(1:t_fig)./Yur_t_2(1:t_fig),'LineWidth',2)
hold on
plot(x_fig,gov_debt_t_1(1:t_fig)./Yur_t_1(1:t_fig),'-.','LineWidth',2)
axis('tight');
xlabel('year')
title('Government Debt / GDP')
print('-dpng','-r300',['pension_' name_fig '_' num2str(year_start_bm+t_fig-1)  '.png'])
print('-depsc2',['pension_' name_fig '_' num2str(year_start_bm+t_fig-1) '.eps'])

end



% fully funded
name_fig='fullyfunded';
for t_fig=[41 101];


figure

subplot(3,1,1)
coh_fig=141; % retirement year 1960-2100
x_fig=year_start_bm-(J-Jw):year_start_bm-(J-Jw)+coh_fig-1;
plot(x_fig,replace_w_coh_3(1:coh_fig),'LineWidth',2)
hold on 
plot(x_fig,replace_w_coh_1(1:coh_fig),'-.','LineWidth',2)
axis([x_fig(1) x_fig(coh_fig) 0.3 0.8]);
xlabel('year retiring')
title('Replacement Ratio by Cohort')


subplot(3,1,2)
x_fig=year_start_bm:year_start_bm+t_fig-1;
plot(x_fig,tax_total_t_3(1:t_fig)./Yur_t_3(1:t_fig),'LineWidth',2)
hold on
plot(x_fig,tax_total_t_1(1:t_fig)./Yur_t_1(1:t_fig),'-.','LineWidth',2)
hold on 
plot(x_fig,pension_total_t_3(1:t_fig)./Yur_t_3(1:t_fig),'color','k','LineWidth',2)
hold on
plot(x_fig,pension_total_t_1(1:t_fig)./Yur_t_1(1:t_fig),'-.','color','k','LineWidth',2)
hold off
axis('tight');
xlabel('year')
title('Tax Revenue / GDP and Pension Payments / GDP')


subplot(3,1,3)
x_fig=year_start_bm:year_start_bm+t_fig-1;
plot(x_fig,gov_debt_t_3(1:t_fig)./Yur_t_3(1:t_fig),'LineWidth',2)
hold on
plot(x_fig,gov_debt_t_1(1:t_fig)./Yur_t_1(1:t_fig),'-.','LineWidth',2)
axis('tight');
xlabel('year')
title('Government Debt / GDP')
print('-dpng','-r300',['pension_' name_fig '_' num2str(year_start_bm+t_fig-1)  '.png'])
print('-depsc2',['pension_' name_fig '_' num2str(year_start_bm+t_fig-1) '.eps'])

end
