% for n groups of agents


function yy=fun_ev_n_sum(ratio, Weight, u_sum_coh_target,pop_t,c_coh,h_coh,Surv_jcoh,bet_coh)

global sig nu phi g index_fixedlabor 

% weight may be 1/(1+r)^(coh-1) or ((1+g)/(1+r))^(coh-1)

[n JJ tt_dyn] = size(pop_t);

%% --------- 1.  use ratio and c_coh, hcoh, Surv_jt to compute u_coh ----------

c_coh=c_coh*ratio;

for i=1:n

for coh=1:JJ+tt_dyn-1 % j is the age in period 1
    Length=JJ;
    
    
    Surv(1:Length)=Surv_jcoh(i,1:Length,coh);
        
    u_sum_coh(i,coh)=0;
    % l means the lth period he appears in the sample
    for l=1:Length
        if index_fixedlabor==1 && h_coh(i,l,coh)~=0
            display('Warning, index_fixedlabor==1 && h_coh(i,l,coh)~=0');
            pause;
        end
        if c_coh(i,l,coh)==0
            u_coh(i,l,coh)=-Inf; % don't count this cohort
        else
            u_coh(i,l,coh)=fun_u_kpr(c_coh(i,l,coh),h_coh(i,l,coh));
        end
        u_sum_coh(i,coh)=u_sum_coh(i,coh)+prod(Surv(1:l))*(bet_coh(i,coh)*(1+g)^(1-sig))^(l-1)*u_coh(i,l,coh);
    
    end
end







%% -------------- Step 2. aggregate u_sum(i) -----------------
u_sum(i)=0;
u_sum_target(i)=0;

% the older person, the higher weight
% existing cohorts, age j=1:JJ
t=1;
for j=1:JJ % j is the age in period 1
    coh=JJ-j+1;
    % only compare those cohorts having positive consumption
    if u_sum_coh(i,coh)~=-Inf
    u_sum(i)=u_sum(i)+u_sum_coh(i,coh)*pop_t(i,j,t)*Weight^(1-j);
    u_sum_target(i)=u_sum_target(i)+u_sum_coh_target(i,coh)*pop_t(i,j,t)*Weight^(1-j);
    end
end

% those born in period t>1
for t=2:tt_dyn
    coh=JJ+t-1;
    if u_sum_coh(i,coh)~=-Inf
    u_sum(i)=u_sum(i)+u_sum_coh(i,coh)*pop_t(i,1,t)*Weight^(t-1);
    u_sum_target(i)=u_sum_target(i)+u_sum_coh_target(i,coh)*pop_t(i,1,t)*Weight^(t-1);
    end
end

% the continuation value is very very small, ignored?
u_sum(i)=u_sum(i)+u_sum_coh(i,JJ+tt_dyn-1)*pop_t(i,1,tt_dyn)*Weight^tt_dyn*1/(1-Weight);
u_sum_target(i)=u_sum_target(i)+u_sum_coh_target(i,JJ+tt_dyn-1)*pop_t(i,1,tt_dyn)*Weight^tt_dyn*1/(1-Weight);


end

yy=sum(u_sum-u_sum_target);

