function yy=fun_ev_p_sum(ratio,uw_p_sum_coh_target,Nw_p_t,cw_p_coh,h_p_coh,lam_jt,bet_w_coh)

global phi nu sig g index_fixedlabor r

[J t_dyn] = size(Nw_p_t);

%% --------- 1.  use ratio and cw_p_coh, h_pcoh, lam_jt to compute uw_p_coh ----------

cw_p_coh=cw_p_coh*ratio;

% those cohorts already exist in period 1
t=1;
for j=1:J % j is the age in period 1
    Length=J-j+1;
    coh=J-j+1;
    
    Surv(1)=1;
    for l=2:Length
        Surv(l)=lam_jt(j+l-1,l);
    end
    
    uw_p_sum_coh(coh)=0;
    % l means the lth period he appears in the sample
    for l=1:Length
        if index_fixedlabor==1 && h_p_coh(l,coh)~=0
            display('Warning, index_fixedlabor==1 && h_p_coh(l,coh)~=0');
            pause;
        end
        if sig~=1
            uw_p_coh(l,coh)=(cw_p_coh(l,coh)-phi*h_p_coh(l,coh)^(1+nu)/(1+nu))^(1-sig)/(1-sig);
            uw_p_sum_coh(coh)=uw_p_sum_coh(coh)+prod(Surv(1:l))*(bet_w_coh(coh)*(1+g)^(1-sig))^(l-1)*uw_p_coh(l,coh);
        elseif sig==1
            uw_p_coh(l,coh)=log(cw_p_coh(l,coh)-phi*h_p_coh(l,coh)^(1+nu)/(1+nu));
            uw_p_sum_coh(coh)=uw_p_sum_coh(coh)+prod(Surv(1:l))*(bet_w_coh(coh)*(1+g)^(1-sig))^(l-1)*uw_p_coh(l,coh);
        end
        
    end
end



% those born in period t>1
for t=2:t_dyn
    Length=J;
    coh=J+t-1;
    
    Surv(1)=1;
    for l=2:Length
        Surv(l)=lam_jt(l,t+l-1);
    end
    
    uw_p_sum_coh(coh)=0;
    for l=1:Length
        if index_fixedlabor==1 && h_p_coh(l,coh)~=0
            display('Warning, index_fixedlabor==1 && h_p_coh(l,coh)~=0');
            pause;
        end
        if sig~=1
            uw_p_coh(l,coh)=(cw_p_coh(l,coh)-phi*h_p_coh(l,coh)^(1+nu)/(1+nu))^(1-sig)/(1-sig);
        else
            uw_p_coh(l,coh)=log(cw_p_coh(l,coh)-phi*h_p_coh(l,coh)^(1+nu)/(1+nu));
        end
        uw_p_sum_coh(coh)=uw_p_sum_coh(coh)+prod(Surv(1:l))*(bet_w_coh(coh)*(1+g)^(1-sig))^(l-1)*uw_p_coh(l,coh);
    end
end




%% -------------- Step 2. aggregate uw_p_sum -----------------
uw_p_sum=0;
uw_p_sum_target=0;

% the older person, the higher weight
% existing cohorts, age j=1:J
t=1;
for j=1:J % j is the age in period 1
    coh=J-j+1;
    uw_p_sum=uw_p_sum+uw_p_sum_coh(coh)*Nw_p_t(j,t)/(1+r)^(1-j);
    uw_p_sum_target=uw_p_sum_target+uw_p_sum_coh_target(coh)*Nw_p_t(j,t)/(1+r)^(1-j);
end

% those born in period t>1
for t=2:t_dyn
    coh=J+t-1;
    uw_p_sum=uw_p_sum+uw_p_sum_coh(coh)*Nw_p_t(1,t)/(1+r)^(t-1);
    uw_p_sum_target=uw_p_sum_target+uw_p_sum_coh_target(coh)*Nw_p_t(1,t)/(1+r)^(t-1);
end

% the continuation value is very very small, ignored?
uw_p_sum=uw_p_sum+uw_p_sum_coh(J+t_dyn-1)*Nw_p_t(1,t_dyn)/(1+r)^t_dyn*(1+r)/r;
uw_p_sum_target=uw_p_sum_target+uw_p_sum_coh_target(J+t_dyn-1)*Nw_p_t(1,t_dyn)/(1+r)^t_dyn*(1+r)/r;


yy=uw_p_sum-uw_p_sum_target;