% partial equilibrium from 2013 


clear;
clear global;
close all;
tic

%% ----------------- 0. Setup ---------------------------------

global_claim;  % global variables


% index_fixedlabor_rural=1; 
index_gtext=0;

name_data_2013='../Pension1_BaselineScenario/data_benchmark_2013.mat';

% load the equilibrium from 2013
load(name_data_2013);
name_data_2000='../Pension1_BaselineScenario/data_benchmark.mat';

%% ----------------- 1. Financial Liberaliation: Adjust eta_t -------------------
adjust_eta;


%% ---------------- 2. Solve for Long-run Replacement Rate ----------------

t_reform=2013-year_start+1; % year_start is defined in parameters_t_xxxx.m

index_guess=0;
name_data_eq='data_eq_2013_benchmark.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'replace_w_coh3','H_p_t','H_np_t','AE_t','p_base_t'); % initial


tol_setting_accurate;
solve_replace_w_coh3_update;


disp('Dynamic computation finished')
toc
% 
% save(name_data_eq,'H_p_t','H_np_t','p_base_t','replace_w_coh3');

% compute other variables in the equilibrium, dra2w figures, save data
variables_eq;
variables_eq_ur;



fig_name='2013';


%% ----------------- 4. Pension Reform Experiment Outcomes ------------------------


experiment_benchmark_2013;     % current system
disp('Experiment_benchmark_2013 finished')
toc


