 




clear;
clear global;
close all;
tic

%% ----------------- 0. Setup ---------------------------------

global_claim;  % global variables

index_fixedlabor=0;
index_fixedlabor_rural=0; % for rural it is still fixed labor?
index_gtext=0;


% set the parameters (e.g. population, death rate) if the economy starts from 2000
name_data_2000='data_benchmark.mat';
name_exp='ruralpension';


% parameters that do not depend on year
parameters_basic;

parameters_t_2013; 
% name_data_p_base_t='data_benchmark_2013';
% adjust_p_base_pre_t;
% pension and tax that matter for the equilibrium price
pensionsystem_2013; % current system, tau_w_ss=0.2; tau_


% ---- rural
parameters_rural_2013;
% load pension system from the old one
% pensionsystem_rural_2013_old;
pensionsystem_rural_2013_new;


parameters_data_t_2013;

% adjust_prod_cd; % after parameters_rural, so the rural part was still the same


% initial wealth distribution
% here we set the initial wealth as certain ration of the pre-transition equilibrium
initialstate_2013;
initialstate_rural_2013;

% %% ---------------- 0.5 Adjust ----------------------
% adjust_uw_coh_2013; % adjust the utility of workers before 2013
% adjust_uwr_coh_2013;



%% -------------- 1. the rural model --------------

solve_Hr_update_2013; % update Hr to solve the rural model

pension_debt_coh_rural;


%% ---------------- 2. Solve for Long-run Replacement Rate ----------------

t_reform=2013-year_start+1; % year_start is defined in parameters_t_xxxx.m

index_guess=0;
name_data_eq='data_eq_2013_ruralpension.mat';
name_data_guess=name_data_eq;

load(name_data_guess,'replace_w_coh3'); % initial


tol_setting_accurate;
solve_replace_w_coh3_update;


disp('Dynamic computation finished')
toc
% 
% save(name_data_eq,'H_p_t','H_np_t','p_base_t','replace_w_coh3');

% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;






%% ----------------- 4. Pension Reform Experiment Outcomes ------------------------






experiment_benchmark_2013_ruralpension;     % current system
disp('Experiment_ruralpension finished')
toc


%% ------------------ 5. temp, but may be useful ------------------
figure;
plot(ave_h_p_t(1:100))
hold on
plot(ave_h_np_t(1:100),'color','g')
hold on
plot(ave_h_t(1:100),'color','r')
hold off
title('average working hour from 2013, blue: workers in pension, green: not in pension, red: all workers')

