% rural pension


%% --------------------- 1. tax ----------------------
tax_total_r_t(1:t_dyn)=tau_wr*wr_t(1:t_dyn).*Hr_t(1:t_dyn);
% steady state value, use t_dyn and multiply by 1+N_growth_ss, and grows at
% the rate of 1+N_growth_ss
tax_total_r_ss=tax_total_r_t(t_dyn)*(1+N_growth_ss);

% life time tax (may need to add the steady state continuation value)
tax_lifetime_r=tax_total_r_t(1); 
for t=2:t_dyn
    tax_lifetime_r=tax_lifetime_r+tax_total_r_t(t)*((1+g)/(1+r))^(t-1);
end
% continuation value from steady state
tax_lifetime_r=tax_lifetime_r+tax_total_r_ss*((1+g)/(1+r))^t_dyn/(1-(1+N_growth_ss)*(1+g)/(1+r));



%% ------------------- 2. Pension Payment -----------------
% -------- No Need to Clear Debt ---------
% use the replace_w defined in pensionsystem_xxx.m 
for t=1:t_dyn
    pension_total_r_t(t)=replace_wr*p_base_r_t(t)*Nr_labor_t(t);
end
pension_total_r_ss=pension_total_r_t(t_dyn)*(1+N_growth_ss); % and then grows at the rate of 1+N_growth_ss
pension_lifetime_r=0;
for t=1:t_dyn
    pension_lifetime_r=pension_lifetime_r+pension_total_r_t(t)*((1+g)/(1+r))^(t-1);
end

pension_debt_lifetime_r=pension_lifetime_r-tax_lifetime_r;
        
% need to add pension_debt_lifeteime_r into the urban pension system    
% need to include tax_total_r_t-pension_total_r_t in gov_debt

% %% --------------------- 3. Pension Debt, in rural -------------------
% % pension_debt_r_t(1) is defined in initialstate.m
% 
% 
% for t=1:t_transfer-2
%     pension_debt_r_t(t+1)=((1+r)*pension_debt_r_t(t)+pension_total_r_t(t)-tax_total_r_t(t))/(1+g);
% end
% % get transfer in period t_transfer
% t=t_transfer-1;
% pension_debt_r_t(t+1)=-Ag_transfer+((1+r)*pension_debt_r_t(t)+pension_total_r_t(t)-tax_total_r_t(t))/(1+g);
% for t=t_transfer:t_dyn
%     pension_debt_r_t(t+1)=((1+r)*pension_debt_r_t(t)+pension_total_r_t(t)-tax_total_r_t(t))/(1+g);
% end
% 
% for t=t_dyn+1:10000
%     pension_debt_r_t(t+1)=((1+r)*pension_debt_r_t(t)+(pension_total_r_ss-tax_total_r_ss)*(1+N_growth_ss)^(t-t_dyn-1))/(1+g);
% end


