% experiment_fullyfunded;
% from 2013, switch to fully funded

if year_start~=2013
disp('Warning: year_start~=2013');
pause;
end

%% ----------- -1. adjust initial state --------------
initialstate_adjust2_fullyfunded; % adjust the wealth and government debt according to the pension promise

pensionsystem_adjust_fullyfunded;



%% ----------- 0. find tau_w ----------------------
guess_tau_w=0;
if guess_tau_w==1;
tau_w_ss=0.0240;
tau_w_t=tau_w_ss*ones(1,t_dyn);
name_data_guess='data_eq_2013.mat'; % guess AE_t, w_t
else % no need to guess, take results from last solved eq
    name_data_guess=name_data_eq;
    load (name_data_eq,'tau_w_ss','tau_w_t');
    tau_w_ss=real(tau_w_ss);
    tau_w_t=real(tau_w_t);
end

solve_tau_w_update_lite;  % update approach, good for later use



%% ----------- 1.  Pension System -----------
index_debtclear=0; % lifetime tax = lifetime pension
pension_debt_coh; % the current system, rep_w=0.8, tau_w=0.2


%% -------------- 2. Workers' Problem in Steady State ----------------
workers_ss;


%% ------------- 3. Workers' Problem in the Dynamic ---------------
workers_dyn;

%% ------------- 4. Aggregate Variables ------------
variables_exp;


%% -------------- 5. Figures ------------------
fig_name='fullyfunded';
name_fig_title='fully funded reform';
name_fig_title2='FF reform';
name_data_compare='data_benchmark_2013.mat';

% figures_workers;

workers_ev;
figures_workers_ev;

% compute the equivalent variation
aggregate_ev;

figures_pension_coh;







% for growth and B
Y_t_ff=Y_t;
Yur_t_ff=Yur_t;
yur_t_ff=yur_t;
yur_pw_t_ff=yur_pw_t;
B_t_ff=B_t;


% for pension graph
tax_total_t_ff=tax_total_t;
pension_total_t_ff=pension_total_t;
gov_debt_t_ff=gov_debt_t;
replace_w_coh_ff=replace_w_coh;


save data_fullyfunded


