 
% assume slow wage convergence (and the same long-run level as the benchmark)


clear;
clear global;
close all;
tic

%% ----------------- 0. Setup, Load Equilibrium ---------------------------------

global_claim;  % global variables

name_data_2013='../Pension1_BaselineScenario/data_benchmark_2013.mat';

%  load the equilibrium from baseline scenario benchmark 2013
load(name_data_2013); 
name_data_2000='../Pension1_BaselineScenario/data_benchmark.mat';
name_data_2013='../Pension1_BaselineScenario/data_benchmark_2013.mat';

name_exp='benchmark_2013';
name_data_exp='data_benchmark_2013.mat';


index_fixedlabor=0; 
index_gtext=0;


%% --------------- 1 Wage Growth Adjustment --------------------
adjust_w_t;


%% ---------------- 2. Solve for Long-run Replacement Rate ----------------

t_reform=2013-year_start+1; % year_start is defined in parameters_t_xxxx.m

index_guess=0;
name_data_eq='data_eq_2013_benchmark.mat';
% name_data_guess=name_data_eq;
name_data_guess=name_data_eq;

load(name_data_guess,'replace_w_coh3'); % initial

solve_replace_w_coh3_update_pe;


disp('Dynamic computation finished')
toc
% 
% save(name_data_eq,'H_p_t','H_np_t','p_base_t','replace_w_coh3');

% compute other variables in the equilibrium, draw figures, save data
variables_eq;
variables_eq_ur;



fig_name='2013';


%% ----------------- 4. Pension Reform Experiment Outcomes ------------------------


experiment_benchmark_2013;     % current system
disp('Experiment_benchmark_2013 finished')
toc

