% starting from year_pre_wr, with awr_1992
year_pre_wr_start=1992;
t_pre_wr_start=year_pre_wr_start-year_pre_start+1;
awr_1992=0;


%% ----------------- variables -------------------
g_wr_t(2:t_dyn)=wr_t(2:t_dyn)./wr_t(1:t_dyn-1)-1;
g_wr_pre=mean(g_wr_t(2:3));
g_wr_t(1)=g_wr_pre;

t_pre_1980=1980-year_pre_start+1; % when the wage starts growing
g_wr_pre_t(1:t_pre_1980-1)=-g;
g_wr_pre_t(t_pre_1980:T_pre+1)=g_wr_pre;

wr_pre_t(T_pre+1:T_pre+J)=wr_t(1:J);
for t=T_pre:-1:1
    wr_pre_t(t)=wr_pre_t(t+1)/(1+g_wr_pre_t(t+1));
end

% % constant labor supply?
% hr_pre_t(1:Jw-1,T_pre+1:T_pre+J)=hr_t(1:Jw-1,1:J);
% % hr_pre_t(1:Jw-1,1:T_pre)=hr_adjust*ones(Jw-1,T_pre);
% 
% if index_fixedlabor_rural==1
%     hr_pre_t(1:Jw-1,1:T_pre)=hr_adjust*ones(Jw-1,T_pre);
% end

% prod_pre_jt(1:Jw-1,T_pre+1:T_pre+J)=prod_jt(1:Jw-1,1:J);
% include education into productivity
% born in t=1 (1922)
for t=1:T_pre+J
    coh=t;
    for j=1:Jw-1
        prod_pre_jt(j,t+j-1)=prod_j(j)*prod_coh(coh);
    end
end

% the same normalization as prod_jt, to make prod_ss=1
prod_pre_jt=prod_pre_jt/temp_prod_sum;
% income
for t=1:T_pre+J-1
    for j=1:Jw-1
        wagepension_r_pre_t(j,t)=wr_pre_t(t)*prod_pre_jt(j,t);
    end
    for j=Jw:J
        wagepension_r_pre_t(j,t)=0;
    end
end


%% ----------------------- workers' problem ---------------
t=t_pre_wr_start;
awr_pre_t(1:J,t)=ones(J,1)*awr_1992;
for j=1:t % cohort 1 to t_pre_e_start, older cohorts don't matter
    coh=t-j+1;
    Length=J-j+1;
    Interest(1:Length)=1+r;
    Inc=zeros(1,Length);
    for l=1:Length
        WagePension(l)=wagepension_r_pre_t(j+l-1,t+l-1);
    end
    Surv(1:Length)=lamr_jcoh(j:j+Length-1,coh);
    Asset_ini=awr_pre_t(j,t);
    [cwr_j,hr_j,ywr_j,awr_j]=fun_c_a_j_kpr(bet_w_ini,Length, Interest,  WagePension, Surv, Asset_ini);
    % put cw_j, aw_j into cw_t, aw_t
    for l=1:Length
        cwr_pre_t(j+l-1,t+l-1)=cwr_j(l);
        hr_pre_t(j+l-1,t+l-1)=hr_j(l);
        ywr_pre_t(j+l-1,t+l-1)=ywr_j(l);
        awr_pre_t(j+l-1,t+l-1)=awr_j(l);
        
        cwr_coh(j+l-1,coh)=cwr_j(l);        
        hr_coh(j+l-1,coh)=hr_j(l);        
        ywr_coh(j+l-1,coh)=Inc(l);
        awr_coh(j+l-1,coh)=awr_j(l);
        
        
         
        uwr_coh(j+l-1,coh)=fun_u_kpr(cwr_coh(j+l-1,coh),hr_coh(j+l-1,coh));
        
    end
    
    % remember to assign them consumptions before t_pre_wr_start
    for len=1:j-1
        ywr_coh(len,coh)=ywr_pre_t(len,t+len-j);
        cwr_coh(len,coh)=ywr_coh(len,coh);
        cwr_pre_t(len,t+len-j)=cwr_coh(len,coh);
        hr_coh(len,coh)=hr_adjust*(len<Jw);
        
        uwr_coh(len,coh)=fun_u_kpr(cwr_coh(len,coh),hr_coh(len,coh));
        
    end
end


% those born in period t>t_pre_w_start
j=1; % start from j=1
for t=t_pre_wr_start+1:T_pre
    coh=t;
    
    Length=J;
    Interest(1:Length)=1+r;
    Inc=zeros(1,Length);
    for l=1:Length
        WagePension(l)=wagepension_r_pre_t(j+l-1,t+l-1); % year l, age depends positively on j
    end
    Surv(1:Length)=lamr_jcoh(j:j+Length-1,coh);
    Asset_ini=0;
    [cwr_j,hr_j,ywr_j,awr_j]=fun_c_a_j_kpr(bet_w_ini,Length, Interest, WagePension, Surv, Asset_ini);
    % put ce_j, ae_j into ce_t, ae_t
    for l=1:Length
        cwr_pre_t(j+l-1,t+l-1)=cwr_j(l);
        hr_pre_t(j+l-1,t+l-1)=hr_j(l);
        ywr_pre_t(j+l-1,t+l-1)=ywr_j(l);
        awr_pre_t(j+l-1,t+l-1)=awr_j(l);
        
        cwr_coh(j+l-1,coh)=cwr_j(l);        
        hr_coh(j+l-1,coh)=hr_j(l);        
        ywr_coh(j+l-1,coh)=Inc(l);
        awr_coh(j+l-1,coh)=awr_j(l);
                
        
            uwr_coh(j+l-1,coh)=fun_u_kpr(cwr_coh(j+l-1,coh),hr_coh(j+l-1,coh));
        
    end
end
awr_pre_t(1,T_pre+1)=0;
