% variables in the experiment

%% ------ 1. aggregate income and asset of workers  --------
% Yw_ss=(yw_p_ss(1:Jw-1)*Nw_p_ss(1:Jw-1)'/(1-tau_w_ss)+yw_np_ss(1:Jw-1)*Nw_np_ss(1:Jw-1)');
Yw_ss=w_ss*H_ss;
Aw_ss=(aw_p_ss(1:J)*Nw_p_ss(1:J)'+aw_np_ss(1:J)*Nw_np_ss(1:J)');
Aw_young_ss=(aw_p_ss(1:Jw-1)*Nw_p_ss(1:Jw-1)'+aw_np_ss(1:Jw-1)*Nw_np_ss(1:Jw-1)');
ratio_Aw_Yw_ss=Aw_ss/Yw_ss;
ratio_Aw_young_Yw_ss=Aw_young_ss/Yw_ss;


for t=1:t_dyn
    Aw_t(t)=aw_p_t(1:J,t)'*Nw_p_t(1:J,t)+aw_np_t(1:J,t)'*Nw_np_t(1:J,t);
    Aw_young_t(t)=aw_p_t(1:Jw-1,t)'*Nw_p_t(1:Jw-1,t)+aw_np_t(1:Jw-1,t)'*Nw_np_t(1:Jw-1,t);
    Awr_t(t)=awr_t(1:J,t)'*Nr_t(1:J,t);
    Awr_young_t(t)=awr_t(1:Jw-1,t)'*Nr_t(1:Jw-1,t);
end

Awr_ss=Awr_t(t_dyn);

% aggregat consumptions and income
for t=1:t_dyn-1
    Ce_t(t)=ce_t(1:J,t)'*Ne_t(1:J,t);
    Cw_t(t)=cw_p_t(1:J,t)'*Nw_p_t(1:J,t)+cw_np_t(1:J,t)'*Nw_np_t(1:J,t);
    Cwr_t(t)=cwr_t(1:J,t)'*Nr_t(1:J,t);
end



%% -------- 3. Private Foreign Reserve, without extra government wealth -----------------

% AE in solve_dynamic.m, Ae in variables_eq.m, Aw_t in 1.
saving_bank_ur_t=Ae_t-AE_t+Aw_t+Awr_t+KE_stor_t; % manager saving, worker saving, E firm extra capital go to bank
loan_ur_t=KF_t+KE_prod_t-AE_t+Kr_t; % loan to F firm and part of E firm's capital
% B_t(1:t_dyn)=saving_bank_t(1:t_dyn)-loan_t(1:t_dyn)-gov_debt_t(1:t_dyn)+gov_asset_t(1:t_dyn); % government debt are issued as bonds, so it attracts some savings
Bp_t(1:t_dyn)=saving_bank_ur_t(1:t_dyn)-loan_ur_t(1:t_dyn); % government debt are issued as bonds
% YN_t=Y_t+B_t*r; % GNP


%% -------- 4. government asset, consumption and savings, and B with gov ------------
Ag_pen_t(1:t_dyn)=-gov_debt_t(1:t_dyn); % asset from pension
Ag_t=Ag_extra_netKg_t+Ag_pen_t; % total asset
Cg_t(1:t_dyn)=r*Ag_extra_netKg_t(1:t_dyn)+Yg_t(1:t_dyn)-Sg_extra_t(1:t_dyn);
B_t(1:t_dyn)=Bp_t(1:t_dyn)+Ag_pen_t(1:t_dyn)+Ag_extra_netKg_t(1:t_dyn); % Kg is both in asset and capital, so it cancels out


%% --------- 5. savings ----------
Sw_t(1:t_dyn-1)=(1+g)*Aw_t(2:t_dyn)-Aw_t(1:t_dyn-1);
Swr_t(1:t_dyn-1)=(1+g)*Awr_t(2:t_dyn)-Awr_t(1:t_dyn-1);
Se_t(1:t_dyn-1)=(1+g)*Ae_t(2:t_dyn)-Ae_t(1:t_dyn-1);
SE_t(1:t_dyn-1)=(1+g)*AE_t(2:t_dyn)-AE_t(1:t_dyn-1);

Sg_pen_t(1:t_dyn-1)=(1+g)*Ag_pen_t(2:t_dyn)-Ag_pen_t(1:t_dyn-1);
% include depreciation as enterprise saving
% two ways to compute savings, first one, use saving




% S and Sr means private urban and rural
S_t(1:t_dyn-1)=Sw_t(1:t_dyn-1)+Se_t(1:t_dyn-1)+dep*K_t(1:t_dyn-1);
Sr_t(1:t_dyn-1)=Swr_t(1:t_dyn-1)+dep*Kr_t(1:t_dyn-1);
Sg_t(1:t_dyn-1)=Sg_extra_t(1:t_dyn-1)+Sg_pen_t(1:t_dyn-1);
% -- some tests ---
% Sg_extra_t(1:20)./Yur_t(1:20)
% Sg_pen_t(1:20)./Yur_t(1:20)
% Sg_t(1:20)./Yur_t(1:20)
% (1+g)*Ag_transfer./Yur_t(12)
% diff_Sg_t(1:t_dyn-1)=(1+g)*Ag_t(2:t_dyn)-Ag_t(1:t_dyn-1)-(Sg_t(1:t_dyn-1)-Ig_t(1:t_dyn-1));
% diff_Sg_pen_t(1:t_dyn-1)=(1+g)*Ag_pen_t(2:t_dyn)-Ag_pen_t(1:t_dyn-1)-Sg_pen_t(1:t_dyn-1);
% diff_Sg_extra_t(1:t_dyn-1)=(1+g)*Ag_extra_netKg_t(2:t_dyn)-Ag_extra_netKg_t(1:t_dyn-1)-(Sg_extra_t(1:t_dyn-1)-Ig_t(1:t_dyn-1));
% diff_Ag_t(1:t_dyn)=Ag_t(1:t_dyn)-Ag_pen_t(1:t_dyn)-Ag_extra_netKg_t(1:t_dyn);

% second way, use output and consumption
S2_t(1:t_dyn-1)=(1-tau_g)*Y_t(1:t_dyn-1)+r*B_t(1:t_dyn-1).*Yur_t(1:t_dyn-1)-iceberg_t(1:t_dyn-1)-Ce_t(1:t_dyn-1)-Cw_t(1:t_dyn-1);
Sg2_t(1:t_dyn-1)=Yg_t(1:t_dyn-1)-Cg_t(1:t_dyn-1);
Sr2_t(1:t_dyn-1)=(1-tau_gr)*Yr_t(1:t_dyn-1)-iceberg_r_t(1:t_dyn-1)-Cwr_t(1:t_dyn-1);

% (S_t-S2_t)./Yur_t(1:data)
% (Sr_t-Sr2_t)./Yur_t(1:data)

% decompose of saving
% households
% need to compute this after pension experiment
% firms
Sh_t(1:t_dyn-1)=Sw_t(1:t_dyn-1)+Se_t(1:t_dyn-1)-SE_t(1:t_dyn-1);
% firms
Sf_t(1:t_dyn-1)=SE_t(1:t_dyn-1)+dep*K_t(1:t_dyn-1);
% private
Sp_t(1:t_dyn-1)=Sh_t(1:t_dyn-1)+Sf_t(1:t_dyn-1);

% rural
Sh_r_t(1:t_dyn-1)=Swr_t(1:t_dyn-1);
Sf_r_t(1:t_dyn-1)=dep*Kr_t(1:t_dyn-1);
Sp_r_t(1:t_dyn-1)=Sh_r_t(1:t_dyn-1)+Sf_r_t(1:t_dyn-1);


%% ------------------------- average labor supply --------------------------
% for t=1:t_dyn
%     ave_h_p_t(t)=sum(h_p_t(1:Jw-1,t).*Nw_p_t(1:Jw-1,t))/sum(Nw_p_t(1:Jw-1,t));
%     ave_h_np_t(t)=sum(h_np_t(1:Jw-1,t).*Nw_np_t(1:Jw-1,t))/sum(Nw_np_t(1:Jw-1,t));
%     ave_h_t(t)=sum(h_p_t(1:Jw-1,t).*Nw_p_t(1:Jw-1,t)+h_np_t(1:Jw-1,t).*Nw_np_t(1:Jw-1,t))/sum(Nw_p_t(1:Jw-1,t)+Nw_np_t(1:Jw-1,t));
% end


%% -------------------- average labor earnings per person compared with wage -------------------
for t=1:t_dyn
    ave_yw_t(t)=(yw_p_t(1:Jw-1,t)'*Nw_p_t(1:Jw-1,t)+yw_np_t(1:Jw-1,t)'*Nw_np_t(1:Jw-1,t))/sum(Nw_p_t(1:Jw-1,t)+Nw_np_t(1:Jw-1,t));
    ave_prod_t(t)=(prod_jt(1:Jw-1,t)'*(Nw_p_t(1:Jw-1,t)+Nw_np_t(1:Jw-1,t)))/sum(Nw_p_t(1:Jw-1,t)+Nw_np_t(1:Jw-1,t));
end

ave_yw_netprod_t=ave_yw_t./ave_prod_t;

%% --------------------- growth of wage and yw --------------------
t1=100;
growth_w_t(2:t1)=w_t(2:t1)./w_t(1:t1-1)-1;
growth_ave_yw_netprod_t(2:t1)=ave_yw_netprod_t(2:t1)./ave_yw_netprod_t(1:t1-1)-1;
