% use data from 2013 benchmark to calculate

%% ------------------- 1. The Promised Payment for existing cohorts ---------------------
% load(name_data_2013,'pw_jt_bm2', 'yw_p_t_bm2','tau_w_t_bm2')
bm2=load(name_data_bm2,'pw_jt', 'yw_p_t','tau_w_t');


% update the cohort existing in t=1, which is 2013
t=1;
for j=1:J % j is the age in period 1
    Length=J-j+1;
    coh=J-j+1;
    % survival rate to period xx
    Surv(1)=1;
    for l=2:Length
        Surv(l)=lam_jt(j+l-1,l);
    end
    % acc. survival rate to period l
    for l=1:Length
        Surv_prod(l)=prod(Surv(1:l));
    end
    % total pw_coh discounted to t=1
    pw_sum_coh_bm2(coh)=0;
    if j<Jw
        for l=1+Jw-j:Length
            pw_sum_coh_bm2(coh)=pw_sum_coh_bm2(coh)+Surv_prod(l)*bm2.pw_jt(j+l-1,l)*((1+g)/(1+r))^(l-1); % t_start is updated in parameters_t_2013.m
        end
    else
        for l=1:Length
            pw_sum_coh_bm2(coh)=pw_sum_coh_bm2(coh)+Surv_prod(l)*bm2.pw_jt(j+l-1,l)*((1+g)/(1+r))^(l-1); % t_start is updated in parameters_t_2013.m
        end
    end
    % unpaid tax
    tax_w_sum_coh_bm2(coh)=0;
    lw=Jw-j+1; % l=1, age=j, l=Jw-j+1, age=Jw
    for l=1:lw-1 % pay tax before retirement
        tax_w_sum_coh_bm2(coh)=tax_w_sum_coh_bm2(coh)+Surv_prod(l)*bm2.yw_p_t(j+l-1,l)*bm2.tau_w_t(l)/(1-bm2.tau_w_t(l))*((1+g)/(1+r))^(l-1); % t_start is updated in parameters_t_2013.m
    end
end

% yw_sum_coh_bm2=pw_sum_coh_bm2-tax_w_sum_coh_bm2;

% give this promise to them as assets
% current workers get a fraction according to their working years, net for
% unpaid tax
t=1;
for j=1:Jw-1
    coh=J-j+1;
    transfer_aw_p_coh(coh)=(pw_sum_coh_bm2(coh)-tax_w_sum_coh_bm2(coh))/(1+r)*(j-1)/(Jw-1);
    aw_p_t(j,1)=aw_p_t(j,1)+transfer_aw_p_coh(coh);
end

% retired people get all what they should get
for j=Jw:J
    coh=J-j+1;
    transfer_aw_p_coh(coh)=pw_sum_coh_bm2(coh)/(1+r);
    aw_p_t(j,1)=aw_p_t(j,1)+transfer_aw_p_coh(coh);
end


%% ------------------ 2. The Increase of Government Debt ----------------------
% gov_debt_t(1) is updatedin initialstate_2013
% paid to current workers

% t=1;
% for j=1:Jw-1
%     coh=J-j+1;
%     gov_debt_t(1)=gov_debt_t(1)+pw_sum_coh_bm2(coh)/(1+r)*(j-1)/(Jw-1)*Nw_p_t(j,1);
% end
% 
% % paid to retired workers
% for j=Jw:J
%     coh=J-j+1;
%     gov_debt_t(1)=gov_debt_t(1)+pw_sum_coh_bm2(coh)/(1+r)*Nw_p_t(j,1);
% end

transfer_aw_p_sum=0;
t=1;
for j=1:J
    coh=J-j+1;
    transfer_aw_p_sum=transfer_aw_p_sum+transfer_aw_p_coh(coh)*Nw_p_t(j,1);
end
gov_debt_t(1)=gov_debt_t(1)+transfer_aw_p_sum;
