% according to kjetil's argument

%% ---------------- 1. rural labor supply ---------------
% hr_adjust=1/prod_kpr; % in adjust_prod_kpr

hr_t(1:Jw-1,1:t_dyn)=hr_adjust;
for t=1:t_dyn
    Hr_t(t)=sum(prod_jt(1:Jw-1,t).*hr_t(1:Jw-1,t).*Nr_t(1:Jw-1,t)); % this is the initial guess, assuming constant labor supply
end
% sum(Nr_t)./sum(N_t)

%% --------------- 2. calibrate alp_r and chi_r ------------- 

% ------- alp_r is pinned down by the investment
IrYr=0.2; % Ir over Yr
t=1; % investment in the first period

g_aftertax_nxt=0; % tax is constant in rural
g_Z_nxt=g_extra_t(t+1); 
rl_nxt=rl_t(t+1);
rl=rl_t(t);
g_Lr_nxt=Hr_t(t+1)/Hr_t(t)-1;

fun_IrYr_alpr=@(alp_r) fun_IrYr(alp_r,g_aftertax_nxt,g_Z_nxt, rl_nxt, rl, g_Lr_nxt, tau_gr, IrYr);
% function yy=fun_IrYr(alp_r,g_aftertax_nxt, g_Z_nxt,rl_nxt,rl,g_Lr_nxt,IrYr)
options = optimset('Display','off');
alp_r=fsolve(fun_IrYr_alpr,0.25,options);

% Ir_t(1:10)./Yr_t(1:10) %0.2022


% ------- chi_r is pinned down by the wage in rural and urban
% notice that VAT can be different in rural and urban
wwr=1.84; % w over wr
chi_r=1/wwr * (1-alp)/(1-alp_r) * (alp/(rl_t(1)+dep))^(alp/(1-alp))/(alp_r/(rl_t(1)+dep))^(alp_r/(1-alp_r)) * (1-tau_g)^(1/(1-alp))/(1-tau_gr)^(1/(1-alp_r));

% w_t(1:10)./wr_t(1:10) % 1.84

