
% General Equilibrium from 2000


clear;
clear global;
close all;
tic

%% ----------------- 0. Setup ---------------------------------

global_claim;  % global variables


name_data_load='../Pension1_BaselineScenario/data_benchmark';
load(name_data_load);
name_data_load='../Pension1_BaselineScenario/data_benchmark';


%% ----------------- 1.  Two-tier Pension System ------------------
pensionsystem_2000; % two-tier system, tau_w_ss=0.12


%% ---------------- 2. Solve the Urban Model  --------------
t_reform=2013-year_start+1; % year_start is defined in parameters_t_xxxx.m

name_exp='benchmark';

name_data_eq='data_eq_2000';
name_data_guess=name_data_eq;


load(name_data_guess,'H_p_t','H_np_t','AE_t','p_base_t','replace_w_coh3','aw_p_t','aw_np_t');


tol_setting_accurate;

solve_ae1_update;
replace_w_coh3


%% -------------- 3. experiment and all variables ------------
% most variables and experiments already done in solving the equilibrium
experiment_benchmark;
% variables_paper; % variables we need in the paper
variables_extra;
save(name_data_exp);


