% !!!!! since the population may be decreasing, and we normalize sum(N_ss) to 1
% !!!!! here AE_ss is in fact E firm capital per N_ss. 

% !!!!! since Ne is constant
% !!!!! Total output is shrinking means me_ss is shrinking !!!!


%% ------------------- initialization -----------------------
KE_stor_ss=0; % ??


% steady state variables updating, similar to fun_ss_new
H_p_ss=H_AE_ss(1);
H_np_ss=H_AE_ss(2);
AE_ss=H_AE_ss(3);

H_ss=H_p_ss+H_np_ss;

if chi_ss<(1/(1-psai_ss))^(1/(1-alp))
    display('Warning: chi<chi_bar')
    pause;
end


%% ---------------------------- Equilibrium -------------------------

if psai_ss==0 && eta_ss==999 % no management income and no borrowing constraint
    % small open economy
    HE_ss=H_ss;
    rho_ss=r;
    KE_ss=(1-psai_ss)^(1/(1-alp))*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_ss)*chi_ss*HE_ss*(r+dep)^(-1/(1-alp));
    w_ss=(1-psai_ss)^(1/(1-alp))*alp^(alp/(1-alp))*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_ss)*chi_ss*(r+dep)^(-alp/(1-alp));
    m_ss=0;
    case_ss=0;    
    
    RE_ss=1+r;
    
elseif    eta_ss~=999
%% -- 5 cases for AE, seperated by 4 AEi --
% --- 1. AE1 makes the Entrepreneur's labor employment just equal to H
w1=alp^(alp/(1-alp))*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_ss)*(rl_ss+dep)^(-alp/(1-alp));
rho1=(1-psai_ss)^(1/alp)*chi_ss^((1-alp)/alp)*(rl_ss+dep)-dep;
% back out KE using H and MPL
KE1=(1-psai_ss)^(-1/alp)*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_ss)*chi_ss^(-(1-alp)/alp)*(rl_ss+dep)^(-1/(1-alp))*H_ss;
% full borrowing
AE1=KE1/(1+eta_ss*(1+rho1)/(1+rl_ss-eta_ss*(1+rho1)));
% AE1=(1-psai_ss)^(-1/alp)*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_ss)*chi_ss^(-(1-alp)/alp)*(rl_ss+dep)^(-1/(1-alp))*H/(1+eta_ss*(1+rho1)/(1+rl_ss-eta_ss*(1+rho1)));
check(1)=(1-psai_ss)*((1-tau_g)^(1/(1-alp))*Z_ss)^alp*chi_ss^alp*(AE1*(1+eta_ss*(1+rho1)/(1+rl_ss-eta_ss*(1+rho1))))^alp*(1-alp)*H_ss^(-alp) - w1;

% --- 2. AE2: rho just equals rl_ss when full borrowing
rho2=rl_ss;
KE2=(1-psai_ss)^(1/(1-alp))*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_ss)*chi_ss*H_ss*(rl_ss+dep)^(-1/(1-alp));
AE2=KE2/(1+eta_ss*(1+rho2)/(1+rl_ss-eta_ss*(1+rho2)));
check(2)=(1-psai_ss)*alp*(AE2*(1+eta_ss*(1+rho2)/(1+rl_ss-eta_ss*(1+rho2))))^(alp-1)*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*H_ss^(1-alp)-dep - rl_ss;

% --- 3. AE3: rho just equals rl_ss when no borrowing
rho3=rl_ss;
KE3=(1-psai_ss)^(1/(1-alp))*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_ss)*chi_ss*H_ss*(rl_ss+dep)^(-1/(1-alp));
AE3=KE3;
check(3)=(1-psai_ss)*alp*AE3^(alp-1)*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*H_ss^(1-alp)-dep - rl_ss;

% --- 4. AE4: rho just equals r when no borrowing
rho4=r;
KE4=(1-psai_ss)^(1/(1-alp))*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_ss)*chi_ss*H_ss*(r+dep)^(-1/(1-alp));
AE4=KE4;
check(4)=(1-psai_ss)*alp*AE4^(alp-1)*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*H_ss^(1-alp)-dep - r;

if AE1>1.01*AE2 || AE2>1.01*AE3 || AE3>1.01*AE4 % 1.01 allows for some small error
    disp('error for AE1 AE2 AE3 AE4');
    AE1
    AE2
    AE3
    AE4
end
%% ---- 5 cases, case by case ----

if AE_ss<=AE1
% ---- case 1, AE<=AE1, HE<=H, wage determined by F firm ----
    w_ss=alp^(alp/(1-alp))*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_ss)*(rl_ss+dep)^(-alp/(1-alp));
    rho_ss=(1-psai_ss)^(1/alp)*chi_ss^((1-alp)/alp)*(rl_ss+dep)-dep;
    KE_ss=(1+eta_ss*(1+rho_ss)/(1+rl_ss-eta_ss*(1+rho_ss)))*AE_ss;
    HE_ss=(1-psai_ss)^(1/alp)*alp^(-1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_ss)^(-1)*chi_ss^((1-alp)/alp)*(rl_ss+dep)^(1/(1-alp))*KE_ss;
    m_ss=psai_ss*KE_ss^alp*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*HE_ss^(1-alp);
    case_ss=1;
    check(5)= (1-psai_ss)*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*KE_ss^alp*(1-alp)*HE_ss^(-alp) - w_ss;
    
elseif AE_ss<=AE2
% ---- case 2, AE1<AE<=AE2, HE=H, wage determined by E firm, rho>=rl_ss
    HE_ss=H_ss;
    % rho solve the following equation
    rho_ini=rl_ss*1.01;
    fun_rho_givenp=@(rho)fun_rho(rho,AE_ss,HE_ss,rl_ss,((1-tau_g)^(1/(1-alp))*Z_ss),chi_ss,psai_ss,eta_ss);
    options = optimset('Display','off');
    rho_ss=fsolve(fun_rho_givenp,rho_ini,options);
    KE_ss=(1+eta_ss*(1+rho_ss)/(1+rl_ss-eta_ss*(1+rho_ss)))*AE_ss;
    w_ss=(1-psai_ss)*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*KE_ss^alp*HE_ss^(-alp);
    m_ss=psai_ss*KE_ss^alp*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*HE_ss^(1-alp);
    case_ss=2;
    check(6)=(1-psai_ss)*alp*(1+eta_ss*(1+rho_ss)/(1+rl_ss-eta_ss*(1+rho_ss)))^(alp-1)*AE_ss^(alp-1)*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*HE_ss^(1-alp) - dep - rho_ss;
%           yy = (1-psai_ss)*alp*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*H^(1-alp)*(1+eta_ss*(1+rho)/(1+rl_ss-eta_ss*(1+rho)))^(alp-1)*AE^(alp-1) - dep - rho;
% another approach is to update rho until getting the correct solution

elseif AE_ss<=AE3
% ---- case 3, AE2<AE<=AE3, HE=H, rho=rl_ss
    HE_ss=H_ss;
    rho_ss=rl_ss;
    KE_ss=(1-psai_ss)^(1/(1-alp))*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_ss)*chi_ss*H_ss*(rl_ss+dep)^(-1/(1-alp));
    w_ss=(1-psai_ss)*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*KE_ss^alp*HE_ss^(-alp);
    m_ss=psai_ss*KE_ss^alp*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*HE_ss^(1-alp);
    case_ss=3;
    check(7)=(1-psai_ss)*alp*KE_ss^(alp-1)*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*HE_ss^(1-alp)-dep - rl_ss;
    
elseif AE_ss<=AE4
% ---- case 4, AE3<AE<=AE4, HE=H, r<=rho<rl_ss
    HE_ss=H_ss;
    KE_ss=AE_ss;
    w_ss=(1-psai_ss)*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*KE_ss^alp*HE_ss^(-alp);
    rho_ss=(1-psai_ss)*alp*KE_ss^(alp-1)*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*HE_ss^(1-alp) - dep;
    m_ss=psai_ss*KE_ss^alp*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*HE_ss^(1-alp);
    case_ss=4;
    check(8)=(1-psai_ss)*alp*AE_ss^(alp-1)*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*HE_ss^(1-alp) - dep - rho_ss;

else
% ---- case 5, AE>AE4, HE=H, rho=r
    HE_ss=H_ss;
    rho_ss=r;
    KE_ss=AE_ss;
    KE_prod_ss=(1-psai_ss)^(1/(1-alp))*alp^(1/(1-alp))*((1-tau_g)^(1/(1-alp))*Z_ss)*chi_ss*HE_ss*(r+dep)^(-1/(1-alp));
    KE_stor_ss=KE_ss-KE_prod_ss;
    w_ss=(1-psai_ss)^(1/(1-alp))*alp^(alp/(1-alp))*(1-alp)*((1-tau_g)^(1/(1-alp))*Z_ss)*chi_ss*(r+dep)^(-alp/(1-alp));
    m_ss=psai_ss*KE_prod_ss^alp*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*HE_ss^(1-alp);
    case_ss=5;
    check(9)=(1-psai_ss)*alp*KE_prod_ss^(alp-1)*((1-tau_g)^(1/(1-alp))*Z_ss)^(1-alp)*chi_ss^(1-alp)*HE_ss^(1-alp) - dep -r;
    
end


% % pension payment
% entrepreneur has no pension payment
% p=tau_w_ss*w*H/sum(N_ss(Jw:J));
RE_ss=((1+rho_ss)*KE_ss - (1+rl_ss)*(KE_ss-AE_ss))/AE_ss;

end % end of if eta_ss~=999

% RE, return of savings


p_base_ss=w_ss*H_p_ss/Nw_labor_p_ss;
% (pre-tax) average income of workers in pension system

%% ---------------------- Household problem ------------------------

workers_ss; % to get h_p_ss and h_np_ss
h_p_ss(Jw:J)=0;
h_np_ss(Jw:J)=0;

% total labor supply
% H_ss=sum(Nw_ss(1:Jw-1))*h_ss;
H_p_ss_new=sum(prod_jss(1:Jw-1).*h_p_ss(1:Jw-1).*Nw_p_ss(1:Jw-1));
H_np_ss_new=sum(prod_jss(1:Jw-1).*h_np_ss(1:Jw-1).*Nw_np_ss(1:Jw-1));
H_ss_new=H_p_ss_new+H_np_ss_new;
ave_h_p_ss=sum(h_p_ss(1:Jw-1).*Nw_p_ss(1:Jw-1))/sum(Nw_p_ss(1:Jw-1));
ave_h_np_ss=sum(h_np_ss(1:Jw-1).*Nw_np_ss(1:Jw-1))/sum(Nw_np_ss(1:Jw-1));
ave_h_ss=sum(h_p_ss(1:Jw-1).*Nw_p_ss(1:Jw-1)+h_np_ss(1:Jw-1).*Nw_np_ss(1:Jw-1))/sum(Nw_p_ss(1:Jw-1)+Nw_np_ss(1:Jw-1));



% mean(h_p_ss(1:Jw-1))-9/24


%% --- entrepreneur's consumption and savings, denoted by j

% income
% pe_ss=replace_e_ss*w_ss;
pe_ss=replace_e_ss*p_base_ss;
% m_ss is the total payment to the management
% me_ss is the income of per manager
me_ss=m_ss/Ne_labor_ss;

for j=1:Je-1
    ye_ss(j)=(1-tau_e_ss)*me_ss; % cross-sectional
end
ye_ss(Je:J)=pe_ss;
ye_coh_ss=ye_ss.*(1+N_growth_ss).^([1:J]-1); % lifecycle

% interest rates for entrepreneurs' saving
Re(1:Je-1)=1+r;
Re(Je:J)=RE_ss;
ae_ss(1)=0; % initial asset


Length=J;
Interest=Re(1:J);
Inc=ye_coh_ss(1:J); % track his lifecycle
Labor=zeros(1,J);
Surv=lam_jss(1:J);
Asset_ini=ae_ss(1);
% from an individual's point of view, lifecycle distribution
[ce_coh_ss,ae_coh_ss]=fun_c_a_j_fixlabor(bet_e_ss, Length, Interest, Inc,  Surv, Asset_ini);
% adjust by cohort, cross-section distribution
% for j=1:J
%     ce_ss(j)=ce_coh_ss(j)/(1+N_growth_ss)^(j-1);
%     ae_ss(j)=ae_coh_ss(j)/(1+N_growth_ss)^(j-1);
% end
ce_ss=ce_coh_ss./(1+N_growth_ss).^([1:J]-1);
ae_ss=ae_coh_ss./(1+N_growth_ss).^([1:J+1]-1);


% check AE
% AE_new=0;
% for j=Je:J
%     AE_new=AE_new+ae(j)*N_ss(j);
% end
% AE_ss_new=ae_ss(Je:J)*Ne_ss(Je:J)'; % should not normalize by population growth
AE_ss_new=(abs(ae_ss(Je:J))+ae_ss(Je:J))/2*Ne_ss(Je:J)';
% error(3)=AE_new-AE;
% yy(3)=AE_new-AE;

H_AE_ss_new(1)=H_p_ss_new;
H_AE_ss_new(2)=H_np_ss_new;
H_AE_ss_new(3)=AE_ss_new;
