clearvars -except index_mac
% close all;

% ---------------------------- 1. EV for different cohorts -------------------

folder_Basic='../Pension1_BaselineScenario';
folder_PerfectForesight='../Pension11_PerfectForesight';


load([folder_Basic '/data_benchmark_2013']);

PerfectForesight.dr=load([folder_PerfectForesight '/data_delayedreform'],'ev_p_coh','year_start');
PerfectForesight.dr2=load([folder_PerfectForesight '/data_delayedreform_2100'],'ev_p_coh');
PerfectForesight.ff=load([folder_PerfectForesight '/data_fullyfunded'],'ev_p_coh');
PerfectForesight.pg=load([folder_PerfectForesight '/data_paygo'],'ev_p_coh');

Basic.dr=load([folder_Basic '/data_delayedreform'],'ev_p_coh');
Basic.dr2=load([folder_Basic '/data_delayedreform_2100'],'ev_p_coh');
Basic.ff=load([folder_Basic '/data_fullyfunded'],'ev_p_coh');
Basic.pg=load([folder_Basic '/data_paygo'],'ev_p_coh');

% Basic.dr.ev_p_coh-Basic.dr2.ev_p_coh

y_min=-15;
y_max=25;

index_gtext=0;

% ---------------------- 1.1 Figures: PerfectForesight, LowFertility, ---------------------------
pos_fromleft=200; pos_frombottom=50; figure('Position',[pos_fromleft pos_frombottom 800 600])
year_fig_start=year_start+(Jw-J);
t_fig=1+2115-year_fig_start;
coh_fig_start=1+(J-Jw)+(year_fig_start-year_start);
x_fig=year_fig_start:year_fig_start+t_fig-1;




% ----------------- Perfect Foresight
diff_year=year_start-PerfectForesight.dr.year_start
subplot(2,2,1)
y1_fig=(PerfectForesight.dr.ev_p_coh(diff_year+coh_fig_start:diff_year+coh_fig_start+t_fig-1))*100;
y2_fig=(Basic.dr.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,y2_fig,'-.','color','r','LineWidth',2);
% hold on
% plot(x_fig,PerfectForesight.dr2.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','b','LineWidth',2);
% hold on
% plot(x_fig,Basic.dr2.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','r','LineWidth',2);
hold on
plot(x_fig,zeros(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
% title('low wage growth')
x_text=2014;
i_x_text=x_text-x_fig(1)+1;
y1_text=y1_fig(i_x_text);
% text(x_text,y1_text,'Delayed until 2050', 'VerticalAlignment','bottom');
title(['Panel a: Delayed Reform until 2050'])

subplot(2,2,2)
y1_fig=(PerfectForesight.dr2.ev_p_coh(diff_year+coh_fig_start:diff_year+coh_fig_start+t_fig-1))*100;
y2_fig=(Basic.dr2.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,y2_fig,'-.','color','r','LineWidth',2);
% hold on
% plot(x_fig,PerfectForesight.dr2.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','b','LineWidth',2);
% hold on
% plot(x_fig,Basic.dr2.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','r','LineWidth',2);
hold on
plot(x_fig,zeros(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
% title('low wage growth')
x_text=2014;
i_x_text=x_text-x_fig(1)+1;
y1_text=y1_fig(i_x_text);
% text(x_text,y1_text,'Delayed until 2100', 'VerticalAlignment','bottom');
title(['Panel b: Delayed Reform until 2100'])

subplot(2,2,3)
y1_fig=(PerfectForesight.ff.ev_p_coh(diff_year+coh_fig_start:diff_year+coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,(Basic.ff.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100,'-.','color','r','LineWidth',2);
hold on
plot(x_fig,zeros(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
% title('Low Wage Growth')
x_text=2045;
i_x_text=x_text-x_fig(1)+1;
y1_text=y1_fig(i_x_text+40);
% text(x_text,y1_text,'Fully Funded', 'VerticalAlignment','bottom');
title(['Panel c: Fully Funded Reform'])

subplot(2,2,4)
y1_fig=(PerfectForesight.pg.ev_p_coh(diff_year+coh_fig_start:diff_year+coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,(Basic.pg.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100,'-.','color','r','LineWidth',2);
hold on
plot(x_fig,0*ones(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min ceil(max((PerfectForesight.pg.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1)))*100/10)*10])% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
% title('low wage growth')
x_text=2027;
i_x_text=x_text-x_fig(1)+1;
y1_text=y1_fig(i_x_text);
% text(x_text,y1_text,'PAYGO', 'VerticalAlignment','bottom');
title(['Panel d: PAYGO Reform'])


suplabel('Year of Retirement');
suplabel('Welfare Gain \omega (in Percent)','y');

print( '-dpng', '-r300', ['Compare_PerfectForesight_notitle.png']);
print( '-depsc2', ['Compare_PerfectForesight_notitle.eps']);

% mtit('Welfare Gain (Equiv. Variation) by Year of Retirement','xoff',0,'yoff',0.03)
mtit('\fontsize{12} Welfare Gain (Equiv. Variation) by Year of Retirement','xoff',0,'yoff',-0.01)



print( '-dpng', '-r300', ['Compare_PerfectForesight.png']);
print( '-depsc2', ['Compare_PerfectForesight.eps']);


% suplabel_test

