clearvars -except index_mac
% close all;

% ---------------------------- 1. EV for different cohorts -------------------
folder_Basic='../Pension1_BaselineScenario';
folder_LowGrowth='../Pension4_LowWageGrowth';
folder_SlowConvergence='../Pension7_SlowConvergence';
folder_LowFertility='../Pension2_LowFertility';



load([folder_Basic '/data_benchmark_2013']);

LowGrowth.dr=load([folder_LowGrowth '/data_delayedreform'],'ev_p_coh');
LowGrowth.dr2=load([folder_LowGrowth '/data_delayedreform_2100'],'ev_p_coh');
LowGrowth.ff=load([folder_LowGrowth '/data_fullyfunded'],'ev_p_coh');
LowGrowth.pg=load([folder_LowGrowth '/data_paygo'],'ev_p_coh');

LowFertility.dr=load([folder_LowFertility '/data_delayedreform'],'ev_p_coh');
LowFertility.dr2=load([folder_LowFertility '/data_delayedreform_2100'],'ev_p_coh');
LowFertility.ff=load([folder_LowFertility '/data_fullyfunded'],'ev_p_coh');
LowFertility.pg=load([folder_LowFertility '/data_paygo'],'ev_p_coh');

Basic.dr=load([folder_Basic '/data_delayedreform'],'ev_p_coh');
Basic.dr2=load([folder_Basic '/data_delayedreform_2100'],'ev_p_coh');
Basic.ff=load([folder_Basic '/data_fullyfunded'],'ev_p_coh');
Basic.pg=load([folder_Basic '/data_paygo'],'ev_p_coh');

SlowConvergence.dr=load([folder_SlowConvergence '/data_delayedreform'],'ev_p_coh');
SlowConvergence.dr2=load([folder_SlowConvergence '/data_delayedreform_2100'],'ev_p_coh');
SlowConvergence.ff=load([folder_SlowConvergence '/data_fullyfunded'],'ev_p_coh');
SlowConvergence.pg=load([folder_SlowConvergence '/data_paygo'],'ev_p_coh');


% Basic.dr.ev_p_coh-Basic.dr2.ev_p_coh

y_min=-15;
y_max=25;

index_gtext=0;

% ---------------------- 1.1 Figures: LowGrowth, LowFertility, ---------------------------
pos_fromleft=200; pos_frombottom=50; figure('Position',[pos_fromleft pos_frombottom 800 600])
year_fig_start=year_start+(Jw-J);
t_fig=1+2115-year_fig_start;
coh_fig_start=1+(J-Jw)+(year_fig_start-year_start);
x_fig=year_fig_start:year_fig_start+t_fig-1;


% ----------------- low growth
subplot(3,3,1)
y1_fig=(LowGrowth.dr.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
y2_fig=(Basic.dr.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,y2_fig,'-.','color','r','LineWidth',2);
% hold on
% plot(x_fig,LowGrowth.dr2.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','b','LineWidth',2);
% hold on
% plot(x_fig,Basic.dr2.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','r','LineWidth',2);
hold on
plot(x_fig,zeros(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
% title('low wage growth')
x_text=2014;
i_x_text=x_text-x_fig(1)+1;
y1_text=max(y1_fig(i_x_text),y2_fig(i_x_text))+1;
text(x_text,y1_text,'Delayed until 2050', 'VerticalAlignment','bottom');

subplot(3,3,2)
y1_fig=(LowGrowth.ff.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,(Basic.ff.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100,'-.','color','r','LineWidth',2);
hold on
plot(x_fig,zeros(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
title('Panel a: Low Wage Growth')
x_text=2045;
i_x_text=x_text-x_fig(1)+1;
y1_text=max(y1_fig(i_x_text+40),y2_fig(i_x_text+40))+1;
text(x_text,y1_text,'Fully Funded', 'VerticalAlignment','bottom');

subplot(3,3,3)
y1_fig=(LowGrowth.pg.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,(Basic.pg.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100,'-.','color','r','LineWidth',2);
hold on
plot(x_fig,0*ones(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min ceil(max((LowFertility.pg.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1)))*100/10)*10])% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
% title('low wage growth')
x_text=2027;
i_x_text=x_text-x_fig(1)+1;
y1_text=max(y1_fig(i_x_text),y2_fig(i_x_text))+14;
text(x_text,y1_text,'PAYGO', 'VerticalAlignment','bottom');



% ----------------- slow convergence
subplot(3,3,4)
y1_fig=(SlowConvergence.dr.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
y2_fig=(Basic.dr.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,y2_fig,'-.','color','r','LineWidth',2);
% hold on
% plot(x_fig,SlowConvergence.dr2.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','b','LineWidth',2);
% hold on
% plot(x_fig,Basic.dr2.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','r','LineWidth',2);
hold on
plot(x_fig,zeros(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
% title('low wage growth')
x_text=2014;
i_x_text=x_text-x_fig(1)+1;
y1_text=max(y1_fig(i_x_text),y2_fig(i_x_text))+1;
text(x_text,y1_text,'Delayed until 2050', 'VerticalAlignment','bottom');

subplot(3,3,5)
y1_fig=(SlowConvergence.ff.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,(Basic.ff.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100,'-.','color','r','LineWidth',2);
hold on
plot(x_fig,zeros(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
title('Panel b: Slow Wage Convergence')
x_text=2045;
i_x_text=x_text-x_fig(1)+1;
y1_text=y1_fig(i_x_text+40);
text(x_text,y1_text,'Fully Funded', 'VerticalAlignment','bottom');

subplot(3,3,6)
y1_fig=(SlowConvergence.pg.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,(Basic.pg.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100,'-.','color','r','LineWidth',2);
hold on
plot(x_fig,0*ones(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min ceil(max((LowFertility.pg.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1)))*100/10)*10])% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
% title('low wage growth')
x_text=2027;
i_x_text=x_text-x_fig(1)+1;
y1_text=y1_fig(i_x_text)+2;
text(x_text,y1_text,'PAYGO', 'VerticalAlignment','bottom');




% --------------- low fertility
subplot(3,3,7)
y1_fig=(LowFertility.dr.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,(Basic.dr.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100,'-.','color','r','LineWidth',2);
% hold on
% plot(x_fig,LowFertility.dr2.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','b','LineWidth',2);
% hold on
% plot(x_fig,Basic.dr2.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1),'-.','color','r','LineWidth',2);
hold on
plot(x_fig,0*ones(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
% title('low fertility')
x_text=2014;
i_x_text=x_text-x_fig(1)+1;
y1_text=min(y1_fig(i_x_text),y2_fig(i_x_text));
text(x_text,y1_text,'Delayed until 2050', 'VerticalAlignment','top');

subplot(3,3,8)
y1_fig=(LowFertility.ff.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,(Basic.ff.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100,'-.','color','r','LineWidth',2);
hold on
plot(x_fig,0*ones(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min y_max])
% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
title('Panel c: Low Fertility')
x_text=2045;
i_x_text=x_text-x_fig(1)+1;
y1_text=y1_fig(i_x_text+40);
text(x_text,y1_text,'Fully Funded', 'VerticalAlignment','bottom');

subplot(3,3,9)
y1_fig=(LowFertility.pg.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100;
plot(x_fig,y1_fig,'color','b','LineWidth',2);
hold on
plot(x_fig,(Basic.pg.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1))*100,'-.','color','r','LineWidth',2);
hold on
plot(x_fig,0*ones(1,t_fig),':','color','k','LineWidth',1);
axis([x_fig(1) x_fig(length(x_fig)) y_min ceil(max((LowFertility.pg.ev_p_coh(coh_fig_start:coh_fig_start+t_fig-1)))*100/10)*10])
% xlabel('T (time of retirement)')
% ylabel('Consumption equivalent gain/loss')
% title('low wage growth')
x_text=2027;
i_x_text=x_text-x_fig(1)+1;
y1_text=y1_fig(i_x_text)+2;
text(x_text,y1_text,'PAYGO', 'VerticalAlignment','bottom');

% 
[ax1,h1]=suplabel('Year of Retirement');
[ax2,h2]=suplabel('Consumption Equivalent Gain/Loss (in Percent)','y');

print( '-dpng', '-r300', ['Compare_LowGrowth_LowFertility_notitle.png']);
print( '-depsc2', ['Compare_LowGrowth_LowFertility_notitle.eps']);

mtit('\fontsize{12} Sensitivity Analysis: Welfare Gains by Cohorts Under Different Scenarios','xoff',0,'yoff',-0.01)
% mtit('Sensitivity analysis: welfare effects by cohorts under different scenarios')

print( '-dpng', '-r300', ['Compare_LowGrowth_LowFertility.png']);
print( '-depsc2', ['Compare_LowGrowth_LowFertility.eps']);


% suplabel_test

