% this is a main file for Song, Storesletten, Wang and Zilibotti 2014
% Sharing High Growth Across Generations
% run this matlab file would generate all the results and figures


%%  ---------------------------- 0. Overview -----------------------------
% there are three groups of folders
% in each folder, there is a main file that you can run to generate the
% results


%% ---------------------------- 1. Demography ------------------------
% /Demography........... are used to compute the demographic model

% --------- 1. /Demography1_MigrationProjection
% propose a simple model to project the
% rural-urban migration rate
cd Demography1_MigrationProjection
display('----------- Migration Projection ------------')
main;

% --------- 2. /Demography2_PopulationProjection
% compute the population from 2000 on,
% given the migration rates computed and stored in  /Demography1_MigrationProjection
cd ../Demography2_PopulationProjection
display('----------- Population Projection ------------')
main;

% ---------- 3. Demography3_LowFertility
% assume low fertility rates and calculate the alternative population
% dynamics
cd ../Demography3_LowFertility
display('----------- Population with Low Fertility ------------')
main;

% ---------- 4. Demography4_LowMigration
% assume low migration rate and compute the population dynamics
cd ../Demography4_LowMigration
display('----------- Population with Low Migration Rate ------------')
main;


%% ----------------------------- 2. Pension ------------------------------------
% /Demography........... are used to compute the pension  models
% ----------- 1. /Pension1_BaselineScenario
% baseline scenario
cd ../Pension1_BaselineScenario
display('----------- Pension System: Baseline Scenario ------------')
main;

% ----------- 2. /Pension2_LowFertility
% low fertility
cd ../Pension2_LowFertility
display('----------- Pension System: Low Fertility ------------')
main;

% ----------- 3. /Pension3_HighInterest
% high interest
cd ../Pension3_HighInterest
display('----------- Pension System: High Interest Rate ------------')
main;

% ---------- 4. /Pension4_LowWageGrowth
% low wage growth 2% forever
cd ../Pension4_LowWageGrowth
display('----------- Pension System: Low Wage Growth ------------')
main;

% ---------- 5. /Pension5_LowBeta
% low beta (discount)
cd ../Pension5_LowBeta
display('----------- Pension System: Low Discounting ------------')
main;

% ---------- 6. /Pension6_FinancialLiberalization
% financial liberalization (relaxation of E firm constraint)
cd ../Pension6_FinancialLiberalization
display('----------- Pension System: Financial Liberaliation ------------')
main;

% ---------- 7. /Pension7_SlowConvergence
% slow convergence to the same steady state level of wage as in the basline
% scenario
cd ../Pension7_SlowConvergence
display('----------- Pension System: Slower Wage Convergence ------------')
main;

% ---------- 8. /Pension8_LowMigration
% if the migration rate is low (around 55% of the rate in the baseline scenario)
cd ../Pension8_LowMigration
display('----------- Pension System: Low Migration Rate ------------')
main;

% ---------- 9. /Pension9_TwoTierSystem
% suppose that the second pillar (individual account) is not empty 
cd ../Pension9_TwoTierSystem
display('----------- Pension System: Two Tier System ------------')
main;


% ---------- 10. /Pension10_Retire57
% suppose that the retierment age is 57 instead of 60
cd ../Pension10_Retire57
display('----------- Pension System: Retirement Age 57 ------------')
main;

% ---------- 11. /Pension11_PerfectForesight
% if agents expect all the reforms (delayed reform, fully funded reform,
% etc..) already in 2000 instead of being shocked in 2013
cd ../Pension11_PerfectForesight
display('----------- Pension System: Perfect Foresight ------------')
main;



%% ---------------------------- 3. Results ------------------------------------
% generate the graphs and numbers in the paper
cd ../Results
main;

